<?php session_name('iAdmin'); session_start();
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");
header("Content-type: text/plain; charset=utf-8");

include("../lib/ado/adodb.inc.php");
include("../lib/generic.inc.php");
include("ishop_all.inc.php");
include("ishop.inc.php");

// www.json.org
$c1=new cJSON();
ob_start();

$db=false;
do {
   $db = &db_open(false);
   if (!$db) {
	  $c1->error="Database connection failed! ".$db->ErrorMsg();
	  $db=false;
	  break;
	}

   $x2=new cX2($db);
   $fu=(int)@$_REQUEST['FUNCTION'];

   // short_login() needs RESELID (only)
	if ( !$x2->short_login() && !$x2->validate_session() ) {
		$c1->error="Authentication error!";
	   break;
   }
   
   // this must be done after $x2 initialization is fully completed
   include('ishop_tax.inc.php');

   switch ($fu)
   {
   case 1:
      eafdss_list();
      break;
   case 2:
      eafdss_info();
      break;
   case 3:
      upd_machine_type();
      break;
   default:
      $c1->error="Undefined function (#$fu) error!";
      break;
   }
   
} while (false);

if ($db!==false)
   $db->Close();

if (!empty($_REQUEST['V'])) {
   ob_end_flush();
}
else { 
   ob_end_clean();
}
echo $c1->print_self();

//--------------------------------------
// Functions
//--------------------------------------
function mysort($a,$b)
{
   if ($a['TXLOCATION'] < $b['TXLOCATION']) {
      return -1;
   }
   else if ($a['TXLOCATION'] > $b['TXLOCATION']) {
      return 1;
   }
   else if ($a['MS11'] < $b['MS11']) {
      return -1;
   }
   else if ($a['MS11'] > $b['MS11']) {
      return 1;
   }
   else {
      return 0;
   } 
}
//--------------------------------------
function eafdss_list()
{
   global $c1, $x2, $ar3;
   $db=&$x2->db;
   
   $s11=array();
   $query="SELECT MS11, MAX(LASTUPDATE) LUPD FROM taxi_log WHERE AGENTID=? AND RECTYPE<>3  
		GROUP BY MS11
      ORDER BY MS11"; 
   $data=array($x2->agentid);
   if (!($rs=$db->Execute($query,$data))) {
		$c1->error = __LINE__.$db->ErrorMsg();
		return;
	}
   while ($o1=$rs->FetchNextObject()) {
      $s11[]=$o1;
   }
   $rs->Close();
   
   $query="SELECT T1.MS11, T1.FIRSTSIGNINZ, T1.LASTZTAKEN, T1.LASTZNR, T1.MDAILY, 
      T1.MLASTHARDST, T1.MLASTAPPST, T1.LASTUPDATE, T2.ENABLED, T2.MACHINETYPE, T2.TXLOCATION FROM taxi_log T1
      LEFT JOIN taxi_eafdss T2 ON (T2.MS11=T1.MS11) 
      WHERE T1.AGENTID=? AND T1.MS11=? AND T1.LASTUPDATE>=?";
   foreach ($s11 as $om) {
      $data=array($x2->agentid, ToUtf8($om->MS11), $om->LUPD);
      if (($rs=$db->Execute($query,$data))===false) {
         $c1->error = __LINE__.$db->ErrorMsg();
         return;
      }
      if ($o1=$rs->FetchNextObject()) {
         $rsx=new cTXCERROR($o1);
         $ar1=array(
            'TXLOCATION' => $o1->TXLOCATION,                  
            'MS11' => $o1->MS11,
            'ENABLED' => $o1->ENABLED,
            'MACHINETYPE' => $o1->MACHINETYPE, 
            'STATUS' => $rsx->Get()   
            );
         $c1->rows[] = $db->verify_8( $ar1 );
      }
      $rs->Close();
   }
   
   usort($c1->rows, 'mysort');
}
//--------------------------------------
function eafdss_info()
{
   global $c1,$x2;
   $db=&$x2->db;
   
   $query="SELECT MAX(LASTUPDATE) FROM taxi_log WHERE AGENTID=? AND MS11=?";
   $data=array($x2->agentid, $_SESSION['MS11']);
   if (($rs=$db->Execute($query,$data))===false) {
      $c1->error = __LINE__.$db->ErrorMsg();
      return;
   }
   $row=$rs->FetchRow();
   $rs->Close();
   if ($row===false) {
      $c1->error = "No data";
      return;
   }
   $mLU=$row[0];
   
   $query="SELECT T1.*, T2.L_PROCID, T2.L_NPROC, T2.L_OS, T2.L_ARCH, T2.MACHINETYPE, T2.TXLOCATION FROM taxi_log T1 
      LEFT JOIN taxi_eafdss T2 ON (T2.AGENTID=T1.AGENTID AND T2.MS11=T1.MS11)
      WHERE T1.AGENTID=? AND T1.MS11=? AND T1.LASTUPDATE>=?";
   $data=array($x2->agentid, $_SESSION['MS11'], $mLU);
   if (($rs=$db->Execute($query,$data))===false) {
      $c1->error = __LINE__.$db->ErrorMsg();
      return;
   }
   if ($o1=$rs->FetchNextObject()) {
      $ar1=(array)$o1;
      $c1->rows[] = $db->verify_8( $ar1 );
   }
   $rs->Close();
}
//--------------------------------------
function upd_machine_type()
{
   global $c1,$x2;
   $db=&$x2->db;
   
   if (empty($_REQUEST["LTR"]) || strlen($_REQUEST["LTR"])<2) {
      $c1->error = "Too few characters for machine name!";
      return;
   }
   
   /*
   $l=strlen($_REQUEST["LTR"]);
   for ($i=0;$i<$l;$i++) {
      $c=ord($_REQUEST["LTR"]{$i});
      if ($c<33 || $c>127) {
         $c1->error = "Incorrect characters in machine name!"; 
         return;   
      }
   }
   */ 
   
   $query="UPDATE taxi_eafdss SET MACHINETYPE=? WHERE MS11 LIKE ? AND AGENTID=? AND MACHINETYPE=0";
   $data=array( (int)$_REQUEST['MACHINETYPE'], $_REQUEST['LTR'].'%', $x2->agentid );
   if (!$db->Execute($query,$data)) {
      $c1->error = __LINE__.$db->ErrorMsg();
      return;
   }
   $c1->rows[] = array('Result'=>'OK');
}
//--------------------------------------
?>   