<?php
// 
// Code for tables generation             
//
//------------------------------------------------------------------------------
function set_newdata(&$db,$o1,$newdata) // called from convert_agent_main()
{
   $t1="agent_main";
   $query2="DELETE FROM $t1 WHERE AGENTID=? AND PNAME=?";
   $data=array($o1->AGENTID, $o1->PNAME);
   if (!$db->Execute($query2,$data)) {
      echo "<h6>".$db->ErrorMsg()."</h6>\n";
      return false;
   }
   else {
      $query2="INSERT INTO $t1 (AGENTID,PNAME,PVALUE) VALUES(?, ?, ?)";
      $data=array($o1->AGENTID, $o1->PNAME, $newdata);
      if ($db->Execute($query2,$data))
         return true; // SUCCESS
      else {
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
         return false;
      }
   }
}
//------------------------------------------------------------------------------
function convert_agent_main($db)
{
   echo "<h6>Converting [agent_main]</h6>\n";

   $t1="agent_main";
   $query="SELECT AGENTID, PNAME, COUNT(PVALUE) F1 FROM $t1 ".
      " GROUP BY AGENTID,PNAME";
   if ($rs=$db->Execute($query)) {
      while ($o1=$rs->FetchNextObject()) {
         if ((int)$o1->F1==1)
            continue;

         if ($o1->PNAME=="CARD" /* || $o1->PNAME=="B2BCARD" */ ) { // B2BCARD deprecated
            $newdata="";
            $query2="SELECT PVALUE FROM $t1 WHERE AGENTID=? AND PNAME=?";
            $data=array($o1->AGENTID, $o1->PNAME);
            if ($rs2=$db->Execute($query2,$data)) {
               while ($o2=$rs2->FetchNextObject()) {
                  if (!empty($newdata)) $newdata.=' ';
                  $newdata.=$o2->PVALUE;
               }
               $rs2->Close();

               set_newdata($db,$o1,$newdata);
            }
            else {
               echo "<h6>".$db->ErrorMsg()."</h6>\n";
            }
         }
         else {
            $newdata="";
            $query2="SELECT PVALUE FROM $t1 WHERE AGENTID=? AND PNAME=?";
            $data=array($o1->AGENTID, $o1->PNAME);
            if ($rs2=$db->Execute($query2,$data)) {
               if ($o2=$rs2->FetchNextObject()) {
                  $newdata=$o2->PVALUE;
               }
               $rs2->Close();

               set_newdata($db,$o1,$newdata);
            }
            else {
               echo "<h6>".$db->ErrorMsg()."</h6>\n";
            }
         }
      }
      $rs->Close();

      $query="ALTER TABLE $t1 ADD PRIMARY KEY (AGENTID,PNAME)";
      if (!$db->Execute($query)) {
         table_terminate($db,$t1,$query);
         return false;
      }

      $query="ALTER TABLE $t1 DROP INDEX prname";
      if (!$db->Execute($query)) {
         table_terminate($db,$t1,$query);
         return false;
      }
   }
   else {
      table_terminate($db,$t1,$query);
      return false;
   }
   
   return true;
}
//------------------------------------------------------------------------------
function reset_lines(&$db) // called from check_tables
{
   echo "<-- Calling reset_lines() -->\n";

	$t1='order_main';
	$query="SELECT ORDERID, LOGTIME FROM ".$t1;
	if (($rs=$db->Execute($query))===false) {
		table_terminate($db,$t1,$query);
      return false;
	}
	$t1='order_line';
	while ($o1=$rs->FetchNextObject()) {
		$query="UPDATE $t1 SET EXECDAYTI=? WHERE ORDERID=? AND STATE=1";
		$data=array($o1->LOGTIME, $o1->ORDERID);
		if (!$db->Execute($query,$data)) {
			table_terminate($db,$t1,$query);
			return false;
		}

		$query="UPDATE $t1 SET ISSUEDAYTI=? WHERE ORDERID=? AND PRINTED=1";
		$data=array($o1->LOGTIME, $o1->ORDERID);
		if (!$db->Execute($query,$data)) {
			table_terminate($db,$t1,$query);
			return false;
		}
	}
	$rs->Close();
	
	return true;
}
//--------------------------------------
function convert_gmap($db,$t1)
{
   $t2=$t1.'_0'; // Old file name

   $query="SELECT AGENTID, LOGIN, GMAP FROM $t2 WHERE GMAP IS NOT NULL AND LENGTH(GMAP)>0";
   if (($rs=$db->Execute($query))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   $nok=0;
   while ($o1=$rs->FetchNExtObject()) {
      $ar1=explode(':',$o1->GMAP);
      if (count($ar1)!=3)
         continue;

      $query="UPDATE $t1 SET GMAPLAT=?, GMAPLNG=?, GMAPZOOM=? WHERE AGENTID=? AND LOGIN=?";
      $data=array( (float)$ar1[0], (float)$ar1[1], (int)$ar1[2], $o1->AGENTID, $o1->LOGIN );
      if (!$db->Execute($query,$data)) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         break;
      }
      else {
         $nok++;
      }
   }
   $rs->Close();

   return $nok;
}
//--------------------------------------
function convert_maproutept(&$db)
{
   $ret=true;
   
   $t1='ishop_mprpoint';
   
   $qsub="SELECT MAX(MPAA) FROM $t1 WHERE MPROUTEID=?";
   
   $db->StartTrans();
   
   $mpid = -1;
   $query="SELECT T1.*, T2.MPLATITUDE, T2.MPLONGITUDE, T2.MPNAME, T2.MPDESC FROM ishop_maproutept T1
      LEFT JOIN ishop_mappoint T2 ON (T2.MPID=T1.MPID) 
      ORDER BY MPID";
   $data=false;
   if (($rs=$db->Execute($query))===false) {        
      echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>";
      $db->CompleteTrans();
      return false;
   }
   while ($o1=$rs->FetchNextObject()) {
      $max=0;
      $data=array($o1->MPROUTEID);
      if (($rs2=$db->Execute($qsub,$data))===false) {
         echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>";
         $ret=false;
         break;
      }
      if ($row=$rs2->FetchRow()) {
         $max=(int)$row[0];
      }
      $rs2->Close();
      
      $data=array(
         'AGENTID'=>$o1->AGENTID,
         'MPROUTEID'=>$o1->MPROUTEID,
         'MPAA'=>$max+1,
         'MPLATITUDE'=>$o1->MPLATITUDE,
         'MPLONGITUDE'=>$o1->MPLONGITUDE,
         'MPNAME'=>$o1->MPNAME,
         'MPDESC'=>$o1->MPDESC
         );  
      if (!InsertEx($db,$t1,$data)) {
         echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>";
         $ret=false;
         break; 
      }
      
      // save last value
      $mpid=$o1->MPID;     
   }
   $rs->Close();
   
   $db->CompleteTrans();
   
   return $ret;
}   
//--------------------------------------
function pre_process_mbr($db,$t1)
{
   if (($m1=$db->MetaPrimaryKeys($t1))===false)
      return false; // Table does not exist yet

   if(!in_array('XID',$m1)) {
      $t2=$t1.'_0';
      $query="ALTER TABLE $t1 RENAME $t2";
      if (!$db->Execute($query)) {
			table_terminate($db,$t1,$query);
			return false;
		}

      return true;
   }
   else {
      return false;
   }
}
//--------------------------------------
function drop_all_indexes(&$db,$t1)
// Drop all indexes, but PRIMARY KEY
{
	$keys=array();
	$query="SHOW INDEX FROM $t1";
	if (($rs=$db->Execute($query))===false) {
		table_terminate($db,$t1,$query);
		return false;
	}
	while ($o1=$rs->FetchNextObject()) {
		if ($o1->KEY_NAME=='PRIMARY')
			continue;

		if (!in_array($o1->KEY_NAME,$keys))
			$keys[]=$o1->KEY_NAME;
	}
	$rs->Close();

	foreach ($keys as $k1) {
	   $query="ALTER TABLE $t1 DROP INDEX $k1";
   	if (!$db->Execute($query)) {
      	table_terminate($db,$t1,$query);
      	return false;
      }
 	}
 	
 	return true;
}
//--------------------------------------
function meta_process_mbr($db,$t1)
{
   $newFields=$db->MetaColumnNames($t1,$numericIndex=true);
   $t2=$t1.'_0';
   $oldFields=$db->MetaColumnNames($t2,$numericIndex=true);

   $mvf=array();
   foreach ($oldFields as $of1) {
      if (in_array($of1,$newFields))
         $mvf[]=$of1;
   }
   $query="INSERT INTO $t1 (".implode(',',$mvf).") SELECT ".implode(',',$mvf)." FROM $t2";
   if (!$db->Execute($query)) {
      echo "<h6>".$db->ErrorMsg()."</h6>\n";
      return false;
   }

   convert_gmap($db,$t1);

   $query="DROP TABLE $t2";
   if (!$db->Execute($query)) {
      table_terminate($db,$t1,$query);
      return false;
   }
   else
      return true;
}
//--------------------------------------
function check_dimension(&$db,$t1,$flds)
// flds holds pairs of fields name in UPPERCASE, NUMERIC length
{
   if ($db->databaseType!='mysqlt')
      return;
      
	$query="DESCRIBE $t1";
	if (($rs=$db->Execute($query))===false) {
      table_terminate($db,$t1,$query);
      return false;
   }
   $afs=array();
   while ($o1=$rs->FetchNextObject()) {
		$ucs=strtoupper($o1->FIELD);
		if (array_key_exists( $ucs, $flds )) {
			$ar1=explode(',',$o1->TYPE);
         $dec=(int)$ar1[1];
         if ($dec<$flds[$ucs]) {
            $afs[]=$ucs;
         }
		}
   }
   $rs->Close();

   foreach ($afs as $f1) {
		$d2=$flds[$f1];
      $query="ALTER TABLE $t1 MODIFY $f1 NUMERIC(15,$d2)";
      if (!$db->Execute($query)) {
         table_terminate($db,$t1,$query);
         return false;
      }
      else
      	echo "<h6>Did change dimensions for $t1, $f1 to $d2</h6>";
   }
   
   return true;
}
//--------------------------------------
function check_for_nulldate(&$db,$t1,$fields)
{
   if ($db->databaseType==='mysqlt') {
      $query="DESCRIBE $t1";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
         return false;
      }
      while ($o1=$rs->FetchNextObject()) {
         if (in_array($o1->FIELD, $fields)) {
            if ($o1->NULL!='YES') {
               $query="ALTER TABLE $t1 MODIFY ".$o1->FIELD." DATETIME";
               if (!$db->Execute($query)) {
                  table_terminate($db,$t1,$query);
                  return false;
               }
               else {
                  echo "<h6>Did set ${t1}.".$o1->FIELD." as DATETIME, NULLABLE</h6>";
               }
            }
         }
      }
      $rs->Close();
   }
   else { // ado_mssql, mssql
      $query="EXEC sp_columns @table_name = '$t1' ";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
         return false;
      }
      while ($o1=$rs->FetchNextObject()) {
         if (in_array($o1->COLUMN_NAME, $fields)) {
            if ($o1->NULLABLE==0) {
               $query="ALTER TABLE $t1 ALTER COLUMN ".$o1->COLUMN_NAME." DATETIME";
               if (!$db->Execute($query)) {
                  table_terminate($db,$t1,$query);
                  return false;
               }
            }
         }
      }
      $rs->Close();
   }
   
   return true;
}
//--------------------------------------
function check_nulls(&$db)
{
   if ($db->databaseType!='mysqlt') {
      echo "<h6>Operation supported only for mysql-T</h6>";
      return;
   }
   
   $types=array('int', 'tinyint', 'double', 'decimal');

   $tables=$db->MetaTables();
   // Convert all to lower case
   array_walk($tables,'array_toLower');

   foreach ($tables as $t1) {
      $t1_printed=false;
      $query="DESCRIBE ".$t1;
      $rs=$db->Execute($query);
      if ($rs===false) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         continue;
      }
      while ($o1=$rs->FetchNextObject()) {
         if ($o1->NULL=='YES')
            continue;
            
         if (@$o1->EXTRA=='auto_increment' || $o1->TYPE=='text')
            continue;

         if (!is_null($o1->DEFAULT)) 
            continue;

         if (!$t1_printed) {
            echo "$t1 ";
            $t1_printed=true;
         }

         echo "<pre>";
         var_dump($o1);
         echo "</pre>";
            
         $ar1=explode('(',$o1->TYPE);
         if (in_array($ar1[0],$types)) {
            $query="ALTER TABLE $t1 ALTER COLUMN ".$o1->FIELD." SET DEFAULT 0";
            if (!$db->Execute($query))
               echo "<h6>$query: ".$db->ErrorMsg()."</h6>";
         }
         else if ($ar1[0]=='varchar') {
            $query="ALTER TABLE $t1 ALTER COLUMN ".$o1->FIELD." SET DEFAULT '' ";
            if (!$db->Execute($query))
               echo "<h6>$query: ".$db->ErrorMsg()."</h6>";
         }
         else {
            echo "<h6>Can not alter</h6>";
         }
      }
      $rs->Close();
   }
}
//--------------------------------------
/*
   The FLOAT and DOUBLE data types are used to represent approximate numeric 
   data values.
    
   The DECIMAL and NUMERIC data types are used to store exact numeric data 
   values. In MySQL, NUMERIC is implemented as DECIMAL. These types are used 
   to store values for which it is important to preserve exact precision, 
   for example with monetary data.
*/
//--------------------------------------
function check_tables(&$db)
{
   //
   // 10-7-2007: added support for MS-SQL
   //

   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   if (!is_array($tables)) {
      $tables=array();
   }
   // Convert all to lower case
   array_walk($tables,'array_toLower');

   //......................................
   // Check greek characters
   $t1='ishop_test';
   $query="CREATE TABLE $t1 ( ".
      	"PNAME      NVARCHAR(20) NOT NULL, ".
         "PRIMARY KEY (PNAME)) ";
   process_meta($db,$tables,$t1,$query);
   do {
      $query="DELETE FROM $t1";
      if (!$db->Execute($query)) {
         echo __LINE__.$db->ErrorMsg();
         break;
      }
      
      $a1='αβγδεζηθικλμνξοπρστυφχψω';
      
      $query="INSERT INTO $t1 (PNAME) VALUES(?)";
      for ($i=0;$i<mb_strlen($a1);$i++) {
         $data=array( mb_substr($a1,$i,1) );
         if (!$db->Execute($query,$data)) {
            echo __LINE__.$db->ErrorMsg();
         }
      }
      $query="SELECT PNAME FROM $t1 ORDER BY PNAME";
      if (($rs=$db->Execute($query))===false) {
         echo __LINE__.$db->ErrorMsg();
      }
      else {
         $a2='';
         while ($row=$rs->FetchRow()) {
            $a2 .= $db->verify_8($row[0]);
         }
         $rs->Close();
         
         if ($a2===$a1) {
            echo "<h4 style=\"color:green\">Greek collation found o.k.</h4>";
         }
         else {
            echo "<h6 style=\"color:red\">Error testing Greek: ".myhtml($a2)."</h6>";
         }
      }
   } while (false);
   //......................................
   $t1='agents';
  	$query="CREATE TABLE $t1 (
      	AGENTID    INT NOT NULL,
		   LPATH      VARCHAR(64) NOT NULL,
         PASSWD     VARCHAR(20) NOT NULL,
         ISADMIN    SMALLINT NOT NULL,
         UNITS      VARCHAR(200) NOT NULL DEFAULT '',
         LASTUPDATE TIMESTAMP,
		   PRIMARY KEY(AGENTID),
         UNIQUE (LPATH) )
         ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   // revision 6-9-2205
   $query="SELECT COUNT(*) FROM $t1";
   if ($rs=$db->Execute($query)) {
		$row=$rs->FetchRow();
   	$rs->Close();

		if ($row===false || (int)$row[0]==0) {
			$query="INSERT INTO $t1 (AGENTID, LPATH, PASSWD, ISADMIN) VALUES(?,?,?,?)";
			$data=array(0, 'root', 'delta', 1000);
			if (!$db->Execute($query,$data)) {
				table_terminate($db,$t1,$query);
			}
			else
				echo "<h4>Created super user [root] with password [delta].</h4>\n";
		}
      else {
         echo "<h6>Found some Administrator!</h6>";
      }
	}
	else {
		table_terminate($db,$t1,$query);
	}
   //......................................
   $t1='agent_main';
  	$query="CREATE TABLE $t1 (
      AGENTID INT NOT NULL,
      PNAME VARCHAR(64) NOT NULL,
      PVALUE VARCHAR(255),
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY(AGENTID,PNAME))
      ENGINE=InnoDb ";
   // revision 23-9-2004
   $mi1=$db->MetaPrimaryKeys($t1);
   if ($mi1!==false && count($mi1)==1) {
      convert_agent_main($db);
   }
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='agent_pref';
  	$query="CREATE TABLE $t1 (
      AGENTID INT NOT NULL,
      PGROUP VARCHAR(64) NOT NULL,
      PNAME VARCHAR(100) NOT NULL,
      PVALUE VARCHAR(255),
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY(AGENTID,PGROUP,PNAME))
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='reseller'; // Πωλητές=Χειριστές συσκευών
  	$query="CREATE TABLE $t1 (
      RESELID     INT NOT NULL AUTO_INCREMENT,
      PASSWD      VARCHAR(20) NOT NULL,
      AGENTID     INT NOT NULL,
      RE_CTG      VARCHAR(50) DEFAULT 'SALES',
      RE_GROUP    INT NOT NULL, -- menurep.MENUID (MENUTYPE=8)
      RE_BARCODE  VARCHAR(100) NOT NULL,
      RE_NAME     VARCHAR(100) NOT NULL,
      RE_PHONE    VARCHAR(100),
      RE_EMAIL    VARCHAR(100),
      RE_COMMENTS VARCHAR(100),
      WAREHOUSEID INT NOT NULL, -- menurep.MENUID (MENUTYPE=1)
      DEVICEID    INT NOT NULL, -- device.DEVICEID
      PRIMARY KEY (RESELID),
      UNIQUE (AGENTID,RESELID))
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='resel_main';
   if(in_array($t1,$tables)) {
   	$query="DROP TABLE $t1";
      if ($db->Execute($query))
         echo "<h6>Dropped table $t1</h6>";
      else
         table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='ishop_reselday';
   $query="CREATE TABLE $t1 (
      RESELID INT NOT NULL,
      AGENTID INT NOT NULL, -- just for info
      LOGTIME DATETIME NOT NULL,
      RINOUT SMALLINT NOT NULL, -- 0/1=in/out
      PRIMARY KEY (RESELID, LOGTIME))
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Preferences για τον πωλητή
   $t1='reselpref';
   $query="CREATE TABLE $t1 ( ".
         "RESELID INT NOT NULL, ".
         "PNAME VARCHAR(64) NOT NULL, ".
         "PVALUE VARCHAR(255) NOT NULL, ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (RESELID,PNAME) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   // Extented preferences για τον πωλητή.
	// Το πεδίο AGENTID συμπεριλαμβάνεται, γιατι με RESELID=0 αναφερόμαστε στον agent.
   $t1='reselprefex';
   $query="CREATE TABLE $t1 (
      AGENTID  INT NOT NULL,
      RESELID  INT NOT NULL,
      PGROUP   VARCHAR(100) NOT NULL,
      PNAME    VARCHAR(100) NOT NULL,
      PVALUE   VARCHAR(255) NOT NULL,
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (AGENTID, RESELID, PGROUP, PNAME) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Menu grouping (MENUTYPE):
   // 1 = Warehouse
   // 2 = Bank names
   // 3 = Τιμοκατάλογοι
   // 4 = Σκοποί αποστολής
   // 5 = Κατηγορίες εξόδων (εξοδολόγιο)
   // 6 = Τρόποι παράδοσης
   // 7 = Τρόποι πληρωμής (χονδρική)
   // 8 = Ομάδες πωλητών
   // 9 = Τρόποι πληρωμής (λιανική/POS)
   // 10 = Εξωτερικά παραστατικά (πχ. Filoxenia)
   // 11 = Τροποι πληρωμής (λιανική/CART)
   // 12 = Ομάδες χρηστών (τηλεφώνων)
   // 13 = Ετοιμα σχολια είδους (παραγγελίας) (MENUID=1,2,3,...)
   // 14 = Τοποθεσιες εκτύπωσης εκτέλεσης (MENUID=2,3,4,...)
   // 15 = Αποστολέας SMS
   // 16 = Ωράρια κράτησης (σε ώρες 00...23), βάσει MENUID
   // 17 = Διαστήματα κράτησης σε ώρες, βάσει MENUID
   // 18 = Ονομασίες event
   // 19 = Οναμασίες ishop_paygroup.PAYGRP
   // 20 = Τυπος υπολογαριασμού (πχ. g11cat)
   // 21 = Τυπος ημερολογίου (g11typ1)
   $t1='menurep'; // menu repository
  	$query="CREATE TABLE $t1 (
   	AGENTID    INT NOT NULL,
   	MENUTYPE   INT NOT NULL, -- Grouping (see above)
   	MENUID     INT NOT NULL,
   	MENUDES    VARCHAR(100),
   	LASTUPDATE TIMESTAMP,
   	PRIMARY KEY (AGENTID,MENUTYPE,MENUID))
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'MENUTYPE', 'MENUDES')
      );
   add_index($db,$t1,$idx);
   // revision 3-4-2004
   // Returns an array containing column names that are the primary keys
   $mi1=$db->MetaPrimaryKeys($t1);
   if ($mi1!==false && count($mi1)==1) { // one field
      $query="ALTER TABLE $t1 DROP PRIMARY KEY";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="ALTER TABLE $t1 ADD PRIMARY KEY (AGENTID,MENUTYPE,MENUID)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='session';
   $query="CREATE TABLE $t1 ( ".
      	"SESSIONID INT NOT NULL, ".
         "DELTA      VARCHAR(100) NOT NULL, ".
         "CREDAYTIME DATETIME NOT NULL, ".
			"LASTUSAGE  DATETIME NOT NULL, ".
      	"SE_COMMENTS VARCHAR(100) NOT NULL, ".
      	"APPLI VARCHAR(40), ".
         "PRIMARY KEY (SESSIONID)) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='session_data';
 	$query="CREATE TABLE $t1 ( ".
      	"SESSIONID INT NOT NULL, ".
         "PNAME VARCHAR(64) NOT NULL, ".
         "PVALUE VARCHAR(255) NOT NULL, ".
         "PRIMARY KEY (SESSIONID,PNAME)) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_session_ctl';
   $query="CREATE TABLE $t1 (".
         "APPLI   VARCHAR(40) NOT NULL, ".
         "AGENTID INT NOT NULL, ".
         "ULOGIN  VARCHAR(40) NOT NULL, ". // RESELID (OLD: or AGENTID#RESELID)
         "SESSID  VARCHAR(140) NOT NULL, ".
         "SEDATA  MEDIUMTEXT, ".
         "LASTUSAGE INT NOT NULL, ". // result of time()
         "PRIMARY KEY (APPLI, SESSID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_sms_unit';
   $query="CREATE TABLE $t1 (
      UID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      INVOICENR   VARCHAR(20),
      INVDATE     DATETIME,
      INVUNITS    INT NOT NULL,
      UNITSLEFT   INT NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (UID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'UID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_sms_text';
   $query="CREATE TABLE $t1 (
      TXTID       INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      SMSTEXT     VARCHAR(480) NOT NULL, -- max 3 X 160
      CREDAYTIME  DATETIME,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (TXTID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'SMSTEXT')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_sms_msg';
   $query="CREATE TABLE $t1 (
      SMSID       INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      TXTID       INT NOT NULL, -- ishop_sms_text.TXTID
      SMSTO       VARCHAR(40), -- Well formatted recipient number (ishop_tel.TELNR)
      SMSFROM     VARCHAR(40), -- Sender number (or 11 char. for CLICKATELL)
      SMSTEXT     VARCHAR(480) NOT NULL, -- max 3 X 160
      ISUNICODE   TINYINT NOT NULL,
      MSGPARTS    TINYINT NOT NULL DEFAULT 1, -- 1/2/3      
      CREDAYTIME  DATETIME,
      OPERID      VARCHAR(100) NOT NULL, -- Operator message Id
      OPERROR     VARCHAR(80), -- Operator error description (if any) while queing msg.
      OPSTATUS    VARCHAR(40), -- Operator last status report
      OPDAYTIME   TIMESTAMP, -- Operator (last status) datetime
      OPCHARGE    NUMERIC(10,2), -- Operator charge units
      OPFROM      VARCHAR(20), -- Operator 'from' field applied to message
      PRIMARY KEY (SMSID),
      UNIQUE (OPERID, SMSID),
      UNIQUE (SMSTO, TXTID, SMSID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'CREDAYTIME', 'SMSID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_usage';
  	$query="CREATE TABLE $t1 (
   	TRID 		INT NOT NULL AUTO_INCREMENT,
   	AGENTID 	INT NOT NULL,
      PHP_SELF VARCHAR(200) NOT NULL,
      FUNCNR 	INT NOT NULL,
      BYTES 	INT NOT NULL,
		TRDATE 	DATETIME NOT NULL,
		ELAPSED	NUMERIC,
		DCCODE 	INT NOT NULL, -- 0/1=Ξοδεύει/κερδίζει μονάδες
		PRIMARY 	KEY(TRID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('TRDATE', 'TRID')
      );
   add_index($db,$t1,$idx);
   //......................................
   // language dictionary
   $t1='ishop_langdic';
	$query="CREATE TABLE $t1 (
      SHORTHAND VARCHAR(64) NOT NULL, 
		LANGID     SMALLINT NOT NULL, -- 0=Eng, 1=Gr, 2=Ger
		WLABEL     VARCHAR(200), -- php module that made the question
		PRIMARY KEY(SHORTHAND,LANGID) ) 
		ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Καταγραφικό ανεπιτυχών αιτήσεων
	$t1='ishop_lang';
	$query="CREATE TABLE $t1 (
      SHORTHAND   VARCHAR(64) NOT NULL, 
		PROGNAME    VARCHAR(255), -- php module that made the question
		LASTQUERY   DATETIME, -- τελ. ερώτηση (ημ/νία)
		PRIMARY KEY(SHORTHAND) ) 
		ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_langui';
   $query="LANGID INT NOT NULL, ".
   	"LANGDES VARCHAR(100), ".
   	"PRIMARY KEY(LANGID) ) ".
   	"ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   /*
   ***                   ***
   ***    hasp license   ***
   ***                   ***
   */
   $t1='hasp_lic';
   $query="CREATE TABLE $t1 (
      HASPID      VARCHAR(20) NOT NULL,
      CLICENSE 	MEDIUMTEXT,
      CUSTOMER    VARCHAR(200),
      RESELLER    VARCHAR(100),
      INVOICE     VARCHAR(100),
      COMMENTS    VARCHAR(200), 
      LASTEXPUPD  DATETIME, 
      PRIMARY KEY (HASPID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   
   //
   // Add FUNCTIONS for MS-SQL
   //
   do {
      if ($db->databaseType==='mysqlt')
         break;

      /*
         User-defined functions have to be called as username.function(...),
         so we must define a function with a different name, that will be called as dbo.function(...)
      */

      //......................................
      $t1='UNXTIMESTAMP';
      $row=false;
      $query="sp_help @objname='$t1' ";
      if (($rs=$db->Execute($query))!==false) {
         $row=$rs->FetchRow();
         $rs->Close();
      }
      // Error return is OK! It means the object does yet exist.
      if ($row!==false) {
         // Function already exists
         break;
      }

      $query="CREATE FUNCTION $t1(@dt1 datetime)
         RETURNS INT
         AS
         BEGIN
         DECLARE @uts INT
         SET @uts = CAST((CAST(@dt1 as FLOAT)-25567)*86400 AS INT)
         RETURN @uts
         END";
      if ($db->Execute($query))
         echo "<h6>Added function $t1</h6>";
      else
         table_terminate($db,$t1,$query);
   } while (false);

   do {
      if ($db->databaseType==='mysqlt')
         break;

      //......................................
      $t1='TIMEX';
      $row=false;
      $query="sp_help @objname='$t1' ";
      if (($rs=$db->Execute($query))!==false) {
         $row=$rs->FetchRow();
         $rs->Close();
      }
      // Error return is OK! It means the object does yet exist.
      if ($row!==false) {
         // Function already exists
         break;
      }

      $query="CREATE FUNCTION $t1(@dt1 datetime)
         RETURNS VARCHAR(8)
         AS
         BEGIN
         DECLARE @uts VARCHAR(8)
         SET @uts = RIGHT('0'+LTRIM(STR(DATEPART(hh, @dt1))),2) + ':' +
         	RIGHT('0'+LTRIM(STR(DATEPART(mi, @dt1))),2) + ':' +
         	RIGHT('0'+LTRIM(STR(DATEPART(ss, @dt1))),2)
         RETURN @uts
         END";
      if ($db->Execute($query))
         echo "<h6>Added function $t1</h6>";
      else
         table_terminate($db,$t1,$query);

   } while (false);
   
   echo "<!-- All files examined. Time elapsed=".$prof->elapsed()." -->";
}   
//--------------------------------------
function chk_tables_generic(&$db)
{
   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   if (!is_array($tables)) {
      $tables=array();
   }
   // Convert all to lower case
   array_walk($tables,'array_toLower');   
   
   //......................................
   $t1='issuedoc';
   $query="CREATE TABLE $t1 ( ".
   	"ISSUEID   INT NOT NULL AUTO_INCREMENT, ".
   	"AGENTID   INT NOT NULL, ".
   	"DOCID     INT NOT NULL DEFAULT 2, ". // 0, 1, 2, 3, 4 = order, Δ/Α, ΤΔΑ, Δ/Π, ΠΔΠ
   	"ISSUESEQ  CHAR(4) NOT NULL, ". // Σειρά (πχ. ΣΤ)
   	"ISSUENR   INT NOT NULL, ".
   	"ISSUEDES  VARCHAR(50) NOT NULL, ".
   	"ISSUELASTUSE DATETIME, ".
   	"SPECID    INT NOT NULL, ". // --> ishop_prspec.SPECID
   	"XDBRTYPE  VARCHAR(20), ". // external database transaction type, i.e. "39"
   	"XDBRDESC  VARCHAR(20), ". // external database transaction desc, i.e. "ΤΔΑ"
   	"XDBCATYP  VARCHAR(20), ". // external database cancel transaction type, i.e. "39"
   	"XDBCADES  VARCHAR(20), ". // external database cancel transaction desc, i.e. "ΤΔΑ"
   	"XDBMOTYP  VARCHAR(20), ". // external database money transaction type, i.e. "39"
   	"XDBMODES  VARCHAR(20), ". // external database money transaction desc, i.e. "ΤΔΑ"
   	"LASTUPDATE TIMESTAMP, ".
   	"PRIMARY KEY (ISSUEID) ) ".
   	"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   check_for_nulldate($db, $t1, array('ISSUELASTUSE') );
   //......................................
   $told='doctext';
   $t1='ishop_doctext';
   if (in_array($told,$tables) && !in_array($t1,$tables)) {
      $query="RENAME TABLE $told TO $t1";
      if (!$db->Execute($query)) {
         echo "<h6>$query error: ".$db->ErrorMsg()."</h6>";
      }
      else {
         echo "<h6>Did rename $told to $t1;</h6>";
         $tables[]=$t1;
      }
   }
   $query="CREATE TABLE $t1 ( ".
         "AGENTID 	INT NOT NULL, ". // just for precaution
         "RESELID		INT NOT NULL, ". // quick query
         "DOCTYPE		INT NOT NULL, ". // 0=invoicing, 1=ordering, 2=receipts
         "TEXTID  	INT NOT NULL AUTO_INCREMENT, ".
         "MBR_LOGIN  VARCHAR(20), ". // --> ishop_mbr
         "REFNO		VARCHAR(20), ".
         "DOCTEXT2 	MEDIUMTEXT, ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (TEXTID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   $mi1=$db->MetaPrimaryKeys($t1);
   // revision 6-10-2004
   if($mi1!==false && in_array('AGENTID',$mi1)) {
		$query="ALTER TABLE $t1 DROP PRIMARY KEY";
		if (!$db->Execute($query))
			table_terminate($db,$t1,$query);
	   $query="ALTER TABLE $t1 ADD PRIMARY KEY (TEXTID)";
	   if (!$db->Execute($query))
			table_terminate($db,$t1,$query);
	}
   //......................................
   // Ποιά έντυπα παίρνει ο πωλητής
   $t1='reseldoc';
   $query="CREATE TABLE $t1 ( ".
         "AGENTID INT NOT NULL, ".
         "RESELID INT NOT NULL, ".
         "ISSUEID INT NOT NULL, ". // <--> issuedoc.ISSUEID
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (AGENTID,RESELID,ISSUEID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Εξοδολόγιο πωλητή
   $t1='ishop_reselexp';
   $query="CREATE TABLE $t1 ( ".
         "EXPID INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID INT NOT NULL, ".   // quick info
         "RESELID INT NOT NULL, ".   // quick info
         "EXPCTG INT NOT NULL, ".    // <--> menurep.MENUID, MENUTYPE=5
         "EXPNAME VARCHAR(200), ".   // προμηθευτής
         "EXPDOC VARCHAR(30), ".     // παραστατικο (α/α)
         "EXPISSUE DATETIME NOT NULL, ".     // ημ/νία παραστατικού
         "EXPVALUE NUMERIC(15,4) NOT NULL, ". // αξία
         "EXPQUA NUMERIC(15,4) NOT NULL, ". // ποσότητα
         "EXPCOMMENTS VARCHAR(200), ".   // σχόλια
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (EXPID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'LASTUPDATE'),
      'k2'=>array('RESELID', 'LASTUPDATE')
      );
   add_index($db,$t1,$idx);
   //......................................
   $told='agent_ups';
   $t1='ishop_ups';
   if (in_array($told,$tables) && !in_array($t1,$tables)) {
      $query="RENAME TABLE $told TO $t1";
      if (!$db->Execute($query)) {
         echo "<h6>$query error: ".$db->ErrorMsg()."</h6>";
      }
      else {
         echo "<h6>Did rename $told to $t1;</h6>";
         $tables[]=$t1;
      }
   }
   $query="CREATE TABLE $t1 ( ".
         "UPSID INT NOT NULL AUTO_INCREMENT, ".
         "UPSNAME VARCHAR(40), ".
  	      "AGENTID INT NOT NULL, ".
  	      "PRIMARY KEY (UPSID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'UPSID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $told='agent_upsdest';
   $t1='ishop_upsdest';
   if (in_array($told,$tables) && !in_array($t1,$tables)) {
      $query="RENAME TABLE $told TO $t1";
      if (!$db->Execute($query)) {
         echo "<h6>$query error: ".$db->ErrorMsg()."</h6>";
      }
      else {
         echo "<h6>Did rename $told to $t1;</h6>";
         $tables[]=$t1;
      }
   }
   $query="CREATE TABLE $t1 ( ".
         "DESTID     INT NOT NULL AUTO_INCREMENT, ".
         "DESTNAME   VARCHAR(50), ".
  	      "AGENTID    INT NOT NULL, ".
     	   "UPSID      INT NOT NULL, ".
         "DESTBASE   NUMERIC (10,2), ".
         "DESTWEIGHT NUMERIC(10,2), ".
         "DESTVOLUME NUMERIC(10,2), ".
         "DESTMIN    NUMERIC(10,2), ".
         "GMAPRECT   TEXT,".
         "PRIMARY KEY (DESTID) ) ".
   	   "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'UPSID', 'DESTID')
      );
   add_index($db,$t1,$idx);
   //......................................
   // OMADA:
   // 0 = Απογραφή
   // 1 = Εισαγωγή
   // 2 = Εξαγαωγή
   // 3 = Εισαγωγή ενδοδιακίνηση
   // 4 = Εξαγωγή ενδοδιακίνηση
   $t1='ishop_extern_doc';
   $query="CREATE TABLE $t1 (
      EXID        INT NOT NULL AUTO_INCREMENT,
      XDBID       INT NOT NULL,
      AGENTID     INT NOT NULL,
      OMADA       INT NOT NULL, 
      CAT_NUM     INT,
      TRS_NUM     INT,
      DESCR       VARCHAR(100),
      XTYPE       INT NOT NULL,
      CAT         INT NOT NULL,
      PRIMARY KEY (EXID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_bonus_main';
   $query="CREATE TABLE $t1 (
      AGENTID    INT NOT NULL,
      BONUSID    INT NOT NULL,
      OFRNAME    VARCHAR(50),  -- offer name
      OFRTYPE    INT NOT NULL, -- 0/1=value type, quantity type (invoice qunatity for higher values) 
      CREDATE    DATETIME NOT NULL,
      DATEFROM   DATETIME NOT NULL,
      DATETO     DATETIME NOT NULL,
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (AGENTID, BONUSID) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_bonus_line';
   $query="CREATE TABLE $t1 (
      AGENTID    INT NOT NULL,
      BONUSID    INT NOT NULL,
      BONUSLINE  INT NOT NULL,
      ICODE      VARCHAR(20) NOT NULL,    -- filter
      ISUBCODE   VARCHAR(20) NOT NULL,    -- filter
      PAGENO     VARCHAR(150) NOT NULL,   -- filter (many, delimited)
      PRICE      NUMERIC(15,4) NOT NULL,  -- filter            
      QUANTITY   INT NOT NULL,
      QINVOICED  INT NOT NULL,
      TVALUE     NUMERIC(15,4),
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (AGENTID, BONUSID, BONUSLINE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_offer_main'; // SYFA
   $query="CREATE TABLE $t1 (
      OFFERID    INT NOT NULL AUTO_INCREMENT,
      AGENTID    INT NOT NULL,
      OFNAME     VARCHAR(50),
      TRKEY		  VARCHAR(65),
      CREDATE    DATETIME NOT NULL,
      DATEFROM   DATETIME NOT NULL,
      DATETO     DATETIME NOT NULL,
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (OFFERID) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_offer_grp';
   $query="CREATE TABLE $t1 (
      OFFERID    INT NOT NULL,
      OFRGRP     INT NOT NULL,
      RTYPE      INT NOT NULL, /* 0=of total quantity, 1=of total value, 10=gift qua, 11=gift value */
      OPERAT     CHAR(2) NOT NULL,
      TQUA       INT NOT NULL,
      TVAL       NUMERIC(15,4),
      GIFT       NUMERIC(10,2),
      PRIMARY KEY (OFFERID, OFRGRP) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_offer_item';
   $query="CREATE TABLE $t1 (
      OFFERID    INT NOT NULL,
      OFRGRP     INT NOT NULL,
      OFRLINE    INT NOT NULL,
      ICODE      VARCHAR(20),
      ISUBCODE   VARCHAR(20),
      QUANTITY   INT NOT NULL, /* προτεινόμενη ποσότητα */
      DISCOUNT	  NUMERIC(10,4) NOT NULL, /* αν υπάρχει έκπτωση, η τιμή δεν παίζει κανένα ρόλο */
      PRICE      NUMERIC(15,4) NOT NULL,
      PRIMARY KEY (OFFERID, OFRGRP, OFRLINE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_wishlist';
   $query="CREATE TABLE $t1 (
      RID            INT NOT NULL AUTO_INCREMENT,
      AGENTID        INT NOT NULL,
      MBR_LOGIN      VARCHAR(20) NOT NULL, -- ishop_mbr.LOGIN
      ICODE          VARCHAR(20) NOT NULL,
      ISUBCODE       VARCHAR(20) NOT NULL,
      LWISHDAYTIME   DATETIME,
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, MBR_LOGIN, ICODE, ISUBCODE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_paynet';
   $query="CREATE TABLE $t1 (
      TRID        INT NOT NULL AUTO_INCREMENT,
      PASSID      INT NOT NULL,
      AGENTID     INT NOT NULL,
      RESELID     INT NOT NULL,
      BENEFIC     VARCHAR(20) NOT NULL,
      FULLNAME    VARCHAR(100), -- end user fullname
      PCODE       VARCHAR(100), -- end user payment code
      AMOUNT      NUMERIC(10,4) NOT NULL,
      PAYHOW      TINYINT NOT NULL, -- end user payment method: 0,1=cash/credit card
      DONE        TINYINT NOT NULL DEFAULT 0,
      CCERRNO     INT NOT NULL DEFAULT 0,
      CCERRDES    VARCHAR(250),
      CRETIME     DATETIME NOT NULL,
      ANSTIME     DATETIME,
      REMOTEHOST  VARCHAR(120),
      REMOTEADDR  VARCHAR(20),
      TEASIGN     MEDIUMTEXT,
      PRIMARY KEY(TRID) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='order_main';
   $proc_table=false;
   if (in_array($t1,$tables)) {
      $coldatas=$db->MetaColumns($t1);

      $fi=false;
      foreach ($coldatas as $col1) {
		   if (strcmp($col1->name, 'PAYDAYTI')!=0)
			   continue;

         // Found 'PAYDAYTI'
         $fi=true;
         if (strcmp($col1->type, 'int')==0) {
            $query="ALTER TABLE $t1 DROP COLUMN PAYDAYTI";
            if (!$db->Execute($query)) {
      	      table_terminate($db,$t1,$query);
      	   }
            $proc_table=true;
         }
         break; // no need to continue loop
      }
		if (!$fi)
			$proc_table=true;
	}
	// ORDTYPE values
	// 0 = Customer (sales)
	// 1 = Supplier order
   // 2 = Παραλαβή ενδοδιακίνησης
   // 3 = Απογραφή (reserved for SOFTONE)
   // 4 = Καταγραφή ελλείψεων
   // 127 = Report (reserved for ORDER Plus)
   $query="ORDERID      INT NOT NULL AUTO_INCREMENT, ".
         "XDBID         INT NOT NULL, ".
         "AGENTID       INT NOT NULL, ".
         "ORDTYPE       TINYINT NOT NULL, ".
         "LOCALID			INT NOT NULL, ". 		// PDA local id
         "LOGTIME       DATETIME NOT NULL, ".
         "STATE         INT NOT NULL, ".
         "MBR_LOGIN     VARCHAR(20) NOT NULL, ". // --> ishop_mbr.LOGIN OR ishop_sup.LOGIN
         "MBR_FAVOR     VARCHAR(20) NOT NULL, ". // ORDER Plus: loyalty customer
         "MBR_XDBID     INT NOT NULL, ". // ---> xxx_mbr.XDBID
         "RE_RESELID    INT NOT NULL, ". // --> reseller.RESELID
		   "CNAME         VARCHAR(50),".
		   "BRANCHID      INT NOT NULL, ". // Υπoκατάστημα παράδοσης
		   "WAREHOUSEID   INT NOT NULL, ". // revision 4-10-2004
		   "PRESETDISC    NUMERIC(15,2), ". // preset discount (%)
		   "DISCOUNT      NUMERIC(15,2), ". // discount percentage (info)
		   "DISCOUNTCALC  SMALLINT, ".
		   "DISCTOTAL     NUMERIC(15,3) NOT NULL, ". // Συνολική αξία εκπτώσεων
		   "NETTOTAL      NUMERIC(15,3), ". // net total witout vat
		   "VATTOTAL      NUMERIC(15,3), ".
   		"GRANDTOTAL    NUMERIC(15,3), ".
	  	   "SELLCURRENCY  VARCHAR(8), ".
	  	   "RESELLER      VARCHAR(20) NOT NULL, ". // INCA reseller login
		   "MERCHARGE     NUMERIC(15,3), ".
		   "RESELPROFIT   NUMERIC (15,3), ".
		   "CHARGECURRENCY VARCHAR(8), ".
         "DLVDEST       VARCHAR(255), ".
         "DLVCOST       NUMERIC (15,3), ".
         "ISSUEID       INT NOT NULL, ".
         "DOCID         INT NOT NULL, ". // 0,1,2,3,4=χωρίς, Δ/Α, ΤΔΑ, Δ/Π, ΠΔΠ
         "DLVREASON     VARCHAR(255), ".
         "COMMENT       TEXT, ".
         "CREDITDAYS    INT NOT NULL, ".
         "PAYZ				INT NOT NULL DEFAULT 1, ".
         "PAYDAYTI		DATETIME, ". // server datetime
         "REFNO         VARCHAR(20), ".
         "ISSUEDES      VARCHAR(50), ". //  ονομασία παραστατικού
         "SPECID        INT, ". // --> ishop_prspec.SPECID
         "SIGNX         SMALLINT, ".
         "SIGNY         SMALLINT, ".
         "SIGNATURE     MEDIUMBLOB, ".
         "PRIMARY KEY(ORDERID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'ORDERID'),
      'k2'=>array('AGENTID', 'RE_RESELID', 'LOCALID'),
      'k3'=>array('AGENTID', 'MBR_LOGIN', 'STATE'),
      'k4'=>array('AGENTID', 'XDBID', 'ORDERID'),
      'k5'=>array('AGENTID', 'MBR_FAVOR', 'STATE')
      );
   add_index($db,$t1,$idx);

   check_for_nulldate($db, $t1, array('PAYDAYTI') );

   if ($proc_table) {
		$query="UPDATE $t1 SET PAYDAYTI=LOGTIME WHERE STATE=110 OR STATE=111 OR STATE=112";
		if (!$db->Execute($query))
      	table_terminate($db,$t1,$query);
   }

   $cols=$db->MetaColumnNames($t1);
   // revision 6-9-2005
   $coldatas=$db->MetaColumns($t1);
   foreach ($coldatas as $col1) {
		if (strcmp($col1->name, 'COMMENT')!=0)
			continue;

      if (strcmp($col1->type, 'varchar')==0) {
      	$query="ALTER TABLE $t1 MODIFY COMMENT TEXT";
      	if (!$db->Execute($query))
         	table_terminate($db,$t1,$query);
		}
   }
   //......................................
   $t1='order_prop';
   $query="CREATE TABLE $t1 ( ".
         "ORDERID INT NOT NULL, ".
         "PNAME VARCHAR(255) NOT NULL, ".
         "PVALUE VARCHAR(255), ".
         "PRIMARY KEY(ORDERID,PNAME) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('PNAME', 'ORDERID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='order_line';
   $proc_table=false;
   if (in_array($t1,$tables)) {
		$cols=$db->MetaColumnNames($t1);
		if (!in_array('EXECDAYTI',$cols)) {
			$proc_table=true;
		}
	}
   $query="ORDERID     INT NOT NULL, ".
         "ORDLINE      INT NOT NULL, ".
         "XDBID        INT NOT NULL, ". // 999999999 for extra items based on quantiy discount policy
         "SUBID        INT NOT NULL, ". // Για να υποστηρίξει τα extras στο Εστιατόριο, με 1.000.000 τις δωρεάν ποσότητες
         "STATE        INT NOT NULL, ". // 0,1,2=temp. entry, processed, deleted
         "PRINTED      TINYINT NOT NULL, ".
         "APODIXI      VARCHAR(20), ".  // Aριθμός απόδειξης (ORDER Plus)
         "ICODE        VARCHAR(20) NOT NULL, ". // 24-9-2004
         "ISUBCODE     VARCHAR(20) NOT NULL, ". // 3-10-2005
         "INAME        VARCHAR(120), ".
         "DISCODE      VARCHAR(20), ".
         "MARGIN       NUMERIC(15,3), ". // discount margin for reseller
         "QWANT        NUMERIC(15,3), ".
         "QUANTITY     NUMERIC(15,3), ".
         "ORIGQUA      NUMERIC(15,3), ".
         "QSENT        NUMERIC(15,3), ".
         "QINVOICED    NUMERIC(15,3), ".
         "LISTPRICE    NUMERIC(15,4), ". // τιμή τιμοκαταλόγου
         "PRICE        NUMERIC(15,4), ". // τιμή δοθείσα (χ/φπα)
         "ORIGPRICE    NUMERIC(15,4), ".
         "GTPRICE      NUMERIC(15,4), ". // τιμή δοθείσα (με φπα)
         "FULLPRICE    NUMERIC(15,2), ". // τιμή μαζί με τα extras +/-, με φπα (εστιατόριο)
         "FULLPRNET    NUMERIC(15,2), ". // τιμή μαζί με τα extras +/-, χωρίς φπα (εστιατόριο)
         "FULLPRNEG    NUMERIC(15,2), ". // τιμή μαζί με τα extras ΜΕΙΟΝ, με φπα (εστιατόριο)
         "DISCOUNT     NUMERIC(5,2), ".  // ποσοστό έκπτωσης
         "VATPER       NUMERIC(6,2), ".
         "VATCTGTAM    INT NOT NULL, ".  // Κατηγορία φόρου στην ταμειακή
         "TICKTPRICE   NUMERIC(15,2), ". // τιμή εισητιρίου
         "TICKTSPENT   NUMERIC(15,2), ". // Συνολικό ποσό (αξία) αναλωθέν σε εκπτώσεις
         "UNIT         VARCHAR(20), ".
         "ICLEARCTG    INT, ". 
         "PRODUCO      TINYINT, ". // production consumption done
         "SWEIGHT      NUMERIC(10,2), ".
         "SVOLUME      NUMERIC(10,2), ".
         "CREDITDAYS   INT, ".
         "EXECZ		  INT NOT NULL DEFAULT 1, ".
         "EXECDAYTI	  DATETIME, ". // server datetime
         "ISSUEZ		  INT NOT NULL DEFAULT 1, ".
         "ISSUEDAYTI	  DATETIME, ". // server datetime
         "COMMENTS     VARCHAR(255), ". // used also for jorbis7 SERVERAA
         "QUAPROC      TINYINT NOT NULL, ".
         "VALPROC      TINYINT NOT NULL, ".
         "SRCORDER     VARCHAR(20), ".
         "SRCORDLINE   INT, ".
         "LASTUPDATE   TIMESTAMP, ".
         "INETVALUE    NUMERIC(15,4), ". // αξία (βάσει PRICE), χωρίς ΦΠΑ
         "IVATVALUE    NUMERIC(15,4), ". // αξία ΦΠΑ
         "PRIMARY KEY(ORDERID,ORDLINE,SUBID) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   // Returns an array containing column names that are the primary keys
   $mi1=$db->MetaPrimaryKeys($t1);
   if ($mi1!==false && count($mi1)==2) { // 2 fields
      $query="ALTER TABLE $t1 DROP PRIMARY KEY";
      echo "<!-- About to execute $query on ".($prof->sec+$prof->msec)." -->\n";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="ALTER TABLE $t1 ADD PRIMARY KEY (ORDERID,ORDLINE,SUBID)";
      echo "<!-- About to execute $query on ".($prof->sec+$prof->msec)." -->\n";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
   }
   if ($proc_table) {
      echo "<!-- About to call reset_lines() on ".($prof->sec+$prof->msec)." -->\n";
		reset_lines($db);
	}
   //
	// Check for PRICE and QUANTITY dimensions
	//
	if ($db->databaseType=='mysqlt') {
   	$query="DESCRIBE $t1";
	   echo "<!-- About to execute $query on ".($prof->sec+$prof->msec)." -->\n";
	   if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
      }
      $ok1=$ok2=false;
      while ($o1=$rs->FetchNextObject()) {
         if (strcasecmp($o1->FIELD,'PRICE')==0) { // 12-2-2007
            $ar1=explode(',',$o1->TYPE);
            $dec=(int)$ar1[1];
            if ($dec>=4) {
               $ok1=true;
            }
         }
         else if (strcasecmp($o1->FIELD,'QUANTITY')==0) { // 12-2-2007
            $ar1=explode(',',$o1->TYPE);
            $dec=(int)$ar1[1];
            if ($dec>=3) {
               $ok2=true;
            }
         }
         else if ($o1->FIELD=='EXECDAYTI') {
            if ($o1->NULL!='YES') {
               $query="ALTER TABLE $t1 MODIFY EXECDAYTI DATETIME";
               if (!$db->Execute($query))
                  table_terminate($db,$t1,$query);
            }
         }
         else if ($o1->FIELD=='ISSUEDAYTI') {
            if ($o1->NULL!='YES') {
               $query="ALTER TABLE $t1 MODIFY ISSUEDAYTI DATETIME";
               if (!$db->Execute($query))
                  table_terminate($db,$t1,$query);
            }
         }
      }
      $rs->Close();
      if (!$ok1) {
         $ar1=array('PRICE', 'LISTPRICE', 'GTPRICE');
         foreach ($ar1 as $a1) {
            $query="ALTER TABLE $t1 MODIFY $a1 NUMERIC(15,4)";
            echo "<!-- About to execute $query on ".($prof->sec+$prof->msec)." -->\n";
            if (!$db->Execute($query))
               table_terminate($db,$t1,$query);
         }
      }
      if (!$ok2) {
         $ar1=array('QWANT', 'QUANTITY', 'QSENT', 'QINVOICED');
         foreach ($ar1 as $a1) {
            $query="ALTER TABLE $t1 MODIFY $a1 NUMERIC(15,3)";
            echo "<!-- About to execute $query on ".($prof->sec+$prof->msec)." -->\n";
            if (!$db->Execute($query))
               table_terminate($db,$t1,$query);
         }
      }
   }
   $idx=array(
      'k1'=>array('DISCODE', 'ORDERID', 'ORDLINE', 'SUBID'),
      'k2'=>array('INETVALUE', 'ORDERID')
      );
   add_index($db,$t1,$idx);
   // 13-6-2008
   $oids=array();
   $query="SELECT T1.ORDERID FROM order_line T1
      LEFT JOIN order_main T2 ON (T2.ORDERID=T1.ORDERID)
      WHERE T1.INETVALUE=0.0 AND T2.STATE!=9999
      GROUP BY T1.ORDERID";
   if (($rs=$db->Execute($query))!==false) {
      while ($o1=$rs->FetchNextObject()) {
         $oids[]=$o1->ORDERID;
      }
      $rs->Close();
   }
   else {
      echo "<h6>".$db->ErrorMsg()."</h6>";
   }
   //......................................
   $t1='ishop_zno';
   $query="AGENTID INT NOT NULL, ".
		"ZTYPE		INT NOT NULL, ". 	// 1,2,3=exec,issue,pay, 1001=α/α αριθμητής αποδείξεων (1)
   	"ZNR			INT NOT NULL, ".
   	"ZDAYTI		DATETIME NOT NULL, ". // server datetime
   	"PRIMARY KEY (AGENTID, ZTYPE, ZNR) ) ".
   	"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_cash';
   $query="ID     INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID    INT NOT NULL, ".
      "OPERID     INT NOT NULL, ".
      "RESELID    INT NOT NULL, ".
      "ZNR			INT NOT NULL, ".
      "PAYTYPE    TINYINT NOT NULL, ". // 1=CASH, 2=TICKET, 3=Credit card
      "CQUA       INT NOT NULL DEFAULT 1, ".
      "CASH1      INT NOT NULL, ".
      "CDAYTIME   DATETIME NOT NULL, ".
      "PRIMARY KEY (ID)) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'RESELID', 'CDAYTIME', 'ID'),
      'k2'=>array('AGENTID', 'CDAYTIME', 'ID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_backordex';
   $query="CREATE TABLE $t1 ( ".
      "ID         INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID    INT NOT NULL, ".
      "MBR_XDBID  INT NOT NULL, ". // ishop_mbr.XDBID
      "ITEM_XDBID INT NOT NULL, ". // ishop_item.XDBID
      "QUANTITY   NUMERIC(15,5), ".
      "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (ID) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'MBR_XDBID', 'ITEM_XDBID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_transact';
   $query="CREATE TABLE ".$t1." (
      TRANSID     INT NOT NULL AUTO_INCREMENT, -- Unique number (MySql AUTO_INCREMENT, MS-Sql IDENTITY)
      FTRANID     INT NOT NULL, -- First 'transid' of session
      AGENTID     INT NOT NULL,
      TSYNC       TINYINT NOT NULL, -- 0=Not synced, 1=synced with external DB
      ULOGIN      VARCHAR(20) NOT NULL, -- user login (reselid)
      ICODE       VARCHAR(50) NOT NULL,
      ISUBCODE    VARCHAR(20) NOT NULL,
      IUNIT       VARCHAR(10) NOT NULL, -- Μονάδα μετρησης
      IQUA        NUMERIC(15,3) NOT NULL,
      ITRANSDAYTI DATETIME NOT NULL,
      IWAREHOUSE  INT NOT NULL DEFAULT 0,
      EXID        INT,
      IPOSITION   VARCHAR(50) NOT NULL DEFAULT ' ',
      LASTUPDATE  TIMESTAMP, 
      PRIMARY KEY (TRANSID) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'ITRANSDAYTI', 'TRANSID'),
      'k2'=>array('AGENTID', 'FTRANID', 'TRANSID'),
      'k3'=>array('AGENTID', 'ICODE')
      );
   add_index($db,$t1,$idx);

   if ($db->databaseType=='mysqlt') {
      $mod1=$mod2=true;
      $query="DESCRIBE $t1";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
      }
      while ($o1=$rs->FetchNextObject()) {
         if (strcasecmp($o1->FIELD,'TRANSID')==0) { // 2-4-2006
            if (strcasecmp($o1->EXTRA,'AUTO_INCREMENT')==0) {
               $mod1=false; // no need to modify
            }
         }
         else if (strcasecmp($o1->FIELD,'IQUA')==0) { // 12-2-2007
            $ar1=explode('(',$o1->TYPE);
            if (strcasecmp($ar1[0],'INT')!=0) {
               $mod2=false; // no need to modify
            }
            break;
         }
      }
      $rs->Close();
      if ($mod1) {
         $query="ALTER TABLE $t1 MODIFY TRANSID INT NOT NULL AUTO_INCREMENT";
         if (!$db->Execute($query))
            table_terminate($db,$t1,$query);
      }
      if ($mod2) {
         $query="ALTER TABLE $t1 MODIFY IQUA NUMERIC(15,3) NOT NULL";
         if (!$db->Execute($query))
            table_terminate($db,$t1,$query);
      }
   }
   //......................................
   $t1='ishop_s81';
   $query="CREATE TABLE $t1 ( ".
         "AGENTID          INT NOT NULL, ".
         "s81warehouse     INT NOT NULL, ". // --> menurep.MENUID (MENUTYPE=1)
         "s81cod1          VARCHAR(20) NOT NULL, ". // Κωδικος ειδους
         "s81subcod			VARCHAR(20) NOT NULL, ". // Υποκωδικός
         "s81qua1          NUMERIC(15,5) NOT NULL, ". //   Ποσοτητα μμ1 υπόλοιπο
         "s81ordq1         NUMERIC(15,5) NOT NULL, ". //   Ποσοτητα μμ1 δεσμευμενη
         "s81supq1         NUMERIC(15,5) NOT NULL, ". //   Ποσοτητα αναμονής μμ1 από προμηθευτες
         "LASTUPDATE       TIMESTAMP, ".
         "PRIMARY KEY (AGENTID, s81warehouse, s81cod1, s81subcod) ) ". // 21-9-2004
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   $cols=$db->MetaColumnNames($t1);
   // revision 21-9-2004
   array_walk($cols,'array_toLower');
   if (!in_array('s81subcod',$cols)) {
      $query="ALTER TABLE $t1 ADD s81subcod VARCHAR(20) NOT NULL AFTER s81cod1";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

		// Remake keys
      $query="ALTER TABLE $t1 DROP PRIMARY KEY";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="ALTER TABLE $t1 ADD PRIMARY KEY (AGENTID,s81warehouse,s81cod1,s81subcod)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='ishop_s83';
   $query="CREATE TABLE $t1 ( 
         RID               INT NOT NULL AUTO_INCREMENT, 
         AGENTID           INT NOT NULL,
         MBR_LOGIN         VARCHAR(20) NOT NULL, 
         ICODE             VARCHAR(20) NOT NULL, 
         QUATHIS           NUMERIC(15,5) NOT NULL, -- quantity This year
         VALTHIS           NUMERIC(15,5) NOT NULL, -- value This year 
         QUALY             NUMERIC(15,5) NOT NULL, -- quantity Last year 
         VALLY             NUMERIC(15,5) NOT NULL, -- value Last Year
         LASTUPDATE        TIMESTAMP, 
         PRIMARY KEY (RID),
         UNIQUE (AGENTID, MBR_LOGIN, ICODE) ) 
         ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'LASTUPDATE')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_d32';
   $query="CREATE TABLE $t1 ( ".
      	"d32row           INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID          INT NOT NULL, ".
         "WEBIO            SMALLINT NOT NULL, ". // 0/1=No/Yes input from the WEB
         "g11row           INT NOT NULL, ". 	 	 // --> ishop_g11
         "d32dat           DATETIME NOT NULL, ". // Ημερομηνια εγγραφης
         "d32draftnr			VARCHAR(40), ".
         "d32bank				VARCHAR(40), ".
			"d32amount			NUMERIC(15,5), ".     //     8   Ποσο
         "d32due   			DATETIME NOT NULL, ". // Ημερομηνια λήξης
         "PRIMARY KEY(d32row) ) ".
         "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'd32dat', 'd32row')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_g01';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      G01ID       INT NOT NULL,
      G01SHORT    VARCHAR(6),
      G01LONG     VARCHAR(100),
      G01MYF      SMALLINT NOT NULL, -- 0/1/2=Any/Invoice/Credit note
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY(AGENTID, G01ID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_g10';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL, 
      g10acc      VARCHAR(20) NOT NULL,
      g10str      VARCHAR(6), -- Δομη λογαριασμου
      g10name     VARCHAR(100) NOT NULL,
      g10sta1     TINYINT, -- Γενικης λογ:0 Αναλυτικης λογ:1 Υπενθυμισης:2
      PRIMARY KEY(AGENTID, g10acc) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_g11';
   $query="CREATE TABLE $t1 ( ".
      	"g11row           INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID          INT NOT NULL, ".
         "WEBIO            SMALLINT NOT NULL, ". // 0/1/2=No/Yes WEB sales/Yes WEB cash collection
         "EXTID            INT NOT NULL, ".
         "g11dat           DATETIME NOT NULL, ". // Ημερομηνια εγγραφης
         "g11typ1          SMALLINT NOT NULL, ". // Τυπος ημερολογιου 1-19
         "g11num1          INT NOT NULL, ".      // Α/Α εγγραφης ανα ημερολογιο 1-999999 1000000- μη ενημερωμενες
         "g11num2          SMALLINT NOT NULL, ". // A/A κινησης στην εγγραφη
         "g11cat           SMALLINT NOT NULL, ". // Κατηγορια 0:γενικης λογιστικης, 1:πελατες, 2:προμηθευτες
         "g11acc           VARCHAR(20) NOT NULL, ". //  Κωδικος λογαριασμου
         "g11typ2          SMALLINT NOT NULL, ". // Τυπος καταχωρισης 1-99 (100 web pay)
         "g11fdc           SMALLINT NOT NULL, ". // Χρεωση =0 Πιστωση =1
         "g11tax           SMALLINT NOT NULL, ". // Κωδικος φορου
         "g11rfd           DATETIME NOT NULL, ". // Ημερομηνια παραστατικου
         "g11dud           DATETIME NOT NULL, ". // Ημερομηνια oφειλης
         "g11rfn1          VARCHAR(20), ". //   Παραστατικο
         "g11rfn2          VARCHAR(20), ". //   Παραστατικο εξωτερικο
         "g11com           VARCHAR(40), ". //   Σχολια
         "g11idn           VARCHAR(100), ". //   Ταυτοτητα καταχωρητη = reseller.RE_NAME
         "g11val           NUMERIC(15,5), ". //     8   Ποσο
         "g11vat           NUMERIC(15,5), ". //     8   Ποσο φορου
         "g11vas           NUMERIC(15,5), ". //     8   Ποσο τζιρου (υπολ)
         "g11vak           NUMERIC(15,5), ". //     8   Ποσο κοστους
         "g11vaq           NUMERIC(15,5), ". //     8   Ποσότητα
         "LASTUPDATE       TIMESTAMP, ".
         "PRIMARY KEY(g11row) ) ". // 1/5/2004
			"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'g11dat', 'g11typ1', 'g11num1', 'g11num2', 'g11row'),
      'k2'=>array('AGENTID', 'EXTID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_g13';
   $query="G13ROW    INT NOT NULL AUTO_INCREMENT,
      AGENTID        INT NOT NULL, 
      G13CAT         SMALLINT NOT NULL DEFAULT 1, 
      G13ACC         VARCHAR(20) NOT NULL,
      G13FCC         INT NOT NULL, -- foreign currency 
      EXTID          INT NOT NULL, 
      YMONTH         INT NOT NULL, -- YYYYMM
      XREOSI         NUMERIC(15,5), 
      PISTOSI        NUMERIC(15,5), 
      TZIROS         NUMERIC(15,5), -- turnover
      QUA            NUMERIC(15,5), -- quantity
      VAT            NUMERIC(15,5), -- VAT ammount
      NIV1           INT,  -- number of invoices
      NIV2           INT,  -- number of pistotika           
      LASTUPDATE     TIMESTAMP, 
      PRIMARY KEY(G13ROW) ) 
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>'AGENTID, G13CAT, G13ACC, YMONTH, G13FCC'
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_s80';
   $query="CREATE TABLE $t1 ( ".
         "s80row           INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID          INT NOT NULL, ".
         "WEBIO            SMALLINT NOT NULL, ". // see comments at end
         "EXTID            INT NOT NULL, ".
         "s80cod1          VARCHAR(20) NOT NULL, ". //   Κωδικος ειδους
         "s80subcod        VARCHAR(20) NOT NULL, ". //   Υποκωδικος ειδους
         "s80dat           DATETIME NOT NULL, ". //       4   ημ/νια κινησης
         "s80qua1          NUMERIC(15,5) NOT NULL, ". //     8   Ποσοτητα μμ1
         "s80qua2          NUMERIC(15,5) NOT NULL, ". //     8   Ποσοτητα μμ2
         "s80pri1          NUMERIC(15,5) NOT NULL, ". //     8   Τιμη εισαγωγης
         "s80val1          NUMERIC(15,5) NOT NULL, ". //     8   Αξια κινησης Τζιρος
         "s80val2          NUMERIC(15,5) NOT NULL, ". //     8   Αξια κινησης Κοστος
         "s80val3          NUMERIC(15,5) NOT NULL, ". //     8   Αξια κινησης φορος ΦΠΑ
         "s80val4          NUMERIC(15,5) NOT NULL, ". //     8   Αξια κινησης ειδικος φορος
         "s80val5          NUMERIC(15,5) NOT NULL, ". //     8   Αξια κινησης ολικη εκπτωση
         "s80vatper        NUMERIC(15,5) NOT NULL, ". //     8   Ποσοστό ΦΠΑ
         "s80usrf          NUMERIC(15,5) NOT NULL, ". //     8   Κοστολογηθησα ποσοτητα
         "s80mco           SMALLINT NOT NULL, ". //       2   Κωδικος κινησης
         "s80slc           SMALLINT NOT NULL, ". //       2   Αποθηκ.χωρος
         "s80slc1          SMALLINT NOT NULL, ". //       2   Αντιθετος αποθηκ.χωρος
         "s80fla1          SMALLINT NOT NULL, ". //       2   Κωδικος Φ.Π.Α. Λογιστικης
         "s80fla2          NUMERIC(15,5), ". //       2   Συνολικη εκπτωση %100
         "s80smn           INT NOT NULL, ". //   Πωλητης 1 <-->reseller.RESELID
         "s80smp           NUMERIC(15,5), ". //       2   Ποσοστο πωλητη 1 %100
         "s80rnu           VARCHAR(20) NOT NULL, ". //  8   Αρ.παραστατ.(εσωτερ.)
         "s80rnu1          SMALLINT NOT NULL, ". //       2   Α/Α στο παραστατικο
         "s80rda           DATETIME NOT NULL, ". //       4   Ημ/νια παραστατικου
         "s80ref           VARCHAR(20), ". //    11   Βοηθητικος αριθμ.παραστατικου
         "s80des           VARCHAR(100), ". //    16   Αιτιολογια/σχόλια
         "s80nam           VARCHAR(100), ". //    41   Περιγραφη ειδους
         "s80idn           VARCHAR(100), ". //   Καταχωρητής = reseller.RE_NAMED
         "s80cat           SMALLINT NOT NULL, ". //       2   Κατηγορια κωδικου 0=γεν. 1=πελατη 2=προμηθ.κλπ.
         "s80acc           VARCHAR(20) NOT NULL, ". //    13   Κωδ.Λογιστικης
         "s80usrl          INT NOT NULL, ". //   4   rowid σχετικης κινησης
         "g11row           INT NOT NULL, ". // <--> g11row
         "LASTUPDATE       TIMESTAMP, ".
         "PRIMARY KEY(s80row) ) ".
         "ENGINE=InnoDb ";
   // Comments
   // WEBIO =0 AS IS from customer database
   //       =1 WEB: spend (sales)
   //       =2 WEB: add quantity (purchases)
   //       =100 WEB: clear (reset) quantities
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 's80cod1', 's80subcod', 's80dat', 's80row'),
      'k2'=>array('AGENTID', 's80cat', 's80acc', 's80dat'),
      'k3'=>array('AGENTID', 's80cod1', 's80dat'),
      'k4'=>array('AGENTID', 'EXTID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_ctg';
   $query="AGENTID INT NOT NULL,
      PAGENO   VARCHAR(20) NOT NULL,
      WMPAGE   VARCHAR(20) NOT NULL, -- Waitermate pageno
      VIEWSEQ  VARCHAR(20) NOT NULL DEFAULT 'z',
		ABBREV   VARCHAR(20) NOT NULL,
		TITLE    VARCHAR(60) NOT NULL,
		COLOR    VARCHAR(10) NOT NULL, -- 15-12-2005
		BGCOLOR  VARCHAR(10) NOT NULL, -- 15-12-2005
		COMMENTS VARCHAR(255),
		FONTSIZE	INT NOT NULL, -- pt (points)
		LISTINCAT  TINYINT NOT NULL DEFAULT 1, -- εμφάνιση στον κατάλογο
		LASTUPDATE TIMESTAMP, -- revision 22-9-2004
		PRIMARY KEY(AGENTID,PAGENO) )
		ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
	
	$idx=array(
      'k1'=>array('AGENTID', 'ABBREV' )
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_item_del';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      CODE        VARCHAR(20) NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (AGENTID, CODE) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_item';
   $query="AGENTID    INT NOT NULL,
      PAGENO     VARCHAR(20) NOT NULL DEFAULT '1',
      PAGENO2    VARCHAR(20) NOT NULL,
      VIEWSEQ    VARCHAR(20) NOT NULL DEFAULT 'z',
      COLOR      VARCHAR(10) NOT NULL,
		BGCOLOR    VARCHAR(10) NOT NULL,
		FONTSIZE	  INT NOT NULL, -- pt (points)
		CODE       VARCHAR(20) NOT NULL,
		CODE2      VARCHAR(20) NOT NULL,
		XDBID      INT NOT NULL, -- external database record id
		BARCODE    VARCHAR(40) NOT NULL,
		NAME       VARCHAR(150) NOT NULL DEFAULT 'Unavailable',
		TRKEY      VARCHAR(75), -- CODE + NAME + GAP
		VATCAT     TINYINT NOT NULL DEFAULT '2',
		PRICE1     NUMERIC(15,4) NOT NULL,
		PRICE2     NUMERIC(15,4) NOT NULL,
      MAXDISCOUNT NUMERIC(15,4) NOT NULL,
      STDPRICE   NUMERIC(15,4) NOT NULL, -- σταθερό κόστος
		UNIT       VARCHAR(20) NOT NULL,
		AVAILABLE  INT NOT NULL, -- 0/1/2/3=Unknown/Available/Waiting/Exhausted
      ICLEARCTG  INT NOT NULL,
      SWEIGHT    NUMERIC(10,2) NOT NULL, -- send Weight
      SVOLUME    NUMERIC(10,2) NOT NULL, -- send Volume
      PRINTPOS   INT NOT NULL, -- => ishop_printpos
      PRINTPOS2  INT NOT NULL, -- => ishop_printpos
      PRINTPOS3  INT NOT NULL, -- => ishop_printpos
      PRINTSEQ   INT NOT NULL DEFAULT 99,
      COUVER  	  TINYINT NOT NULL, -- 0=normal, 1=κουβερ, 2=ticket, 3=επιστρεφόμενο
      LISTINCAT  TINYINT NOT NULL DEFAULT 1, -- εμφάνιση στον κατάλογο
      ILOCKED    TINYINT NOT NULL, -- 1=item is locked (not allowed to sell)
      WEIGHTINP  TINYINT NOT NULL, -- 1=ζυγιζόμενο
      CREDITDAYS INT NOT NULL,
		INFO       VARCHAR(255) NOT NULL,
		INFO2      TEXT, -- comments
		SMALLHREF  VARCHAR(255) NOT NULL,
		BIGHREF    VARCHAR(255) NOT NULL,
		MOREHREF   VARCHAR(255) NOT NULL,
		ISALESGRP1 INT, -- => ishop_discount.ISALESGRP1
		ISALESOMA1 VARCHAR(10), -- => ishop_cgdisc.ISALESOMA1
		CODETOGR   VARCHAR(20), -- for Megatron
		THESI      VARCHAR(100) NOT NULL,
		MINORDERQ  NUMERIC (15,3) NOT NULL, -- Ελάχιστο απόθεμα για αναπαραγγελία
		PROPOSEDQUA   NUMERIC(15,4) NOT NULL DEFAULT 1,
		LASTSUPPLIER  VARCHAR(20), -- => ishop_sup.LOGIN
		LASTSUPREF VARCHAR(100),
		SALEPOINTS NUMERIC(10,2), -- Sales points
		STOMADA    INT NOT NULL, -- SYFA statistics
      STGRP      INT NOT NULL, -- SYFA statistics
		LASTUPDATE TIMESTAMP,
		PRIMARY KEY(AGENTID,CODE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'NAME'),
      'k2'=>array('AGENTID', 'PAGENO', 'NAME'),
      'k3'=>array('AGENTID', 'BARCODE'),
      'k4'=>array('AGENTID', 'CODE2'),
      'k5'=>array('AGENTID', 'TRKEY'),
      'k6'=>array('AGENTID', 'LASTUPDATE'),
      'k7'=>array('AGENTID', 'PAGENO', 'CODE')
      );
   add_index($db,$t1,$idx);

   if ($db->databaseType=='mysqlt') {
      $moduni=false;
      $clrdef=false;
      $query="DESCRIBE $t1";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
      }
      while ($o1=$rs->FetchNextObject()) {
         if (strcasecmp($o1->FIELD,'UNIT')==0) { // 2-4-2006
            $d2=explode('(',$o1->TYPE);
            if ($d2>=2 && (int)$d2[1]<20)
               $moduni=true;
         }
         else if (strcasecmp($o1->FIELD,'PAGENO2')==0) { // 24-11-2006
            if (strlen($o1->DEFAULT)>0)
               $clrdef=true;
         }
      }
      $rs->Close();

      if ($moduni) {
         $query="ALTER TABLE $t1 MODIFY UNIT VARCHAR(20) NOT NULL";
         if (!$db->Execute($query))
            table_terminate($db,$t1,$query);
      }
      if ($clrdef) {
         $query="ALTER TABLE $t1 MODIFY PAGENO2 VARCHAR(20) NOT NULL";
         if (!$db->Execute($query))
            table_terminate($db,$t1,$query);
      }
   }
   //......................................
   // Item properties (descirption of properties taken from menurep/16)
   $t1='ishop_item_prop';
   $query="CREATE TABLE $t1 (
      RID      INT NOT NULL AUTO_INCREMENT,
      AGENTID  INT NOT NULL,
      ICODE    VARCHAR(20) NOT NULL,
      PNAME      VARCHAR(100), 
      PVALUE     VARCHAR(255), 
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, ICODE, PNAME) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Item groups (organizational units)
   $t1='ishop_grplist';
   $query="CREATE TABLE $t1 (
      LISTID   INT NOT NULL AUTO_INCREMENT,
      AGENTID  INT NOT NULL,
      LISTYPE  INT NOT NULL, -- 0=Προσφορες, 1=Νέες αφίξεις, 2=Προτάσεις
      ICODE    VARCHAR(20) NOT NULL, -- <=> ishop_item.CODE
      PRIMARY KEY (LISTID),
      UNIQUE (AGENTID, LISTYPE, ICODE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_pointstep';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      SALEVALUE   NUMERIC(15,2) NOT NULL,
      SALEPOINTS  NUMERIC(10,2) NOT NULL,
      PRIMARY KEY (AGENTID, SALEVALUE) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Item measure units (extra)
   $t1='ishop_units';
	$query="CREATE TABLE $t1 ( ".
         "AGENTID      INT NOT NULL, ".
         "ICODE 		  VARCHAR(20) NOT NULL, ".
         "UNIT         CHAR(4) NOT NULL, ".
         "UNIT2        CHAR(4) NOT NULL, ". // relational unit --> ishop_item.UNIT
         "URELATION    NUMERIC(15,4) NOT NULL, ". // UNIT = UNIT2*relation
         "LASTUPDATE   TIMESTAMP, ".
         "PRIMARY KEY(AGENTID,ICODE,UNIT,UNIT2) )".
         "ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
   //......................................
   // Sales pricelists file (INCA)
   $t1='ishop_pricing';
   $query="PRICID       INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID      INT NOT NULL, ".
         "CODE 		  VARCHAR(20) NOT NULL, ".
         "SUBCODE      VARCHAR(20) NOT NULL, ".
         "PRLISTNO	  INT NOT NULL, ". // --> menurep type(3)
         "PRICE		  NUMERIC(15,4), ".
         "PRIC2		  NUMERIC(15,4) NOT NULL, ". // 16-1-2006
         "DISCOUNT	  NUMERIC(10,4), ".  // 22-9-2004
         "LASTUPDATE   TIMESTAMP, ". // 22-9-2004
         "PRIMARY KEY(PRICID), ".
         "UNIQUE (AGENTID,CODE,SUBCODE,PRLISTNO) ) ".
			"ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_discount';
   if (in_array($t1,$tables)) {
		$cols=$db->MetaColumnNames($t1);
		if (!in_array('DISCVALID',$cols)) { // πολύ παλιός τυπος πινακα: δεν επιδιορθωνεται
			$query="DROP TABLE $t1";
			if (!$db->Execute($query))
      		table_terminate($db,$t1,$query);
  		}
	}
   $query="RID			INT NOT NULL AUTO_INCREMENT, ".
		"AGENTID 		INT NOT NULL, ".
   	"CSALESGRP1		INT NOT NULL, ". // --> ishop_mbr.CSALESGRP1
   	"ISALESGRP1		INT NOT NULL, ". // --> ishop_item.ISALESGRP1
      "DATEFROM      DATETIME NOT NULL, ".
      "DATETO        DATETIME, ".
      "QUA1          NUMERIC(15,4), ". // qua from
      "QUA2          NUMERIC(15,4), ". // qua to
      "PRICE         NUMERIC(15,4), ".
      "DISC1         NUMERIC(5,2), ".
      "DISC2         NUMERIC(5,2), ".
      "DISCVALID     SMALLINT NOT NULL DEFAULT 1, ".
      "DMARK         INT NOT NULL, ".
      "LASTUPDATE    TIMESTAMP, ".
   	"PRIMARY KEY (RID), ".
   	"UNIQUE (AGENTID,CSALESGRP1,ISALESGRP1,DATEFROM,QUA1) ) ".
   	"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_discount_del';
   $query="AGENTID 		INT NOT NULL, ".
      "CSALESGRP1		INT NOT NULL, ". // --> ishop_mbr.CSALESGRP1
   	"ISALESGRP1		INT NOT NULL, ". // --> ishop_item.ISALESGRP1
      "DATEFROM      DATETIME NOT NULL, ".
      "QUA1          NUMERIC(15,4) NOT NULL, ". // qua from
      "LASTUPDATE    TIMESTAMP, ".
   	"PRIMARY KEY (AGENTID,CSALESGRP1,ISALESGRP1,DATEFROM,QUA1) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_quapolicy';
   if (in_array($t1,$tables)) {
		$cols=$db->MetaColumnNames($t1);
		if (!in_array('DISCVALID',$cols)) {
         // Παλαιού τύπου table. Δεν μπορούμε να το αλλαξουμε. To κάνουμε drop.
			$query="DROP TABLE $t1";
			if (!$db->Execute($query))
      		table_terminate($db,$t1,$query);
  		}
	}
   $query="RID			INT NOT NULL AUTO_INCREMENT, ".
		"AGENTID 		INT NOT NULL, ".
   	"ICODE		   VARCHAR(20) NOT NULL, ". // --> ishop_item.CODE
      "DATEFROM      DATETIME NOT NULL, ".
      "DATETO        DATETIME, ".
      "QUA1          NUMERIC(15,4), ". // qua from
      "QUA2          NUMERIC(15,4), ". // qua to
      "PRICE         NUMERIC(15,4), ".
      "DISC1         NUMERIC(5,2), ".
      "DISC2         NUMERIC(5,2), ".
      "DISCVALID     SMALLINT NOT NULL DEFAULT 1, ".
   	"LASTUPDATE    TIMESTAMP, ".
   	"PRIMARY KEY   (RID), ".
   	"UNIQUE (AGENTID,ICODE,DATEFROM,QUA1) ) ".
   	"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
	//......................................
	$t1='ishop_ctg_quapo';
   $query="RID			INT NOT NULL AUTO_INCREMENT, ".
		"AGENTID 		INT NOT NULL, ".
   	"PAGENO		   VARCHAR(20) NOT NULL, ". // --> ishop_item.PAGENO
      "DATEFROM      DATETIME NOT NULL, ".
      "DATETO        DATETIME, ".
      "QUA1          NUMERIC(15,4), ". // qua from
      "QUA2          NUMERIC(15,4), ". // qua to
      "DISC1         NUMERIC(5,2), ".
      "DISC2         NUMERIC(5,2), ".
      "DISCVALID     SMALLINT NOT NULL DEFAULT 1, ".
   	"LASTUPDATE    TIMESTAMP, ".
   	"PRIMARY KEY   (RID), ".
   	"UNIQUE (AGENTID,PAGENO,DATEFROM,QUA1) ) ".
   	"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
	$t1='ishop_ctg_discount';
	$query="RID      INT NOT NULL AUTO_INCREMENT,
		AGENTID 		  INT NOT NULL,
   	PAGENO		  VARCHAR(20) NOT NULL, -- ishop_item.PAGENO
   	PRLISTNO	     INT NOT NULL, -- menurep type(3)
      DISCOUNT      NUMERIC(15,4),
   	LASTUPDATE    TIMESTAMP,
   	PRIMARY KEY   (RID),
   	UNIQUE (AGENTID,PAGENO,PRLISTNO) )
   	ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
	//......................................
   $t1='ishop_cgdisc'; // customer price
   $query="RID			INT NOT NULL AUTO_INCREMENT, ".
   	"AGENTID 		INT NOT NULL, ".
		"MBR_LOGIN     VARCHAR(20) NOT NULL, ".
		"ISALESOMA1    VARCHAR(10) 		NOT NULL, ". // --> ishop_item
		"DATEFROM      DATETIME NOT NULL, ".
      "DATETO        DATETIME, ".
      "DISC1         NUMERIC(5,2), ".
      "DISC2         NUMERIC(5,2), ".
      "LASTUPDATE    TIMESTAMP, ".
      "PRIMARY KEY (RID), ".
      "UNIQUE (AGENTID,MBR_LOGIN,ISALESOMA1,DATEFROM) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_cprice'; // customer price
   $query="RID			INT NOT NULL AUTO_INCREMENT, ".
		"AGENTID 		INT NOT NULL, ".
		"MBR_LOGIN     VARCHAR(20) NOT NULL, ".
		"ICODE         VARCHAR(20) NOT NULL, ".
      "DATEFROM      DATETIME NOT NULL, ".
      "DATETO        DATETIME, ".
      "QUA1          NUMERIC(15,4), ". // qua from
      "QUA2          NUMERIC(15,4), ". // qua to
      "PRICE         NUMERIC(15,4), ".
      "DISC1         NUMERIC(5,2), ".
      "DISC2         NUMERIC(5,2), ".
      "DISCVALID     SMALLINT NOT NULL DEFAULT 1, ".
      "LASTUPDATE    TIMESTAMP, ".
      "PRIMARY KEY (RID), ".
      "UNIQUE (AGENTID,MBR_LOGIN,ICODE,DATEFROM,QUA1) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Sales pricelist times file
   $t1='ishop_pritime';
   if (in_array($t1,$tables)) {
   	$cols=$db->MetaColumnNames($t1);
   	if (in_array('NDATE', $cols)) { // Πολυ παλιός τυπος πινακα: δεν επισκευαζεται
   		$query="DROP TABLE $t1";
   		if (!$db->Execute($query))
         	table_terminate($db,$t1,$query);
   	}
   }
   $query="TIMEID  INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID    INT NOT NULL, ".
      "WDAY       INT NOT NULL, ". // 0,1,2,...=K,Δ,Τ,Τ,Π,Π,Σ,Κ,Ε1,...
      "TIMEFROM   INT NOT NULL, ". // HHMM: 10000 is used just to make an entry
      "TIMETO     INT NOT NULL, ". // HHMM
      "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (TIMEID), ".
      "UNIQUE (AGENTID, WDAY, TIMEFROM) ) ".
      "ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
	//......................................
	$t1='ishop_pridate';
	$query="DATEID  INT NOT NULL AUTO_INCREMENT, ".
		"AGENTID    INT NOT NULL, ".
      "WDAY       INT NOT NULL, ". // <--> ishop_pritime
      "NDATE		INT NOT NULL, ". // YYYYMMDD
      "LASTUPDATE TIMESTAMP, ".
		"PRIMARY KEY (DATEID), ".
      "UNIQUE (AGENTID, WDAY, NDATE) ) ".
      "ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
	//......................................
	$t1='ishop_priseason';
	$query="RID    INT NOT NULL AUTO_INCREMENT,
		AGENTID     INT NOT NULL,
      FROMDAY     DATETIME NOT NULL,
      TILLDAY     DATETIME NOT NULL,
      DELTA       NUMERIC (15,4), -- delta (+/-) percentage on price
      LASTUPDATE TIMESTAMP,
		PRIMARY KEY (RID),
      UNIQUE (AGENTID, FROMDAY) )
      ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_subitem';
   $query="CREATE TABLE $t1 ( ".
   	"AGENTID      INT NOT NULL, ".
		"CODE         VARCHAR(20) NOT NULL, ".
		"SUBCODE      VARCHAR(20) NOT NULL, ".
		"UCODE        VARCHAR(40) NOT NULL, ". // unified code+subcode (softone)
		"SUBCOLOR     VARCHAR(40) NOT NULL, ". // i.e. "RED MARACES"
		"SUBSIZE      VARCHAR(40) NOT NULL, ".  // i.e. "XXL"
		"SUBWIDTH     NUMERIC(15,3), ".
		"SUBHEIGHT    NUMERIC(15,3), ".
		"SUBDEPTH     NUMERIC(15,3), ".
		"LASTUPDATE   TIMESTAMP, ".
		"PRIMARY KEY(AGENTID,CODE,SUBCODE) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'UCODE' )
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_xtra';
  	$query="CREATE TABLE $t1 ( ".
   	   "XTRID  			INT NOT NULL AUTO_INCREMENT, ".
   	   "AGENTID       INT NOT NULL, ".
   	   "XDBID         INT NOT NULL, ".
		   "CODE 			VARCHAR(20) NOT NULL, ".
		   "SUBCODE 		VARCHAR(20) NOT NULL, ".
		   "XTRCODE 		VARCHAR(20) NOT NULL, ".
         "XTRSUBCODE 	VARCHAR(20) NOT NULL, ". // deprecated
		   "VIEWSEQ       VARCHAR(20) NOT NULL DEFAULT 'z', ".
		   "XTYPE 			SMALLINT NOT NULL DEFAULT 1, ". // 0/1=Without/With
		   "PRICE1 			NUMERIC(15,4), ".
		   "PRICE2 			NUMERIC(15,4), ".
		   "QUANTITY      NUMERIC(15,3) NOT NULL DEFAULT 1.0, ". // recipe quantity
		   "LASTUPDATE 	TIMESTAMP, ".
		   "PRIMARY KEY(XTRID), ".
         "UNIQUE (AGENTID,CODE,SUBCODE,XTRCODE) ) ".
		   "ENGINE=InnoDb ";
	process_meta($db,$tables,$t1,$query);
	//
	// Check for QUANTITY dimensions
	//
	//check_dimension($db,$t1,array('QUANTITY'=>3));
   $idx=array(
      'k1'=>array('AGENTID', 'XTRCODE' )
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_recipe';
  	$query="CREATE TABLE $t1 (
   	REID			INT NOT NULL AUTO_INCREMENT,
   	AGENTID     INT NOT NULL,
		CODE 			VARCHAR(20) NOT NULL,
		SUBCODE 		VARCHAR(20) NOT NULL,
		RECODE 		VARCHAR(20) NOT NULL,
		RESUBCODE 	VARCHAR(20) NOT NULL,
		QUANTITY 	NUMERIC(15,3),
		LASTUPDATE 	TIMESTAMP,
		PRIMARY KEY (REID),
		UNIQUE (AGENTID,CODE,SUBCODE,RECODE,RESUBCODE) )
		ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //
	// Check for QUANTITY dimensions
	//
	//check_dimension($db,$t1,array('QUANTITY'=>3));
   //......................................
   $t1='ishop_open_da';
   $query="CREATE TABLE $t1 ( ".
   	"ODAID		INT NOT NULL AUTO_INCREMENT, ".
   	"AGENTID		INT NOT NULL, ".
		"MBR_LOGIN	VARCHAR(20), ".
		"REFNO		VARCHAR(20), ". // σειρά + αριθμός
		"DOCID		INT NOT NULL, ".
		"ISSUEDAYTIME DATETIME NOT NULL, ".
		"ORDERID		INT NOT NULL, ".
		"LASTUPDATE TIMESTAMP, ".
		"PRIMARY KEY (ODAID) ) ".
		"ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'MBR_LOGIN', 'REFNO' )
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_rel';
   $query="CREATE TABLE $t1 (
   	AGENTID      INT NOT NULL,
      CODE         VARCHAR(20) NOT NULL,
		RELCODE      VARCHAR(20) NOT NULL,
		PRIMARY KEY(AGENTID,CODE,RELCODE))
		ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_breader';
   $query="CREATE TABLE $t1 (
   	ID         INT NOT NULL AUTO_INCREMENT,
   	AGENTID    INT NOT NULL,
		RESELID    INT NOT NULL, -- authentication user
		COMNR      INT NOT NULL,
		ORDERID    INT NOT NULL,
		ORDSCAN    DATETIME NOT NULL,
		DELIVERY   INT,
		DLVRSCAN   DATETIME,
		PRIMARY KEY (ID) )
		ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   
   $idx=array(
      'k1'=>array('AGENTID', 'RESELID', 'COMNR', 'ORDSCAN' )
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_apolog'; // Λογιστικο (εξωτερικό) απόθεμα απογραφής
   $query="CREATE TABLE $t1 ( ".
      "ID            INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID       INT NOT NULL, ".
      "ICODE         VARCHAR(20) NOT NULL, ".
      "ISUBCODE      VARCHAR(20) NOT NULL, ".
      "WAREHOUSEID   INT NOT NULL, ".
      "THESI         VARCHAR(100) NOT NULL, ".
      "QUANTITY      NUMERIC(15,5), ".
      "LASTUPDATE    TIMESTAMP, ".
      "PRIMARY KEY (ID), ".
      "UNIQUE (AGENTID, ICODE, WAREHOUSEID, THESI) ) ".
      "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_view_main';
   $query="CREATE TABLE $t1 (
   	VIEWID 		INT NOT NULL AUTO_INCREMENT,
   	AGENTID 		INT NOT NULL,
   	VIEWNAME 	VARCHAR(100) NOT NULL,
   	VIEWTYPE 	INT NOT NULL, -- 1=Items, 2=Customers, 4=Loyalty
   	LASTUSED    DATETIME,
   	PRIMARY KEY(VIEWID),
   	UNIQUE (AGENTID, VIEWNAME) )
   	ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_view_field'; // ishop_view_info
   $query="CREATE TABLE $t1 (
   	VIEWID 	INT NOT NULL, -- => ishop_view_main.VIEWID
   	VFTYPE 	INT NOT NULL, -- 0=FIELD, 1=SORT, 2=FILTER (VIFROM, VITO)
   	VFSEQ		INT NOT NULL,
   	VIFIELD	VARCHAR(100) NOT NULL,
   	FVALUE   VARCHAR(255), -- Use with VFTYPE=3
   	VISORT 	TINYINT NOT NULL, -- 0,1=ASC,DESC sort order
   	LASTUPDATE  TIMESTAMP,
		PRIMARY KEY (VIEWID, VFTYPE, VFSEQ),
		UNIQUE (VIEWID, VFTYPE, VIFIELD) )
		ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_apotmp';
   if(in_array($t1,$tables)) {
		$query="DROP TABLE $t1";
		if (!$db->Execute($query))
      	table_terminate($db,$t1,$query);
	}
	//......................................
   $t1='ishop_apotmp2';
   $query="CREATE TABLE $t1 (
      RUNID       INT NOT NULL,
      RUNDAYTI    DATETIME NOT NULL,
      AGENTID     INT NOT NULL, /* just info, not needed */
      ICODE       VARCHAR(20) NOT NULL,
      ISUBCODE    VARCHAR(20) NOT NULL,
      IWAREHOUSE  INT NOT NULL,
      ITHESI      VARCHAR(100) NOT NULL,
      QUALOG      NUMERIC(15,5) NOT NULL,
      QUACOUNT    NUMERIC(15,5) NOT NULL,
      PRIMARY KEY (RUNID, ICODE, ISUBCODE, IWAREHOUSE, ITHESI) )
      ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_telwait';
  	$query="CREATE TABLE $t1 ( ".
   	   "TELID          INT NOT NULL AUTO_INCREMENT, ".
   	   "AGENTID        INT NOT NULL, ".
         "TELNR          VARCHAR(40) NOT NULL, ".
		   "TELDAYTIME     DATETIME NOT NULL, ".
		   "DONE           INT NOT NULL, ". // 1=Timeout, 2=Cancel, 3=Selected, 4=Outgoing
		   "DURATION       INT, ".
		   "NOTEID         INT NOT NULL, ". // <--> ishop_cunote
		   "PRIMARY KEY(TELID)) ".
		   "ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_smsin';
  	$query="CREATE TABLE $t1 (
   	SID            INT NOT NULL AUTO_INCREMENT,
   	CALLER         VARCHAR(40) NOT NULL,
      MSGIN          VARCHAR(200) NOT NULL,
      COMMENTS       VARCHAR(200) NOT NULL,
		INDAYTIME      DATETIME NOT NULL,
		PRIMARY KEY(SID))
		ENGINE=InnoDb ";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Πλάνα ορόφων
   $t1='ishop_dplan';
   $query="AGENTID     	INT NOT NULL, ".
      	"PLANID 		  	INT NOT NULL, ".
         "INAME			VARCHAR(50), ".
         "PINOUT			TINYINT NOT NULL, ". // 0/1 = IN/OUT
         "RSVUSEPLAN		TINYINT NOT NULL, ". // 0/1 = No/Yes
         "LASTUPDATE   	TIMESTAMP, ".
         "PRIMARY KEY(AGENTID,PLANID)) ".
         "ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	//......................................
	// Κατηγορίες (ειδών) πλάνου
   $t1='ishop_ctplan';
   $query="AGENTID     	INT NOT NULL, ".
      	"PLANID 		  	INT NOT NULL, ".
         "PAGENO			VARCHAR(20) NOT NULL, ". // <--> ishop_ctg
         "LASTUPDATE   	TIMESTAMP, ".
         "PRIMARY KEY(AGENTID,PLANID,PAGENO) ) ".
         "ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	//......................................
   // ΠΕΡΙΟΧΕΣ ΕΞΥΠΗΡΕΤΗΣΗΣ
	$t1='ishop_area_grp';
	$query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      AREAID      INT NOT NULL,
      TITLE 		VARCHAR(100), -- description
      SRVNAME     VARCHAR(200), -- IP or Host name, for printing
      GMAPLAT     NUMERIC(10,6), 
		GMAPLNG     NUMERIC(10,6), 
		GMAPZOOM    INT, 
      COMMENTS		VARCHAR(200),
		LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (AGENTID, AREAID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_mbr_del';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      LOGIN       VARCHAR(20) NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (AGENTID, LOGIN) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // ishop_mbr (Customer) + ishop_sup (Suppliers)
   $query1="XID      INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID    INT NOT NULL, ".
         "LOGIN      VARCHAR(20)  NOT NULL DEFAULT 'L1', ".
         "XDBID      INT NOT NULL, ". // external database record id
         "WEBIO      SMALLINT NOT NULL, ". // 0/1=no/yes created or modified from the web
		   "PASSWORD   VARCHAR(10) NOT NULL, ".
		   "NAME       VARCHAR(40) NOT NULL, ". // Υπέυθυνος (για εταιρία) ή μικρό όνομα
		   "COMPANY    VARCHAR(40) NOT NULL, ". // Επωνυμία ή επίθετο
		   "CALIAS     VARCHAR(40), ".
		   "SEX        TINYINT NOT NULL, ". // 0/1/2=φύλο χωρίς/ανδρας/γυναίκα
		   "WEBSITE    VARCHAR(200), ".
		   "TRKEY      VARCHAR(65), ". // LOGIN + NAME + GAP
		   "JOB        VARCHAR(40), ".
		   "ADDR1      VARCHAR(40), ".
		   "ADDR2      VARCHAR(40), ".
		   "CITY       VARCHAR(20), ".
		   "STATE      VARCHAR(20), ".
		   "ZIP        VARCHAR(10), ".
		   "COUNTRY    VARCHAR(20), ".
		   "PHONE      VARCHAR(20), ".
		   "PHONE2     VARCHAR(20), ". // mobile
		   "FAX        VARCHAR(20), ".
		   "FLOOR      VARCHAR (20), ".
		   "BELL       VARCHAR(40), ".
		   "AREAID     INT NOT NULL, ". // -- ishop_area_grp.AREAID
		   "VATNO      VARCHAR(20), ".
		   "DOY        VARCHAR(20), ".
		   "EMAIL      VARCHAR(70) NOT NULL, ".
		   "VATCODE    TINYINT NOT NULL DEFAULT '2', ". // 1,2,3,4=No vat,Generic,Reduced,Specific
		   "VATPER     NUMERIC(15,2) NOT NULL, ".
		   "BASEDISC   NUMERIC(15,2) NOT NULL, ". // βασική εκπτωση %
		   "PRLISTNO   INT, ".  // --> ishop_pricing (0=without)
		   "SHOWPRWVAT TINYINT NOT NULL DEFAULT 1, ". // for CART: 0/1=show prices with VAT no/yes
		   "VALIDMBR   TINYINT NOT NULL, ". // valid member (allow to buy from WEB)
         "LISTINCAT  TINYINT NOT NULL DEFAULT 1,  ". // -- εμφάνιση στον κατάλογο 
		   "RESELID    INT, ".  // --> reseller
		   "CRERESELID INT, ".  // --> PDA reseller who created account: should be 0 when reloading file from host database, -1 for auto-creation
		   "DLVMETHOD 	INT, ".
		   "PAYMETHOD 	INT, ".
		   "CSALESGRP1 INT, ".
		   "PLANID		INT DEFAULT 1, ". // --> ORDER Plus: ishop_dplan.PLANID, iCART: 1=ΛΙΑΝΙΚΗ, 2=ΧΟΝΔΡΙΚΗ
		   "TDATA		VARCHAR(100), ". // table data: ttype,horz,vert (old: +c1,c2,c3,c4), delimited by ':'
		   "TC1		   SMALLINT NOT NULL, ". // table chairs left
		   "TC2		   SMALLINT NOT NULL, ". // table chairs up
		   "TC3		   SMALLINT NOT NULL, ". // table chairs right
		   "TC4		   SMALLINT NOT NULL, ". // table chairs down
		   "PRN_EXECUTE INT NOT NULL DEFAULT 1, ".
		   "PRN_ANALYSIS INT NOT NULL, ". // --> ishop_printpos
		   "PRN_TAX		INT NOT NULL, ". // --> ishop_printpos
		   "PRN_FORTYPE INT NOT NULL, ". // --> ishop_printpos
		   "PRN_PAY		INT NOT NULL, ". // --> ishop_printpos
		   "PRN_INVOICE INT NOT NULL, ". // --> ishop_printpos
		   "LOGINTOGR  VARCHAR(20), ". // for Megatron
		   "MINORDER   NUMERIC(15,4) NOT NULL, ". // Restaurant
		   "AUTOISSUE  TINYINT NOT NULL, ". // Restaurant
		   "AUTOPAY    TINYINT NOT NULL, ". // Restaurant
		   "REMARKS    VARCHAR(100), ".
		   "MAPSQR		VARCHAR(30), ".  // location on wall map (square number)
		   "GMAPLAT    NUMERIC(10,6) NOT NULL, 
		   GMAPLNG     NUMERIC(10,6) NOT NULL, 
		   GMAPZOOM    INT, 
		   ISWHOLESALER   INT NOT NULL, 
		   LASTUPDATE  TIMESTAMP, 
		   PRIMARY KEY (XID), 
		   UNIQUE (AGENTID,LOGIN) ) 
         ENGINE=InnoDb";
   // Loop through both tables
   $ar1=array('ishop_mbr', 'ishop_sup');
   foreach ($ar1 as $t1) {
      $bResetKeys=pre_process_mbr($db,$t1);
      $t2=$t1.'_0';
      if ($bResetKeys) {
         $tb2=array();
         process_meta($db,$tb2,$t1,$query1);
         meta_process_mbr($db,$t1);
      }
      else {
         if (in_array($t2,$tables)) {
            meta_process_mbr($db,$t1);
         }
         process_meta($db,$tables,$t1,$query1);
      }

      $idx=array(
         'k1'=>array('AGENTID', 'NAME', 'LOGIN'),
         'k2'=>array('COMPANY'),
         'k3'=>array('EMAIL'),
         'k4'=>array('AGENTID', 'PLANID', 'LOGIN'),
         'k5'=>array('AGENTID', 'GMAPLAT', 'GMAPLNG'),
         'k6'=>array('AGENTID', 'TRKEY'),
         'k7'=>array('AGENTID', 'LASTUPDATE')
         );
      add_index($db,$t1,$idx);
   }
   //......................................
   // OLD name:
   $t1='ishop_phone';
   if(in_array($t1,$tables)) {
      $query="DROP TABLE ".$t1;
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
   }
   // NEW name:
   $t1='ishop_tel';
   $query="CREATE TABLE $t1 (
      TELID       INT NOT NULL AUTO_INCREMENT,
		AGENTID     INT NOT NULL,
      MBR_LOGIN 	VARCHAR(20) NOT NULL, -- ishop_mbr.LOGIN: Εταιρία
      FIRSTNAME   VARCHAR(80),
      LASTNAME    VARCHAR(80),
      ALIAS       VARCHAR(30),
      TELNR		   VARCHAR(40) NOT NULL, -- Well formatted tel.nr
      TELTYPE     TINYINT NOT NULL DEFAULT 0, -- 0=PSTN, 1=MOBILE, 2=FAX
      MOBILE      VARCHAR(20),
      PHONE1      VARCHAR(30),   
      PHONE2      VARCHAR(20),
      FAX         VARCHAR(20),
      COMPANY     VARCHAR(160), -- Company name
      JOB         VARCHAR(160), -- Company job (activity)
      JOBPOS      VARCHAR(160), -- Job position in company
      ADDR1       VARCHAR(160),
		ADDR2       VARCHAR(160),
		CITY        VARCHAR(80),
		STATE       VARCHAR(80),
		ZIP         VARCHAR(10),
		COUNTRY     VARCHAR(80),
		FLOOR       VARCHAR (20),
		BELL        VARCHAR(40),
		EMAIL       VARCHAR(160),
		WEB         VARCHAR(160),
      COMMENT		VARCHAR(200),
      UNIQUEID    VARCHAR(40),
      PASSWORD    VARCHAR(20),
      UCHKBOX1    VARCHAR(255),
      UFIELD1     VARCHAR(255),
      USRTYPE     INT NOT NULL,
      EMLERROR    VARCHAR(255),    
      EMLERRTIME  DATETIME,
      HTMLEMAIL   TINYINT NOT NULL DEFAULT 1,
      CONFIRMED   TINYINT NOT NULL DEFAULT 1,
      BLACKLISTED TINYINT NOT NULL,
      CREDATE     DATETIME,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (TELID) )
      ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	$idx=array(
         'k1'=>array('AGENTID', 'MBR_LOGIN', 'PHONE1'),
         'k2'=>array('AGENTID', 'PHONE1', 'MBR_LOGIN'),
         'k2'=>array('AGENTID', 'TELNR', 'MBR_LOGIN'),
         'k3'=>array('UNIQUEID'),
         'k4'=>array('AGENTID', 'EMAIL')
         );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_telfind';
   $query="CREATE TABLE $t1 (
      TELID    INT NOT NULL, -- ishop_tel.TELID
      AGENTID  INT NOT NULL,
      TRKEY    VARCHAR(100) NOT NULL, -- Refers to all fields in ishop_tel and ishop_mbr.COMPANY too.
      PRIMARY KEY (TELID, TRKEY) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_tel_login';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      TELID       INT NOT NULL, -- ishop_tel.TELID
      AGENTID     INT NOT NULL,
      LOGDAYTIME  DATETIME NOT NULL, 
      PRIMARY KEY (RID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'LOGDAYTIME'),
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_telgrp';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      GRPID       INT NOT NULL, -- menurep.MENUID (MENUTYPE=12)
      TELID       INT NOT NULL, -- ishop_tel.TELID
      AGENTID     INT NOT NULL,
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, GRPID, TELID ),
      UNIQUE (TELID, GRPID ) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_email_doc';
   $query="CREATE TABLE $t1 (
      MSGID       INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      MSGSUBJECT  VARCHAR(250) NOT NULL,
      MSGTEXT     MEDIUMTEXT,
      CLRTXT      MEDIUMTEXT,
      MSGCREATED  DATETIME NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (MSGID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'MSGCREATED')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_email_to';
   $query="CREATE TABLE $t1 (
      SENDID      INT NOT NULL AUTO_INCREMENT,
      MSGID       INT NOT NULL, -- ishop_email_doc.MSGID
      AGENTID     INT NOT NULL,
      TELID       INT NOT NULL, -- ishop_tel.TELID
      REQUESTED   DATETIME NOT NULL,
      MSGSENT     DATETIME, -- Must be able for NULL
      PRIMARY KEY (SENDID),
      UNIQUE (TELID, MSGID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'MSGSENT', 'MSGID')
      );
   //......................................
   $t1='ishop_mbr_prop';
   $query="CREATE TABLE $t1 ( ".
      "RID        INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID    INT NOT NULL, ".
      "MBR_LOGIN  VARCHAR(20) NOT NULL, ".
      "GCAT       SMALLINT NOT NULL DEFAULT 1, ". // 1=πελατες
      "PNAME      VARCHAR(100), ".
      "PVALUE     VARCHAR(255), ".
      "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (RID), ".
      "UNIQUE (AGENTID, GCAT, MBR_LOGIN, PNAME ) ) ".
      "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_paygroup';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT, 
      AGENTID     INT NOT NULL, 
      PAYGRP      INT NOT NULL, -- ishop_mbr.ISWHOLESALER description: menurep(MENUTYPE=19).MENUID 
      PAYID       INT NOT NULL, -- menurep(MENUTYPE=7).MENUID 
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, PAYGRP, PAYID ) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_ftpuser';
   $query="CREATE TABLE $t1 (
      RID      INT NOT NULL AUTO_INCREMENT,
      UHOST    VARCHAR(120), 
      UNAME    VARCHAR(20),
      UPASS    VARCHAR(20),
      FTPUSER  VARCHAR(100),
      FTPPASS  VARCHAR(20),
      FTPDIR   VARCHAR(200),
      PRIMARY KEY (RID), 
      UNIQUE (UNAME) )    
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);   
   //......................................
   $t1='ishop_delivery';
  	$query="CREATE TABLE $t1 ( 
   	   AGENTID    INT NOT NULL, 
         MBR_LOGIN  VARCHAR(20) NOT NULL, -- ishop_mbr.LOGIN
         DLVID      INT NOT NULL, 
         RESELID    INT NOT NULL, 
         BRANCHNAME VARCHAR(40), 
         ADDR1      VARCHAR(40), 
		   ADDR2      VARCHAR(40), 
		   CITY       VARCHAR(20), 
		   STATE      VARCHAR(20), 
		   ZIP        VARCHAR(10), 
		   COUNTRY    VARCHAR(20), 
		   PHONE      VARCHAR(20), 
		   FAX        VARCHAR(20), 
		   FLOOR      VARCHAR(20), 
		   BELL       VARCHAR(40), 
		   EMAIL      VARCHAR(70) NOT NULL, 
         GMAPLAT    NUMERIC(10,6) NOT NULL, 
		   GMAPLNG    NUMERIC(10,6) NOT NULL, 
		   GMAPZOOM   INT,
		   LASTUPDATE TIMESTAMP, 
		   PRIMARY KEY (AGENTID,MBR_LOGIN,DLVID)) 
		   ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
	$t1='ishop_tplan'; // travel plan
   $remake=false;
   do {
      if ($db->databaseType!='mysqlt' || !in_array($t1,$tables))
         break;

      $cols=$db->MetaColumnNames($t1);
      if (in_array('PLANDAYTIME',$cols)) {
         // Already converted: nothing to do
         break;
      }

		// Drop all indexes, but PRIMARY KEY
		drop_all_indexes($db,$t1);

      $query="ALTER TABLE $t1 ADD PLANDAYTIME DATETIME NOT NULL AFTER AGENTID";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="UPDATE $t1 SET PLANDAYTIME = CONCAT(PLANDATE, ' ',PLANTIME)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $remake=true;
   } while (false);

   do {
      if (!in_array($t1,$tables))
         break;

      $cols=$db->MetaColumnNames($t1);
      if (in_array('PLANDATE',$cols)) {
         break;
      }

      $query="ALTER TABLE $t1 ADD PLANDATE DATETIME";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="ALTER TABLE $t1 ADD PLANTIME INT NOT NULL DEFAULT 0";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="UPDATE $t1 SET PLANDATE = PLANDAYTIME";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="UPDATE $t1 SET PLANTIME = DATE_FORMAT(PLANDAYTIME,'%H%i%s')";
      if (!$db->Execute($query)) {
         //table_terminate($db,$t1,$query);
         $db->ErrorMsg();
      }

   } while (false);

  	$query="CREATE TABLE $t1 (
      PLANID      INT NOT NULL AUTO_INCREMENT,
   	AGENTID     INT NOT NULL, /* Company id */
   	PLANDATE    DATETIME,
   	PLANTIME    INT NOT NULL DEFAULT 0, /* HHMMSS */
   	PLANDAYTIME DATETIME NOT NULL,
   	RESELID     INT NOT NULL, /* Reseller id */
   	LOGIN       VARCHAR(20) NOT NULL, /* Customer code */
		PLACE       VARCHAR(50), /* Place where to meet */
		UNSENT      INT NOT NULL, /* Internal system usage */
		LASTUPDATE  TIMESTAMP,
		PRIMARY KEY (PLANID),
		UNIQUE (AGENTID,PLANDAYTIME,RESELID,LOGIN) )
		ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);

   if ($remake) {
      $query="ALTER TABLE $t1 ADD UNIQUE (AGENTID,PLANDAYTIME,RESELID,LOGIN)";
   	if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='ishop_cunotitle';
   $query="TITLEID    INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID     INT NOT NULL, ".
         "TITLEDES    CHAR(64) NOT NULL, ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (TITLEID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_cunote'; // customer notes
   $remake=false;
   do {
	   if ($db->databaseType!='mysqlt' || !in_array($t1,$tables))
	      break;

	   $cols=$db->MetaColumnNames($t1);
      if (in_array('CREDAYTIME',$cols)) {
         // Already converted: nothing to do
         break;
      }

      // Drop all indexes, but PRIMARY KEY
		drop_all_indexes($db,$t1);

      $query="ALTER TABLE $t1 ADD CREDAYTIME DATETIME NOT NULL AFTER AGENTID";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="UPDATE $t1 SET CREDAYTIME = CONCAT(CREDATE, ' ', CRETIME)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $remake=true;
   } while (false);

  	$query="NOTEID  INT NOT NULL AUTO_INCREMENT, ".
   	   "AGENTID INT NOT NULL, ".
   	   /*
   	   "CREDATE DATE NOT NULL, ".
   	   "CRETIME TIME NOT NULL, ".
   	   */
   	   "CREDAYTIME DATETIME NOT NULL, ".
   	   "RESELID   INT NOT NULL, ". // --> Reseller 0=Admin
   	   "LOGIN     VARCHAR(20) NOT NULL, ". // --> Member
   	   "REFID     INT NOT NULL, ". // reference id of another NOTEID
   	   "NOTETITLE VARCHAR(64) NOT NULL, ".
   	   "TITLEID   INT NOT NULL, ".
			"NOTETXT   TEXT, ".
			"LASTUPDATE TIMESTAMP, ".
			"PRIMARY KEY (NOTEID) ) ".
			"ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'LOGIN', 'CREDAYTIME')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_cuvisit';
   $query="CREATE TABLE $t1 (
      VISITID  INT NOT NULL AUTO_INCREMENT,
      AGENTID INT NOT NULL,
      LOGIN VARCHAR (20) NOT NULL, -- ishop_mbr.MBR_LOGIN
      VISDAYTIME DATETIME NOT NULL,
      RESELID INT NOT NULL,
      REASON  INT NOT NULL,  /* 0=just visit, 1=put an order, 2=cash collection, 3=other reason, 4=Add notes, 5=questionaire, 6=planed visit */
      COMMENT VARCHAR(250),
      ORDERID INT NOT NULL,
      NOTEID  INT NOT NULL,
      QINID   INT NOT NULL, -- ishop_crm_gethead.QINID
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY(VISITID),
      UNIQUE (AGENTID, LOGIN, VISDAYTIME) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Question groups
   $t1='ishop_crm_group';
  	$query="CREATE TABLE $t1 (
   	AGENTID    INT NOT NULL,
   	QGRPID     INT NOT NULL,
   	GRPDES     VARCHAR(100) NOT NULL,
		PRIMARY KEY(AGENTID,QGRPID) )
		ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................
   // Question titles
   $t1='ishop_crm_question';
  	$query="CREATE TABLE $t1 ( ".
         "AGENTID    INT NOT NULL, ".
         "QUEID      INT NOT NULL, ".
         "QUEDES     VARCHAR(100) NOT NULL, ".
         "QUETYPE    INT NOT NULL, ".  // 0/1/2/(3)=TEXT/CHECK BOX/TEXTAREA/(ANALYTIC)
         "QUEMAX     INT NOT NULL, ".  // max length for text input, or max lines
         "QGRPID     INT NOT NULL, ".  // presenting group
         "QUESEL     TEXT, ".
         "PRIMARY KEY(AGENTID,QUEID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Question gather
   $t1='ishop_crm_gather';
   if (in_array($t1,$tables)) {
      $query="DROP TABLE $t1"; // 20-10-2005
      if (!$db->Execute($query))
      	table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='ishop_crm_gethead';

   $remake=false;
   do {
   	if ($db->databaseType!='mysqlt' || !in_array($t1,$tables))
   	   break;

      $cols=$db->MetaColumnNames($t1);
      if (in_array('CREDAYTIME',$cols)) {
         // Already converted: nothing to do
         break;
      }

      // Drop all indexes, but PRIMARY KEY
		drop_all_indexes($db,$t1);

      $query="ALTER TABLE $t1 ADD CREDAYTIME DATETIME NOT NULL AFTER AGENTID";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $query="UPDATE $t1 SET CREDAYTIME = CONCAT(CREDATE, ' ', CRETIME)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);

      $remake=true;
   } while (false);

   $query="CREATE TABLE $t1 ( ".
   	   "QINID     INT NOT NULL AUTO_INCREMENT, ".
   	   "AGENTID   INT NOT NULL, ".
   	   "CREDAYTIME DATETIME NOT NULL, ".
   	   "MBR_LOGIN VARCHAR(20) NOT NULL, ". // --> xxxxx_mbr.LOGIN
   	   "RESELID   INT NOT NULL, ".        // --> Reseller 0=Admin
   	   "PRIMARY   KEY(QINID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'MBR_LOGIN', 'CREDAYTIME', 'QINID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_crm_getitem';
   $query="CREATE TABLE $t1 ( ".
   	   "QINID  INT NOT NULL, ". // --> "ishop_crm_gethead"
   	   "QUEID INT NOT NULL, ".
   	   "QINTEXT TEXT, ".
   	   "PRIMARY KEY(QINID, QUEID) ) ".
   	   "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_msg_main';
  	$query="CREATE TABLE $t1 ( ".
         "MSGID 		INT NOT NULL AUTO_INCREMENT, ".
         "AGENTID 	INT NOT NULL, ".
         "MSGTEXT2 	MEDIUMTEXT, ".
         "LASTUPDATE TIMESTAMP, ". // effectively, date of creation
         "PRIMARY KEY (MSGID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_msg_to';
  	$query="CREATE TABLE $t1 ( ".
         "MSGID 		INT NOT NULL, ". // --> ishop_msg_main
         "RESELID 	INT NOT NULL, ". // --> reseller
         "ARRIVED		DATETIME, ".
         "PRIMARY KEY (MSGID, RESELID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_prspec';
  	$query="CREATE TABLE $t1 ( ".
         "AGENTID    INT NOT NULL, ".
         "SPECID     INT NOT NULL, ". // αριθμος εντυπου <--> issuedoc.SPECID
         "SPECKEY    VARCHAR(100) NOT NULL, ".
         "SPECTYPE   INT NOT NULL, ". // see below
         "PRGROUP    INT NOT NULL, ".  // 0,1,2,3,4=1st page, header, items, footer, last page (spectype=normal)
         "PRROW      INT NOT NULL, ".    // valid values: >=1
         "PRCOL      INT NOT NULL, ".    // valid values: >=1
         "PRWIDTH    INT NOT NULL, ".  // πλατος πεδιου (>0)
         "PRALIGN    SMALLINT NOT NULL, ". // 0/1=Left/Right
         "PRDECIMAL  SMALLINT NOT NULL, ". // NUMERIC points
         "PRTHOUSEP  CHAR(1) NOT NULL, ".  // thousand separator
         "PRDECSEP   CHAR(1) NOT NULL DEFAULT ',', ". // NUMERIC separator
         "PROFFSET   SMALLINT NOT NULL, ".
         "PRTEXT     VARCHAR(200), ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (AGENTID, SPECID, SPECKEY) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   /*
     	SPECTYPE = 0: normal
		SPECTYPE = 1: user text (SPECKEY=1,2,3... -> usertext1, usertext2,...)
		SPECTYPE = 2 (specific)
					    SPECKEY = I_Design_Name : PRTEXT=ονομασία σχεδίου
					    SPECKEY = I_Design_Type : PRGROUP=τυπος σχεδιου (0=Τιμολογηση, 1=Αποδείξεις)
						                           PRTEXT=περιγραφή τυπου σχεδιου
	*/
   //......................................
   $t1='ishop_prpre';
   $query="PRID INT NOT NULL, ".// ID for a group of records
      "PRTYPE INT NOT NULL, ".  // 1=Execute, 2=TaxSpooler, 3=Analysis, 4=Payment, 5=POS
      "PRDONE INT NOT NULL, ".  // 0=No, 1=Yes, 98=inserting records in progress, 99=processing in progress
      "PRSIGN INT, ".           // error (status) return from getSignature (default=null)
      "PRINTSEQ INT NOT NULL, ".
      "ORDERID INT NOT NULL, ".
      "ORDLINE INT NOT NULL, ".
      "SUBID INT NOT NULL, ".
      "PRINTPOS INT NOT NULL, ". // --> ishop_printpos
      "FLEXNO INT NOT NULL, ".
      "INAME VARCHAR(120), ". // item name (may be not in main language)
      "SRVHOST VARCHAR(100), ". 	// from ishop_printpos
      "SRVPORT INT NOT NULL, ".	// from ishop_printpos
      "PRCOMMAND TEXT, ".
      "PRPARAM TEXT, ".
      "PRMAKEDAYTI DATETIME NOT NULL, ".
      "PRCOMMENT  VARCHAR(255), ".
      "PRIMARY KEY(PRID, ORDLINE, SUBID) ) ".
      "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   // revision 10-1-2006
   $mi1=$db->MetaPrimaryKeys($t1);
   if ($mi1!==false && in_array('ORDERID', $mi1)) {
		$query="ALTER TABLE $t1 DROP PRIMARY KEY, ADD PRIMARY KEY (PRID, ORDLINE, SUBID)";
      if (!$db->Execute($query))
         table_terminate($db,$t1,$query);
	}

	$idx=array(
      'k1'=>array('PRDONE', 'PRINTPOS', 'PRID', 'PRINTSEQ', 'ORDLINE', 'SUBID')
      );
   add_index($db,$t1,$idx);
	//......................................
	$t1='ishop_filo_bill';
	$query="CREATE TABLE $t1 ( ".
		"AGENTID 		INT NOT NULL, ".
		"MBR_LOGIN     VARCHAR(20) NOT NULL, ". // --> ishop_mbr (αριθμός τραπεζιού)
		"REQUESTDAYTI	DATETIME NOT NULL, ".
		"ANSWERDAYTI	DATETIME, ".
		"AMOUNT			NUMERIC(15,2) NOT NULL, ".
		"FREQUESTCLOSE TINYINT NOT NULL, ". // Filoxenia delayed payment
		"FROOMNR       INT, ".              // Filoxenia delayed payment
		"FACCOUNT      VARCHAR(40), ".      // Filoxenia delayed payment
		"FPAYMETHOD    INT, ".              // Filoxenia delayed payment
		"PRIMARY KEY (AGENTID, MBR_LOGIN) ) ".
		"ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	check_for_nulldate($db, $t1, array('ANSWERDAYTI') );
	//......................................
	$t1='ishop_filo_room';
	$query="CREATE TABLE $t1 ( ".
		"AGENTID 		INT NOT NULL, ".
		"ACCOUNT			VARCHAR(40) NOT NULL, ".
		"ROOMNR 			INT NOT NULL, ".
		"FULLNAME		VARCHAR(100), ".
		"DEAL				VARCHAR(20), ".
		"DEALBR			VARCHAR(20), ".
		"DEALME			VARCHAR(20), ".
		"DEALDI			VARCHAR(20), ".
		"LASTUPDATE 	TIMESTAMP, ".
		"PRIMARY KEY (AGENTID, ACCOUNT) ) ".
		"ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................
   //
   // clear old session data (passed 3 hours)
   //
   $session=array();
   $query="SELECT SESSIONID FROM session WHERE CREDAYTIME < ?";
   $data=array( date('Y-m-d H:i;s',time()-3*3600) );
   if ($rs=$db->Execute($query,$data)) {
   	while ($row=$rs->FetchRow()) {
      	$session[]=$row[0];
      }
      $rs->Close();
   }
   foreach ($session as $sessionid) {
   	$query="DELETE FROM session WHERE SESSIONID=".$sessionid;
      $db->Execute($query);
      $query="DELETE FROM session_data WHERE SESSIONID=".$sessionid;
      $db->Execute($query);
   }

	$t1='ishop_cedata';
  	$query="LOGID INT NOT NULL AUTO_INCREMENT, ".
   		"LOGPROG  VARCHAR(200) NOT NULL, ".
   		"REMOTEADDR VARCHAR(50) NOT NULL, ".
   		"LOGTIME DATETIME NOT NULL, ". // server based
   		"RETTIME DATETIME, ".
   		"DATAIN MEDIUMTEXT, ".
   		"DATAOUT MEDIUMTEXT, ".
   		"OUTSIZE  INT NOT NULL, ".
         "PRIMARY KEY (LOGID), ".
			"UNIQUE (LOGTIME,LOGID) ) ".
			"ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   check_for_nulldate($db, $t1, array('RETTIME') );
   //....................................
   $t1='ishop_cartlog';
  	$query="LOGID      INT NOT NULL AUTO_INCREMENT, ".
  	      "AGENTID     INT NOT NULL, ".
  	      "FUNC        INT NOT NULL, ".
   		"REMOTEHOST  VARCHAR(80) NOT NULL, ".
   		"DELTA1      REAL NOT NULL, ".
   		"DELTA2      REAL NOT NULL, ".
   		"DELTA3      REAL NOT NULL, ".
   		"DATAIN      MEDIUMTEXT, ".
   		"LASTUPDATE  TIMESTAMP, ".
         "PRIMARY KEY (LOGID) ) ".
			"ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //....................................
   $t1='ishop_cart_query';
  	$query="CREATE TABLE $t1 (
      ID          INT NOT NULL AUTO_INCREMENT, 
  	   AGENTID     INT NOT NULL,
  	   FIRSTID     INT NOT NULL,
  	   PNAME       VARCHAR(100) NOT NULL,
  	   PVALUE      VARCHAR(255),
  	   LASTUPDATE  TIMESTAMP,
  	   PRIMARY KEY (ID) )
      ENGINE=InnoDb"; 
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'FIRSTID', 'PNAME')
      );
   add_index($db,$t1,$idx);
   //....................................
   // Alias θέσων εκτυπωτών (πχ. bar, κουζίνα, κλπ.)
   $t1='ishop_printpos';
  	$query="CREATE TABLE $t1 (
      AGENTID        INT NOT NULL, 
      PRINTPOS       INT NOT NULL, 
   	POSNAME        VARCHAR(100), 
   	SRVHOST        VARCHAR(100), -- RestauPrint server
   	SRVPORT        INT NOT NULL DEFAULT 11000, 
   	XTR_EXEC_CPY   INT NOT NULL,
   	PRCOMMAND      TEXT, 
   	PRPARAM        TEXT, 
   	LASTUPDATE     TIMESTAMP, 
      PRIMARY KEY (AGENTID, PRINTPOS) )
      ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	//......................................
	$t1='ishop_exeplace';
	$query='ID     INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      PRSEQUENCE  INT NOT NULL,
      EXEPLACE    INT NOT NULL, -- menurep.MENUID (MENUTYPE=14)
      PRINTPOS    INT NOT NULL, -- ishop_printpos.PRINTPOS
      PRIMARY KEY (ID),
      UNIQUE (AGENTID, PRSEQUENCE, EXEPLACE) )
      ENGINE=InnoDb';
   process_meta($db,$tables,$t1,$query);
	//......................................
   $t1='ishop_docs';
   $query="CREATE TABLE $t1 (
      RID      INT NOT NULL AUTO_INCREMENT,
      AGENTID  INT NOT NULL,
      DOCID    INT NOT NULL,
      LANGID   INT NOT NULL,
      LISTINCAT  TINYINT NOT NULL DEFAULT 1, -- εμφάνιση στον κατάλογο
      DOCTITLE VARCHAR(100),
      PAGEIDS  VARCHAR(100) NOT NULL,
      PAGEROW  INT NOT NULL DEFAULT 1,
      PAGECOL  INT NOT NULL DEFAULT 1,
      DOCTEXT  MEDIUMTEXT,
      LASTUPDATE TIMESTAMP,
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, DOCID, LANGID) ) 
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'LANGID', 'PAGEIDS', 'PAGEROW', 'PAGECOL')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='phplist_user_login';
   $query="CREATE TABLE $t1 (
      EMAIL       VARCHAR(240) NOT NULL,
      CREDAYTIME  DATETIME NOT NULL,
      PRIMARY KEY (EMAIL, CREDAYTIME) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   /*
	***                   ***
	***    barcode data   ***
	***                   ***
	*/
   $t1='ishop_barenc';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      DATABYTES   MEDIUMTEXT,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (RID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
	//......................................
   /*
	***              ***
	***    Project   ***
	***              ***
	*/
	$t1='ishop_project';
	$query="CREATE TABLE $t1 ( ".
	   "RID       INT NOT NULL AUTO_INCREMENT, ".
	   "AGENTID   INT NOT NULL, ".
	   "LEVEL     INT NOT NULL, ".
	   "SUBLEVEL  INT NOT NULL, ".
	   "TITLE     VARCHAR(100), ".
	   "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (RID), ".
      "UNIQUE (AGENTID, LEVEL, SUBLEVEL) ) ".
      "ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................
	$t1='ishop_projwho';
	$query="CREATE TABLE $t1 ( ".
	   "RID       INT NOT NULL, ". // <--> ishop_project.RID
	   "RESELID   INT NOT NULL, ". // <--> reseller.RESELID
	   "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (RID, RESELID) ) ".
      "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_projtodo';
   $query="CREATE TABLE $t1 ( ".
      "TODOID     INT NOT NULL AUTO_INCREMENT, ".
      "AGENTID		INT NOT NULL, ".
      "LEVEL		INT NOT NULL, ". // priority is applied per LEVEL
      "SUBLEVEL	INT NOT NULL, ".
      "DATEOPEN   DATETIME NOT NULL, ".
      "PRIORITY   INT NOT NULL, ".
      "CREATOR		INT NOT NULL, ". // reselid
      "STATUS     SMALLINT NOT NULL, ". // 1=closed
      "LASTPRICHANGE DATETIME, ".
      "LASTWHOCHANGE INT NOT NULL, ". // reselid
      "DESCR      MEDIUMTEXT, ".
      "PRIMARY KEY (TODOID), ".
		"UNIQUE (AGENTID, LEVEL, PRIORITY) ) ".
      "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_projtodoex';
   $query="CREATE TABLE $t1 ( ".
      "TDEXID     INT NOT NULL AUTO_INCREMENT, ".
      "TODOID     INT NOT NULL, ".  // <--> ishop_projtodo.TODOID
      "CREATOR		INT NOT NULL, ". 	// reselid
      "FILETYPE   VARCHAR(20), ".
      "DATAEX     MEDIUMBLOB, ".
      "LASTUPDATE TIMESTAMP, ".
      "PRIMARY KEY (TDEXID) ) ".
      "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('TODOID', 'TDEXID')
      );
   add_index($db,$t1,$idx);
   //......................................
   // MPRFLAGS values (ORed):
   // 1=Dragable Map, 2=Large map control, 4=Scale control, 8=Map type control,
   // 16=Overview control, 32=Custom xzoom control
   $t1='ishop_maproute'; // Διαδρομη στον χάρτη; ανήκει σε ένα δρομολόγιο; το δρομολόγιο μπορεί να έχει πολλές διαδρομές
   $query="CREATE TABLE $t1 (
      MPROUTEID   INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      GPOSFROM    VARCHAR(100), -- Google (center) start pos = 'lat:lng:zoom'
      GPOS        VARCHAR(100), -- Google (center) final pos = 'lat:lng:zoom'
      GPOSLIMIT   VARCHAR(100), -- Google (bounds) final pos = 'NorthEast_lat:lng:SouthWest_lat:lng'
      MPRNAME     VARCHAR(200), -- Route name
      MPWIDTH     INT NOT NULL,
      MPHEIGHT    INT NOT NULL,
      MPRTYPE     INT NOT NULL, -- 0/1=single, connected points
      MPRSTATE    INT NOT NULL, -- 0/1/2=Map/Satellite/Hybrid
      MPRDATA     INT NOT NULL, -- 0/1/2=data by points, all customers, specific customers
      MPRFLAGS    INT NOT NULL, -- (see description)
      GMARKER     INT NOT NULL,
      ITINERID    INT NOT NULL, -- ishop_itenerary.ITINERID (itenerary where it belongs to)
      TOTLEN      INT NOT NULL, -- total length
      PRIMARY KEY (MPROUTEID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //---
   $idx=array(
      'k1'=>'AGENTID, MPRNAME, MPROUTEID',
      'k2'=>'AGENTID, ITINERID'
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_mprpoint'; // derived from ishop_mappoint
   $query="CREATE TABLE $t1 (
      MPID        INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      EXTERNID    VARCHAR(64) NOT NULL,   
      MPROUTEID   INT NOT NULL, -- 2: ishop_maproute.MPROUTEID
      MPAA        INT NOT NULL, -- 2: 1,2,3...
      MPLATITUDE  NUMERIC(15,10) NOT NULL,
      MPLONGITUDE NUMERIC(15,10) NOT NULL,
      MPNAME      VARCHAR(200),
      MPDESC      MEDIUMTEXT,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (MPID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>'MPROUTEID, MPAA',
      'k2'=>'AGENTID, MPNAME',
      'k3'=>'AGENTID, EXTERNID'
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_maproutept';
   if (in_array($t1,$tables)) {
      if (convert_maproutept($db)) {   
         $ar1=array('ishop_maproutept', 'ishop_mappoint');
         foreach ($ar1 as $t1) {
            $query="DROP TABLE $t1";
            if ($db->Execute($query))
               echo "<h6>Dropped table $t1</h6>";
            else
               table_terminate($db,$t1,$query);
         }
      }
   }
   $t1='ishop_gmprogram'; // external update only
   $query="CREATE TABLE $t1 (
      PROGID         INT NOT NULL AUTO_INCREMENT,
      AGENTID        INT NOT NULL,
      EXTMASTER      VARCHAR(64),   -- ishop_mprpoint.EXTERNID
      NDATE          INT NOT NULL,  -- YYYMMDD (local date)
      NTIME          INT  NOT NULL, -- HHMM (local time)
      EXTDETAIL      VARCHAR(64),   -- ishop_mprpoint.EXTERNID
      EXTDRIVER      VARCHAR(64),   -- ishop_gmdriver.EXTERNID
      EXTOBJECT      VARCHAR(64),   -- ishop_gmobject.EXTERNID
      ROUTENAME      VARCHAR(200),  -- Route name (ishop_maproute.MPRNAME)
      MPROUTEID      INT NOT NULL DEFAULT 0, -- ishop_maproute.MPROUTEID
      TICKETS        INT NOT NULL,
      RESERVATION    INT NOT NULL,
      AVAILABLE      INT NOT NULL,
      FULLNESS       NUMERIC(8,2), -- fullness percentage
      FORDEL         TINYINT NOT NULL DEFAULT 0,
      LASTUPDATE     TIMESTAMP, 
      PRIMARY KEY (PROGID),     
      UNIQUE (AGENTID, EXTMASTER, NDATE, EXTDETAIL, NTIME ) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>'AGENTID, MPROUTEID, ROUTENAME'
      );
   //......................................
   $t1='ishop_gmdriver'; // Οδηγοί οχημάτων
   $query="CREATE TABLE $t1 (
      DRVID       INT NOT NULL AUTO_INCREMENT, -- Object Id
      AGENTID     INT NOT NULL,
      EXTERNID    VARCHAR(64) NOT NULL DEFAULT '',
      FULLNAME    VARCHAR(100) NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (DRVID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>'AGENTID, EXTERNID'
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_gmobject'; // Αντικείμενο παρακολούθησης, π.χ. αυτοκινητο
   $query="CREATE TABLE $t1 (
      OBJID       INT NOT NULL AUTO_INCREMENT, -- Object Id
      AGENTID     INT NOT NULL,
      EXTERNID    VARCHAR(64) NOT NULL DEFAULT '',
      ROBJECT     VARCHAR(100) NOT NULL, -- description
      OBJCODE     VARCHAR(100), -- object (i.e.) vehicle code
      GMARKER     INT NOT NULL,
      /*
      DRVID       INT NOT NULL, -- current driver (ishop_gmdriver.DRVID)
      */
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (OBJID),
      UNIQUE (AGENTID, ROBJECT) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>'AGENTID, EXTERNID'
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_gmimei';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      IMEI        VARCHAR(250) NOT NULL, -- IMEI or PDA serial
      OBJID       INT NOT NULL,          -- ishop_gmobject.OBJID
      RACTIVE     TINYINT NOT NULL,
      TIMEDELTA   INT NOT NULL, -- add this to modem's time to get real time
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (IMEI) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_gmrecord';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      OBJID       INT NOT NULL,  -- ishop_gmobject.OBJID
      DRVID       INT NOT NULL,  -- current driver (ishop_gmdriver.DRVID)
      MPROUTEID   INT NOT NULL DEFAULT 0, -- ishop_maproute.MPROUTEID
      RTIMESTAMP  REAL NOT NULL, -- UTC unix timestamp
      RPRIORITY   INT NOT NULL,
      RLONGITUDE  REAL NOT NULL,
      RLATITUDE   REAL NOT NULL,
      RALTITUDE   INT  NOT NULL, -- meters
      RANGLE      INT NOT NULL, -- degrees
      RSATELITES  SMALLINT NOT NULL,
      RSPEED      INT NOT NULL, -- km/hour
      RDISTPROC   TINYINT NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (RID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //---
   $idx=array(
      'k1'=>array('AGENTID', 'OBJID', 'RTIMESTAMP'),
      'k2'=>array('AGENTID', 'RTIMESTAMP'),
      'k3'=>array('AGENTID', 'RDISTPROC', 'OBJID', 'RTIMESTAMP')
   );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_gmdistance';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      OBJID       INT NOT NULL,  -- ishop_gmobject.OBJID
      DRVID       INT NOT NULL,  -- ishop_gmdriver.DRVID
      MPROUTEID   INT NOT NULL,  -- ishop_maproute.MPROUTEID  
      RHOURSTAMP  INT NOT NULL,
      RDISTANCE   REAL NOT NULL, -- km
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (RID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //---
   $idx=array(
      //'k1'=>array('AGENTID', 'ROBJECT', 'RTIMESTAMP'),
      'k1'=>array('AGENTID', 'OBJID', 'RHOURSTAMP'),
      'k2'=>array('AGENTID', 'DRVID', 'RHOURSTAMP')
   );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_gmfence';
   $query="CREATE TABLE $t1 (
		FID          INT NOT NULL AUTO_INCREMENT,
		AGENTID      INT NOT NULL,
		OBJID        INT NOT NULL,  -- ishop_gmobject.OBJID
		ISGEOFENCE   TINYINT NOT NULL,
		TOPLEFTLONG  REAL NOT NULL,
		TOPLEFTLAT   REAL NOT NULL,
		BTMRIGHTLONG REAL NOT NULL,
		BTMRIGHTLAT  REAL NOT NULL,
		MAXSPEED     INT NOT NULL,
		FTITLE       VARCHAR(200),
		LASTUPDATE   TIMESTAMP,
		PRIMARY KEY (FID),
      UNIQUE (AGENTID, OBJID, TOPLEFTLONG, TOPLEFTLAT, BTMRIGHTLONG, BTMRIGHTLAT) )
		ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_itinerary'; // Vehicle itinerary (δρομολόγιο, πχ. ΑΘΗΝΑ-ΘΕΣ/ΝΙΚΗ-ΑΘΗΝΑ)
   $query="CREATE TABLE $t1 (
      ITINERID    INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      RNAME       VARCHAR(120),
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (ITINERID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_veitiner'; // Assign itineraries to vehicles (a vehicle may travel to multiple itineraries, and and itinerary may have multiple vehicles)
   $query="CREATE TABLE $t1 (
      VEITID      INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      OBJID       INT NOT NULL, -- ishop_gmobject.OBJID
      ITINERID    INT NOT NULL, -- ishop_itinerary.ITINERID
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (VEITID),
      UNIQUE (AGENTID, OBJID, ITINERID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>"AGENTID, ITINERID, OBJID"
   );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_itiroute'; // routes that belong to itinerary
   if (in_array($t1,$tables)) {
   	$query="DROP TABLE $t1";
      if ($db->Execute($query))
         echo "<h6>Dropped table $t1</h6>";
      else
         table_terminate($db,$t1,$query);
   }
   //......................................
   $t1='lex_main';
   $query="CREATE TABLE $t1 (
		LEXID INT NOT NULL AUTO_INCREMENT,
		LEXTITLE VARCHAR(150),
		LEXIMGURL	VARCHAR(150),
		LEXHEADER MEDIUMTEXT,
		PRIMARY KEY (LEXID) )
		ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   //......................................ΚΡΑΤΗΣΕΙΣ............................
   $t1='ishop_res_event';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      EVENTID     INT NOT NULL, -- menurep.(MENUTYPE=18).MENUID
      PLANID      INT NOT NULL,
      STARTDATE   DATETIME NOT NULL,
      DURATION    INT NOT NULL, -- duration in hours
      PRIMARY KEY (RID),
      UNIQUE (AGENTID, STARTDATE, PLANID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_res_avail';
   $query="CREATE TABLE $t1 (
      AVAILID     INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL, 
      PLANID      INT NOT NULL,
      DAYTIMEFROM DATETIME NOT NULL,
      MAXPERSON   TINYINT NOT NULL,
      MINPERSON   TINYINT NOT NULL DEFAULT 1,
      DURATION    TINYINT NOT NULL, -- duration in hours
      AVAILABLE   INT NOT NULL,
      RESERVED    INT NOT NULL,
      PPRICE      NUMERIC(15,2) NOT NULL, -- per person price
      PRIMARY KEY (AVAILID),
      UNIQUE (AGENTID, DAYTIMEFROM, PLANID, MAXPERSON, MINPERSON) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_res_tables';
   $query="CREATE TABLE $t1 (
      AGENTID     INT NOT NULL,
      AVAILID     INT NOT NULL,
      TABLENO     VARCHAR(20),
      DAYTIMEFROM DATETIME NOT NULL,
      STATE       INT NOT NULL, -- 1=available to users, 2=user working, 3=user reserved 
      ORDERID     INT NOT NULL,
      ORDLINE     INT NOT NULL, -- one ORDLINE may have multiple tables
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (AVAILID, TABLENO),
      UNIQUE (AGENTID, DAYTIMEFROM, TABLENO) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('ORDERID', 'ORDLINE', 'TABLENO')
   );
   add_index($db,$t1,$idx);
   //......................................
   $t1='ishop_res_ordmain';
   $query="CREATE TABLE $t1 (
      ORDERID     INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      RESVID      INT NOT NULL, -- reservation id (complementary with orderid)
      MBR_LOGIN   VARCHAR(20) NOT NULL, -- ishop_mbr.LOGIN
      LOGTIME     DATETIME NOT NULL,
      RSVTIME     DATETIME,
      STATE       INT NOT NULL, -- 0=just requested, [1=reserved, but no payment yet], 2=payment verified
      TABLETOT    INT NOT NULL,
      PERSONTOT   INT NOT NULL,
      VALUETOTAL  NUMERIC(15,3),
      PRIMARY KEY (ORDERID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='ishop_res_ordline';
   $query="CREATE TABLE $t1 (
      ORDERID     INT NOT NULL,
      ORDLINE     INT NOT NULL, -- 1,2,3,...
      AGENTID     INT NOT NULL,
      AVAILID     INT NOT NULL,
      PERSON      INT NOT NULL,
      PPRICE      NUMERIC(15,4), -- per person price
      QREQUEST    INT NOT NULL,  -- quantity requested
      RESVDONE    TINYINT NOT NULL, -- Reservation done: 0/1= No/yes
      PRIMARY KEY (ORDERID, ORDLINE),
      UNIQUE (ORDERID, AVAILID, PERSON) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //...........................................................................
   $t1='ishop_res_orditem';
   if (in_array($t1,$tables)) {
      $query="DROP TABLE $t1";
      if (!$db->Execute($query))
         echo "<h6>".$db->ErrorMsg()."</h6>";
   }
   //...........................................................................
   $t1='lex_thema';
   $query="CREATE TABLE $t1 (
   	THMID INT NOT NULL AUTO_INCREMENT,
   	LEXID INT NOT NULL, -- lex_main.LEXID
   	LEVEL1 INT NOT NULL,
   	LEVEL2 INT NOT NULL,
   	LEVEL3 INT NOT NULL,
   	LEVEL4 INT NOT NULL,
   	THMTYPE INT NOT NULL, -- 0/1/2 = generic/admin/user comment
   	THMTITLE VARCHAR(150),
   	THMTEXT MEDIUMTEXT,
   	PRIMARY KEY (THMID),
		UNIQUE (LEXID, LEVEL1, LEVEl2, LEVEL3, lEVEL4) )
		ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
   /*
	***              ***
	***    iupdate   ***
	***              ***
	*/
	// ΘΕΣΗ ΠΡΟΓΡΑΜΜΑΤΩΝ ΣΤΟν WEB SERVER
	$t1='iupd_main';
   $query="CREATE TABLE $t1 (
      PROGID      VARCHAR(50) NOT NULL,
      VERLOCATION VARCHAR(255),
      VERPREPEND  VARCHAR(255),
      UPDLOCATION VARCHAR(255),
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (PROGID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // Queries
   $t1='iupd_qrylog';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      SERVERLOG   MEDIUMTEXT,
      REQUESTLOG  MEDIUMTEXT,
      PCID        INT,
      REMOTEPC    VARCHAR(255), -- Remote Host or Address
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (RID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('LASTUPDATE'),
      'k2'=>array('PCID', 'RID'),
      'k3'=>array('REMOTEPC', 'RID')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='iupd_qrylog_ex';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL, -- iupd_qrylog.RID
      SEQ         INT NOT NULL, -- 0,1,2,...
      PROG        VARCHAR(200),
      VERSION     VARCHAR(200),
      SERIAL      VARCHAR(200),
      PRIMARY KEY (RID, SEQ) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('PROG', 'RID'),
      'k2'=>array('VERSION', 'RID'),
      'k3'=>array('SERIAL', 'RID')
      );
   add_index($db,$t1,$idx);
   //......................................
   // Καταγραφή PCIDs
   $t1='iupd_pcid';
   $query="CREATE TABLE $t1 (
      PCID        INT NOT NULL AUTO_INCREMENT,
      REMOTEHOST  VARCHAR(255),
      REMOTEADDR  VARCHAR(255),
      COMMENT     VARCHAR(255),
      FIRSTQUERY  DATETIME,
      LASTQUERY   DATETIME,
      NRQUERY     INT NOT NULL DEFAULT 0,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (PCID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='iupd_msg';
   $query="CREATE TABLE $t1 (
      MSGID       INT NOT NULL AUTO_INCREMENT,
      MSGREF      INT NOT NULL, -- parent message id
      PCID        INT NOT NULL,
      ADMREAD     TINYINT NOT NULL,
      USREAD      TINYINT NOT NULL,
      PROGID      VARCHAR(50),
      USERID      VARCHAR(100), -- WEB Admin or something else
      MSGTITLE    VARCHAR(255),
      MSGTEXT2    MEDIUMTEXT,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (MSGID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('LASTUPDATE'),
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='iupd_msg_att';
   $query="CREATE TABLE $t1 (
      ATTID       INT NOT NULL AUTO_INCREMENT,
      MSGID       INT NOT NULL, -- iupd_msg.MSGID
      FILENAME    VARCHAR(200),
      FILERROR    INT,
      DATABYTES   INT NOT NULL,
      HASHTOTAL   VARCHAR(50),
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (ATTID),
      UNIQUE (MSGID, ATTID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('MSGID', 'FILENAME'),
      );
   add_index($db,$t1,$idx);
   //......................................
   // Τύποι προγραμμάτων (περιγραφές module)
   $t1='ser_item';
   $query="CREATE TABLE $t1 (
      ser_progid VARCHAR(50), -- i.e. taxspooler
   	ser_itemid INT NOT NULL,  -- 250,260,270...=TaxSpooler
   	ser_desc VARCHAR(80), -- description
   	LASTUPDATE  TIMESTAMP,
   	PRIMARY KEY (ser_progid, ser_itemid) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // ΑΔΕΙΕΣ / ΕΚΔΟΣΗ (χορηγηθείσες)
	$t1="ser_version";
	$query="CREATE TABLE $t1 (
      ser_progid     VARCHAR(50), -- i.e. taxspooler
   	ser_itemid     INT NOT NULL,  -- 250,260,270...=TaxSpooler
   	ser_serial     VARCHAR(40) NOT NULL,
   	ser_version    VARCHAR(20) NOT NULL, -- TaxSpooler: μεγαλύτερη από 2.4.1.1
   	ser_date       DATETIME NOT NULL, -- ημ/νία δημιουργίας version
   	ser_vactkey    VARCHAR(100) NOT NULL, -- activation key Non-INCA, i.e. Orbis
      ser_transid    INT NOT NULL,
   	PRIMARY KEY (ser_progid, ser_itemid, ser_serial, ser_version) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   // ΑΔΕΙΕΣ ΠΑΛΙΟΥ ΤΥΠΟΥ
	$t1="ser_data";
	$query="CREATE TABLE $t1 (
	   ser_progid       VARCHAR(50), -- i.e. taxspooler
   	ser_itemid       INT NOT NULL, --  250,260,270...=TaxSpooler
   	ser_serial       VARCHAR(40) NOT NULL,
   	ser_date         DATETIME NOT NULL, -- ημ/νία δημιουργίας του activation key
   	ser_actkey       VARCHAR(100) NOT NULL, -- activation key (TaxSpooler v2.4.1.1 ή παλιότερη)
   	ser_deltio       VARCHAR(20) NOT NULL, -- TABLE ser_deltia
      ser_transid      INT NOT NULL,
      ser_upgrade      DATETIME, -- ημ/νία αγοράς τελ. upgrade
      ser_expires      DATETIME, --  ημ/νία λήξης δωρεαν αναβαθμισεων
      ser_comments     VARCHAR(200),
   	PRIMARY KEY (ser_progid, ser_itemid, ser_serial) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('ser_date', 'ser_progid', 'ser_serial', 'ser_itemid')
      );
   add_index($db,$t1,$idx);
   //......................................

   echo "<!-- All files examined. Time elapsed=".$prof->elapsed()." -->";
}
//--------------------------------------
function chk_tables_txc(&$db)
{
   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   // Convert all to lower case
   array_walk($tables,'array_toLower');
   
   $t1='taxi_log';
   //TXLOCATION     VARCHAR(200), -- Geolocation, after TXVERSION
   $query="CREATE TABLE $t1 (
      ROWID          INT NOT NULL AUTO_INCREMENT,
      AGENTID        INT NOT NULL,
      RECTYPE        SMALLINT, -- 1/2/3: PCK1/2/3 (3=pos only)
      TXVERSION      VARCHAR(50),  -- TaxSpooler version
      SENDERIP       VARCHAR(20),
      EAFDSSPORT     VARCHAR(20),
      MS11           VARCHAR(11),
      MVENDOR        VARCHAR(100),
      MMODEL         VARCHAR(100),
      MVERSION       VARCHAR(100),
      CLOGIC         VARCHAR(50),  -- Logic DLL version         
      OPENTIME       DATETIME,
      FIRSTSIGNINZ   DATETIME,
      LASTZTAKEN     DATETIME,
      LASTZNR        INT,
      MPROGRESSIVE   INT,
      MDAILY         INT,
      MTIMEPASSED    INT, -- time since last communication, in seconds
      MLASTOK        DATETIME,
      MLASTFAIL      DATETIME,
      MLASTERROR     INT, -- Last Error Code (0-255) 
      MLASTHARDST    INT, -- Last Device Hardware Status (0-255) 
      MLASTAPPST     INT, -- Last Device Application Status (0-255)
      POSAREAID      INT, -- ΑΡΙΘΜΟΣ ΥΠΟΚΑΤΑΣΤΗΜΑΤΟΣ
      POSRECEIPTS    INT, -- ΑΠΟΔΕΙΞΕΙΣ ΕΣΟΔΩΝ                 
      POSFPACHANGE   INT, -- ΑΛΛΑΓΕΣ ΤΙΜΩΝ ΦΠΑ                     
      POSHDRCHANGE   INT, -- ΑΛΛΑΓΕΣ ΛΕΚΤΙΚΟΥ                       
      POSCMOSERR     INT, -- ΒΛΑΒΕΣ CMOS                            
      POSCFERR       INT, -- ΒΛΑΒΗ ΕΠΙΚΟΙΝΩΝΙΑΣ CF                  
      POSPRNDETACH   INT, -- ΑΠΟΣΥΝΔΕΣΕΙΣ ΕΚΤΥΠΩΤΗ                  
      POSTECHOPEN    INT, -- ΕΠΕΜΒΑΣΕΙΣ ΤΕΧΝΙΚΟΥ                    
      POSDIMEDETACH  INT, -- ΑΠΟΣΥΝΔΕΣΕΙΣ ΔΗΜΕ                   
      MEM_USG        INT,             
      CPU_USG        INT,
      TXSPEC         TEXT, -- printer/folder (type:1/2=normal alternate), next...
      LASTUPDATE     TIMESTAMP,
      PRIMARY KEY (ROWID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'MS11', 'LASTUPDATE'),
      'k2'=>array('AGENTID', 'LASTUPDATE', 'MS11'),
      'k3'=>array('MS11', 'LASTUPDATE')
      );
   add_index($db,$t1,$idx);
   
   $t1='taxi_eafdss';
   $query="CREATE TABLE $t1 (
      MS11           VARCHAR(11) NOT NULL,
      AGENTID        INT NOT NULL,
      ENABLED        SMALLINT NOT NULL DEFAULT 0,
      MACHINETYPE    INT NOT NULL DEFAULT 0, -- 0=Unknown, 1=TaxSpooler, 2=FaSy, 3=POS
      TXLOCATION     VARCHAR(200), -- Location (i.e. city)
      L_PROCID       VARCHAR(250), -- last processor ID
      L_NPROC        INT,          -- last number of processors      
      L_OS           VARCHAR(250), -- last O/S 
      L_ARCH         VARCHAR(100), -- last system architecture                
      LASTUPDATE     TIMESTAMP,
      PRIMARY KEY (MS11) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   
   $t1='taxi_alert';
   $query="CREATE TABLE $t1 (
      MS11           VARCHAR(11) NOT NULL,
      ALRTYPE        VARCHAR(64) NOT NULL,
      AGENTID        INT NOT NULL,
      LASTSEND       DATETIME NOT NULL,
      PRIMARY KEY (MS11, ALRTYPE) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   
   echo "<h6>All files examined. Time elapsed=".$prof->elapsed()."</h6>";
}   
//--------------------------------------
function check_tables2(&$db)
{
   //
   // 10-7-2007: added support for MS-SQL
   //

   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   // Convert all to lower case
   array_walk($tables,'array_toLower');

   /*
	***              ***
	***    Remotex   ***
	***              ***
	*/
   $t1='dev_user'; // Χειριστές συσκευών
  	$query="USERID    INT NOT NULL AUTO_INCREMENT, ".
         "PASSWD     VARCHAR(20) NOT NULL, ".
         "UNAME      VARCHAR(100) NOT NULL, ".
         "UPHONE     VARCHAR(100), ".
         "UEMAIL     VARCHAR(100), ".
         "UCOMMENTS  VARCHAR(100), ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (USERID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='dev_main';
   $query="CREATE TABLE $t1 ( ".
   	   "USERID       INT NOT NULL, ".
   	   "DEVICEID     INT NOT NULL, ".
         "PENDING      INT NOT NULL, ". // 1=set, 2=read, 0=no pending request
         "SETVAL       INT NOT NULL, ".  // value to set
         "SETTIME      DATETIME, ".     // last set datetime
         "RETSTATUS    INT NOT NULL, ".   // return status= 0: no info, 1: exec done ok, 2: read done ok
         "RETVAL       INT NOT NULL, ".  // return value
         "RETTIME      DATETIME, ".     // last return time
         "DEVLOCATION  VARCHAR(100), ".
         "RELAVAILABLE SMALLINT NOT NULL, ". // relays available (4/8)
         "RELMAX       SMALLINT NOT NULL, ". // set by the user; max. value= relavailable
         "REL1NAME     VARCHAR(50), ".
         "REL2NAME     VARCHAR(50), ".
         "REL3NAME     VARCHAR(50), ".
         "REL4NAME     VARCHAR(50), ".
         "REL5NAME     VARCHAR(50), ".
         "REL6NAME     VARCHAR(50), ".
         "REL7NAME     VARCHAR(50), ".
         "REL8NAME     VARCHAR(50), ".
         "LASTUPDATE   TIMESTAMP, ".
         "PRIMARY KEY(USERID,DEVICEID) )".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='dev_log';
  	$query="CREATE TABLE $t1 ( ".
      	"LOGID INT NOT NULL AUTO_INCREMENT, ".
      	"USERID INT NOT NULL, ".
   	   "DEVICEID INT NOT NULL, ".
   	   "LOGTYPE SMALLINT NOT NULL, ". // 0/1=request by user/by device
   	   "XSTATUS INT NOT NULL, ". // 'PENDING' or 'RETSTATUS'
         "XVAL INT NOT NULL, ".    // SETVAL or RETVAL
         "ASKTIME DATETIME NOT NULL, ".
         "PRIMARY KEY(LOGID) )".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('USERID', 'DEVICEID', 'ASKTIME')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='device'; // OLD file (early iremote development)
  	$query="CREATE TABLE $t1 ( ".
      	"AGENTID INT NOT NULL, ".
		   "DEVICEID INT NOT NULL, ".
         "STATUS INT NOT NULL, ".
         "PENDING SMALLINT NOT NULL, ".
         "LASTUPDATE TIMESTAMP, ".
		   "PRIMARY KEY(AGENTID,DEVICEID) )".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   
   /*
	***              ***
	***    iPhone    ***
	***              ***
	*/
   $t1='mo_group';
  	$query="CREATE TABLE $t1 ( ".
   		"GID INT NOT NULL AUTO_INCREMENT, ".
   		"AGENTID INT NOT NULL, ".
      	"GROUPID INT NOT NULL, ".
      	"SUBID INT NOT NULL, ".
      	"GNAME VARCHAR(50) NOT NULL, ".
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (GID), ".
			"UNIQUE (AGENTID, GROUPID, SUBID), ".
			"UNIQUE (AGENTID, GNAME) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='mo_main';
  	$query="CREATE TABLE $t1 ( ".
      	"MOID INT NOT NULL AUTO_INCREMENT, ".
      	"AGENTID INT NOT NULL, ".
      	"FIRSTNAME VARCHAR(50), ".
      	"FAMILYNAME VARCHAR(50), ".
      	"COMPANY VARCHAR(60) NOT NULL, ".
      	"JOB VARCHAR(50), ".
      	"TRKEY VARCHAR(162), ".  	// FAMILYNAME.FIRSTNAME
      	"FATHERNAME VARCHAR(50), ".
      	"ADDRESS VARCHAR(80), ".
      	"ZIPTOWN VARCHAR(40), ".
      	"COUNTRY VARCHAR(40), ".
      	"PHONE VARCHAR(30), ". 	 	// Personal phone
      	"MOBILE VARCHAR(30), ".
      	"EMAIL VARCHAR(120), ".
      	"SEX SMALLINT NOT NULL, ". // 0/1=Mr/Mrs
         "COPHONE VARCHAR(30), ".
         "FAX VARCHAR(30), ".
         "URL VARCHAR(160), ".
         "RESELID INT NOT NULL, ". 	// Creator of entry
         "PERSONLY INT NOT NULL, ". // Personal usage only (0/1=No/Yes)
         "GID INT NOT NULL, ". 	   // <--> mo_group
         "LASTUPDATE TIMESTAMP, ".
         "PRIMARY KEY (MOID) ) ".
         "ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);

   $idx=array(
      'k1'=>array('AGENTID', 'GID', 'FAMILYNAME', 'FIRSTNAME', 'COMPANY'),
      'k2'=>array('AGENTID', 'FAMILYNAME', 'FIRSTNAME', 'COMPANY'),
      'k3'=>array('AGENTID', 'TRKEY'),
      'k4'=>array('AGENTID', 'PHONE'),
      'k5'=>array('AGENTID', 'RESELID', 'PERSONLY', 'MOID')
      );
   add_index($db,$t1,$idx);
   //......................................

   echo "<!-- All files examined. Time elapsed=".$prof->elapsed()." -->";
}
//--------------------------------------
function check_tables_edu(&$db)
{
   //
   // 10-7-2007: added support for MS-SQL
   //

   $prof=new cPROFILER1();

   $tables=$db->MetaTables();
   array_walk($tables,'array_toLower');
   
   /*
	***              ***
	***    EDU       ***
	***              ***
	*/
	$t1='edu_diag_main';
	$query="CREATE TABLE $t1 (
      DIAGID      INT NOT NULL AUTO_INCREMENT, 
      AGENTID     INT NOT NULL,
      MBR_LOGIN   VARCHAR(20) NOT NULL, -- creator of Diagonisma
      CREDAYTIME  DATETIME NOT NULL,
      DIAGNAME    VARCHAR(100), -- description of diagonisma
      ISGLOBAL    TINYINT NOT NULL, -- isglobal = is accessible by anyone
      INCLUDEANS  TINYINT NOT NULL, -- include answers
      COMMENTS    VARCHAR(250),
      PRIMARY KEY (DIAGID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('AGENTID', 'MBR_LOGIN', 'CREDAYTIME', 'DIAGID')
      );
   add_index($db,$t1,$idx);
   //......................................
	$t1='edu_diag_line';
	$query="CREATE TABLE $t1 (
      DIAGID      INT NOT NULL, -- edu_diag_main.DIAGID 
      DIAGLINE    INT NOT NULL, -- 1,2,3,..
      GRPLINE     INT NOT NULL DEFAULT 1, -- 1,2,3,... 
      AGENTID     INT NOT NULL, -- not really needed, only for interserver sync
      ICODE       VARCHAR(20),
      DEGREE      NUMERIC(10,2) NOT NULL,
      LASTUPDATE  TIMESTAMP, 
      PRIMARY KEY (DIAGID, DIAGLINE),
      UNIQUE (DIAGID, ICODE) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   $idx=array(
      'k1'=>array('DIAGID', 'GRPLINE', 'DIAGLINE')
      );
   add_index($db,$t1,$idx);
   //......................................
	$t1='edu_diag_grp';
	$query="CREATE TABLE $t1 (
	   DIAGID      INT NOT NULL, -- edu_diag_main.DIAGID
	   GRPLINE     INT NOT NULL, -- edu_diag_line.GRPLINE
	   AGENTID     INT NOT NULL, -- not really needed, only for interserver sync
	   COMMENTS    TEXT,
	   LASTUPDATE  TIMESTAMP, 
      PRIMARY KEY (DIAGID, GRPLINE) )
      ENGINE=InnoDb";
	process_meta($db,$tables,$t1,$query);
	
   echo "<!-- All files examined. Time elapsed=".$prof->elapsed()." -->";
}
//--------------------------------------
function check_tables_paynet(&$db)
{
   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   // Convert all to lower case
   array_walk($tables,'array_toLower');
   
   $t1='paynet_utility';
  	$query="CREATE TABLE $t1 (
  	   UTILID      INT NOT NULL AUTO_INCREMENT,
  	   AGENTID     INT NOT NULL,
  	   UDESC       VARCHAR(150),
  	   BANKID      VARCHAR(80) NOT NULL,
  	   STDCMS1IN   NUMERIC(10,3) NOT NULL, -- operator commission 
  	   PCCMS1IN    NUMERIC(10,3) NOT NULL,
  	   STDCMS1OUT  NUMERIC(10,3) NOT NULL, 
  	   PCCMS1OUT   NUMERIC(10,3) NOT NULL,
  	   STDCMS2IN   NUMERIC(10,3) NOT NULL, -- teotec commission 
  	   PCCMS2IN    NUMERIC(10,3) NOT NULL,
  	   STDCMS2OUT  NUMERIC(10,3) NOT NULL, 
  	   PCCMS2OUT   NUMERIC(10,3) NOT NULL,
  	   LASTUPDATE  TIMESTAMP,
      PRIMARY KEY(UTILID) )         
  	   ENGINE=InnoDb";
  	process_meta($db,$tables,$t1,$query);
  	
  	$idx=array(
      'k1'=>array('AGENTID', 'BANKID')
      );
   add_index($db,$t1,$idx);
   
   $t1='paynet_taxapo';
   $query="CREATE TABLE $t1 (
      RID         INT NOT NULL AUTO_INCREMENT,
      AGENTID     INT NOT NULL,
      AFM         VARCHAR(11),
      APONR       VARCHAR(20),
      APODATE     DATETIME,
      APOCTG      VARCHAR(40),
      AMOUNT      NUMERIC(10,2) NOT NULL,
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY(RID) )         
  	   ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query); 
}
//--------------------------------------
function check_tables_einv(&$db)
{
   $prof=new cPROFILER1();
   //
   // Check for tables
   //
   $tables=$db->MetaTables();
   // Convert all to lower case
   array_walk($tables,'array_toLower');

   $t1='einv_eafdss'; // Στοιχεια ΕΑΦΔΣΣ
  	$query="CREATE TABLE $t1 (
  	   AGENTID     INT NOT NULL,
  	   EAFDSS      VARCHAR(20) NOT NULL,
  	   ACTIVE      TINYINT NOT NULL DEFAULT 1,
      COMPANY     VARCHAR(40) NOT NULL,
		CALIAS      VARCHAR(40), -- diakritic title
		JOB         VARCHAR(40), 
		ADDR1       VARCHAR(40),
		ADDR2       VARCHAR(40),
		CITY        VARCHAR(20),
		STATE       VARCHAR(20),
		ZIP         VARCHAR(10),
		COUNTRY     VARCHAR(20),
		PHONE       VARCHAR(20),
		FAX         VARCHAR(20),
		VATNO       VARCHAR(20),
		DOY         VARCHAR(20),
  	   LASTUPDATE  TIMESTAMP,
  	   PRIMARY KEY (EAFDSS),
  	   UNIQUE (AGENTID, EAFDSS) )
      ENGINE=InnoDb";
  	process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='einv_virtual';
   $query="CREATE TABLE $t1 (
  	   EAFDSS      VARCHAR(20) NOT NULL, -- string 11 chars.
  	   PROGRESSIVE INT NOT NULL, -- up to 8 digits (99.999.999)
  	   AGENTID     INT NOT NULL,
  	   ZNR         SMALLINT NOT NULL, -- 1:3000
  	   DAILYNR     SMALLINT NOT NULL, -- 1:2500
      SIGDATE     INT NOT NULL, -- YYMMDD database signature date 
      SIGTIME     SMALLINT NOT NULL, -- hhmm
      SIGNHEX     VARCHAR(40) NOT NULL,
  	   PRIMARY KEY (EAFDSS, PROGRESSIVE),
      UNIQUE (EAFDSS, ZNR, DAILYNR) )
      ENGINE=InnoDb";
  	process_meta($db,$tables,$t1,$query);
  	//......................................
   $t1='einv_signs'; // documents sent, spent einv_addsigns 
  	$query="CREATE TABLE $t1 (
  	   EAFDSS      VARCHAR(20) NOT NULL, -- string 11 chars.
  	   PROGRESSIVE INT NOT NULL, -- up to 8 digits (99.999.999)
  	   AGENTID     INT NOT NULL,
      DOCID       INT NOT NULL, -- einv_addsigns.DOCID spent
  	   ZNR         SMALLINT NOT NULL, -- 1:3000
  	   DAILYNR     SMALLINT NOT NULL, -- 1:2500
      SIGDATE     INT NOT NULL, -- YYMMDD document date
      SIGTIME     SMALLINT NOT NULL, -- hhmm
      SIGNHARD    VARCHAR(40) NOT NULL,
      SIGNDOC     VARCHAR(40) NOT NULL,
      IVPWD       VARCHAR(64),    
      CREATED     DATETIME NOT NULL,
      LASTREAD    DATETIME, -- old field  	   
      PRIMARY KEY (EAFDSS, PROGRESSIVE),
      UNIQUE (AGENTID, EAFDSS, PROGRESSIVE) )
      ENGINE=InnoDb";
  	process_meta($db,$tables,$t1,$query);
  	$idx=array(
      'k1'=>array('AGENTID', 'CREATED')
      );
   add_index($db,$t1,$idx);
   //......................................
   $t1='einv_signfor';
   $query="CREATE TABLE $t1 (
  	   EAFDSS      VARCHAR(20) NOT NULL, -- string 11 chars.
  	   PROGRESSIVE INT NOT NULL, -- up to 8 digits (99.999.999)
  	   EMAILFS     VARCHAR(200), -- email full string
      EMAIL5      VARCHAR(32), -- md5 hash of email
      ETYPE       INT NOT NULL, -- 0=To, 1=Cc, 2=Bcc
      LASTREAD    DATETIME, 
      PRIMARY KEY (EAFDSS, PROGRESSIVE, EMAIL5) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
   //......................................
   $t1='einv_ulogin';
   $query="CREATE TABLE $t1 (
      EMAIL5      VARCHAR(32), -- md5 hash of email
      EPASSWD     VARCHAR(32), 
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (EMAIL5) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
  	//......................................
  	$t1='einv_addsigns';
  	$query="CREATE TABLE $t1 (
  	   DOCID    INT NOT NULL AUTO_INCREMENT,
      AGENTID  INT NOT NULL,
      DOCNR    VARCHAR(20) NOT NULL,
      DOCDATE  DATETIME NOT NULL,
      SIGNQUA  INT NOT NULL, -- signature set
      SIGNAVL  INT NOT NULL, -- signatures available
      LASTUPDATE  TIMESTAMP,
      PRIMARY KEY (DOCID) )
      ENGINE=InnoDb";
   process_meta($db,$tables,$t1,$query);
  	//......................................

   echo "<!-- All files examined. Time elapsed=".$prof->elapsed()." -->";
}
//------------------------------------------------------------------------------
function check_inno1(&$db, $tablename)
{
   $query="SHOW TABLE STATUS LIKE ?";
   $data=array($tablename);
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>\n";
      return false;
   }
	$o1=$rs->FetchNextObject();
	$rs->Close();
	if ($o1===false) {
      echo "<h6>Could not get stats. for $tablename</h6>";
	   return false;
	}
	
	$ar1=get_object_vars($o1);
	if (array_key_exists('ENGINE',$ar1))
	   $ctype=$ar1['ENGINE'];
	else if (array_key_exists('TYPE',$ar1)) 
	   $ctype=$ar1['TYPE'];
	else 
	   $ctype='Unknown';
	
	if (strcasecmp($ctrype, 'innodb')==0) {
	   return true;
   }
   else {
      echo "<h6>Type for $tablename is ".$o1->TYPE."</h6>";
      return false;
   }
}
//------------------------------------------------------------------------------
function check_innodb(&$db)
{
   if ($db->databaseType!='mysqlt')
      return;

   $prof=new cPROFILER1();
   //
   // Check type of tables; reset to InnoDb if not.
   //
   $tobj=array();
   $query="SHOW TABLE STATUS";
   if ($rs=$db->Execute($query)) {
      echo "<!-- Got a status list. Time elapsed=".$prof->elapsed()." -->";
		while ($o1=$rs->FetchNextObject()) {
			$tobj[]=$o1;
		}
		$rs->Close();
	}
	else
		echo "<h6>".$db->ErrorMsg()."</h6>\n";

   echo "<br>Got status list. Time elapsed=".$prof->elapsed()."<br>\n";

   $i=0;
	foreach ($tobj as $o1) {
      $ar1=get_object_vars($o1);
      if (array_key_exists('TYPE',$ar1))
         $val=$ar1['TYPE'];
      else if (array_key_exists('ENGINE',$ar1))
         $val=$ar1['ENGINE'];
      else {
         echo "<h6>Neither TYPE, nor ENGINE field exists for ".$o1->NAME."!</h6>";
         continue;
      }
      
      if (strcasecmp(substr($o1->COLLATION,0,4), 'utf8')!=0) {
         $query="ALTER TABLE ".$o1->NAME." CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci";
         if (!$db->Execute($query))
            echo "<span style=\"color:red\">".$db->ErrorMsg()."</span>";
         else  
            echo "<br>Converted $o1->NAME into utf-8\n";
      }

		if (strcasecmp($val, 'myisam')==0) {
			$query="ALTER TABLE ".$o1->NAME." ENGINE=InnoDb";
			if (!$db->Execute($query)) {
				echo "<h6>$query: ".$db->ErrorMsg()."</h6>\n";
				continue;
			}
			else {
            echo "<br>Requested ENGINE convertion for ".$o1->NAME."\n";
         }

			if ($i==0) {
            if (!check_inno1($db, $o1->NAME)) {
               echo "<h3 style=\"color:red;\">Can not convert table $o1->NAME to INNODB. Aborting...</h3>";
               continue;
            }
         }

			$i++;
		}
	}

	echo "<br>All files COLLATION + ENGINE examined. Time elapsed=".$prof->elapsed()."\n";
}
//------------------------------------------------------------------------------
?>
