<?php
define('DOCUMENT_ROOT', get_docroot() );

$http_host=isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:(isset($_SERVER['HOST'])?$_SERVER['HOST']:'localhost');
define('HTTP_HOST', $http_host);

define('FSEP', PHP_OS=='WINNT'?'\\':'/');
define('cs8', 'utf-8');
define('csGRW', 'windows-1253');

ini_set('track_errors', '1');

if (function_exists('mb_internal_encoding')) {
   mb_internal_encoding("UTF-8");
   mb_substitute_character("none"); 
}

$verbose=false; // global var

//--------------------------------------
/* printer document:
      <ishop_printer_doc>
         <printer>
            <printername>....</printername>
            <doctitle>...</doctitle>
            <fontname>...</fontname>
            <fontsize>...</fontsize>
            <fontweight>...</fontweight> (100,200,...)
            <linedistfactor>...</linedistfactor> (1, 1.25, 0.75...)
            <border>
               <top></top>
               <left></left>
            </border> (default 10,10) in 1/100 of inch   
         </printer>
         
         <data>
            <page>
               <drawtext [x=...] [y=...]></drawtext> (default x=0, default y=follow linedistfactor or -1)
            </page>
            
            <page>...</page>
            <page>...</page>
         </data>
      </ishop_printer_doc>
   */
class MyPrinter
{
   var $_db;
   var $_prname;
   var $_doctitle;
   var $outfile;
   var $fp=false;
   var $fontname=null;
   var $pointsheight=10;
   var $fontweight=400;
   var $factor=1;
   var $tags=array();
   
   function __construct(&$db, $prname, $doctitle='')
   {
      $this->_db=&$db;
      $this->_prname=$prname;
      $this->_doctitle=$doctitle;
   }
   
   function initialize()
   {
      $printoutcat=false;
      $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='PRINTOUT_CATALOG' ";
      if (($rs=$this->_db->Execute($query))===false) {
         echo "<h6>".__LINE__.$this->_db->ErrorMsg()."</h6>";
         return false;
      }
      if (($row=$rs->FetchRow())!==false) {
         $printoutcat=$row[0]; 
      }
      $rs->Close();
      
      if (empty($printoutcat)) {
         $printoutcat="c:\\tmp\\printout";
      }
      
      if (($this->outfile=tempnam($printoutcat, 'XMP'))===false) {
         echo "<h6>Failed to get temporary filename</h6>";
         return false;
      }
      
      if (strcasecmp(dirname($this->outfile), $printoutcat)!=0) {
         echo "<h6>Directory for temp. file is not o.k., got {$this->outfile}</h6>";
         unlink($this->outfile);
         return false;
      }
   
      if (($this->fp=@fopen($this->outfile,"w"))===false) {
         echo "<h6>Failed to open $this->outfile file for writing</h6>";
         return false;
      }
      
      fwrite($this->fp, "<"."?xml version=\"1.0\" encoding=\"UTF-8\"?".">\n<ishop_printer_doc>\n<printer>\n" );
      
      $this->write_tag_value('printername', $this->_prname);
      $this->write_tag_value('doctitle', $this->_doctitle);
      $this->write_tag_value('fontname', $this->fontname);
      $this->write_tag_value('fontsize', $this->pointsheight);
      $this->write_tag_value('fontweight', $this->fontweight);
      $this->write_tag_value('linedistfactor', $this->factor);
      fwrite($this->fp, "<border>");
      $this->write_tag_value('top', 0);
      $this->write_tag_value('left', 0);
      fwrite($this->fp, "</border>");
      
      fwrite($this->fp, "</printer>\n<data>\n");
      
      return true;
   }
   
   function write_tag_value($tag,$val)
   {
      fwrite($this->fp, "<$tag>".myxml($val)."</$tag>\n");
   }
   
   function open_tag($tag)
   {
      $this->tags[]=$tag;
      fwrite($this->fp, "<$tag>");
   }
   
   function close_tag()
   {
      if (count($this->tags)>0) {
         $tag=array_pop($this->tags);
         fwrite($this->fp, "</$tag>");
      }
   }
   
   function restart_tag()
   {
      if (($n=count($this->tags))>0) {
         $tag=$this->tags[$n-1];
         fwrite($this->fp, "</$tag>\n<$tag>");
      }
   }
   
   function __destruct()
   {
      if ($this->fp!==false) {
         fwrite($this->fp, "</data>\n</ishop_printer_doc>");
         fclose($this->fp);
      }
   }
}
//--------------------------------------
function clear_spaces($src)
{
   static $tr1=array(' '=>'');
   
   return strtr($src,$tr1);
}
//--------------------------------------
class cFIELDOBJEC
{
   var $name;
   var $type='';
   var $max_length=0;
   var $scale=0;
   var $primkey='';

   function __construct($str1)
   {
      $this->name=strtoupper(strtok($str1," \t"));

      if (($h1=strtok(")"))===false)
         return;

      $i=strpos($h1,"(");
      if ($i===false) {
         $this->set_type($h1);
      }
      else if ($i>0) {
         $this->set_type( substr($h1,0,$i) );
         $szs=strtok(substr($h1,$i+1),")");
         if (strcasecmp($this->name, 'PRIMARY')==0 && strcasecmp($this->type, 'KEY')==0) {
            $this->primkey=clear_spaces($szs);
         }
         else {
            $ar1=explode(',',$szs);
            
            if (!empty($ar1))
               $this->max_length=(int)$ar1[0];
               
            if (count($ar1)>=2)
               $this->scale=(int)$ar1[1];
         }
      }
   }
   
   private function set_type($s1)
   {
      $ar1=explode(' ', trim($s1));
      if (count($ar1)>=1) { $this->type=$ar1[0]; }
   }

   function differs($of1)
   {
      static $ar1=array('int', 'smallint', 'tinyint', 'varchar', 'timestamp', 'datetime');
      
      foreach ($ar1 as $typ) {
         if (strcasecmp($this->type,$typ)==0) {
            if (strcasecmp($of1->type,$typ)!=0) {
               return true;
            }
            break;
         }
      }

      if ($this->max_length>0 && (int)$of1->max_length>=0 && $this->max_length!=(int)$of1->max_length)
         return true;

      if (isset($of1->scale) && $this->scale!=(int)$of1->scale)
         return true;

      return false;
   }
}
//--------------------------------------
function get_docroot()
{
   /*
      DOCUMENT_ROOT:
      Always (both Windows ans Unix) separated with '/'; NEVER ends up with '/'.
   */
   @include('user_def.php');
   if (!empty($DocumentRoot))
      return $DocumentRoot;
   
   if (!empty($_SERVER[$k1='SUBDOMAIN_DOCUMENT_ROOT']))
      return $_SERVER[$k1];
   else if (!empty($_SERVER[$k1='DOCUMENT_ROOT']))
      return $_SERVER[$k1];

   if (!empty($_SERVER[$k1='PATH_TRANSLATED']))
      $ptr=strtr($_SERVER[$k1],"\\","/");
   else if (!empty($_SERVER[$k1='SCRIPT_FILENAME']))
      $ptr=strtr($_SERVER[$k1],"\\","/");
   else
      return '';   

   $psf=strtr($_SERVER['PHP_SELF'],"\\","/");
   $l1=strlen($ptr);
   $l2=strlen($psf);
   if ($l2<$l1) {
      return substr($ptr,0,$l1-$l2);
   }
   else {
      return '';
   }
}
//--------------------------------------
function implement_session()
{
   /*
      2-5-2008: because of PHP bug, variables_order is not taken into consideration
      when calling session_... functions.
      Moreover, we want to force specific order ...CGP...
   */
   global $myse;
   
   if (defined('MY_SESSION_NAME')) {
      $s1=MY_SESSION_NAME;

      if (isset($_REQUEST[$s1])) {
         $_GET[$s1] = $_REQUEST[$s1];
         $_POST[$s1] = $_REQUEST[$s1];
         $_COOKIE[$s1] = $_REQUEST[$s1];
      }

      if (session_name()!=$s1) {
         session_name($s1);
         session_id($_REQUEST[$s1]);
      }
   }
   
   if (!headers_sent($filename,$line)) {
      session_start();
   }
   else {
      echo "Headers sent in $filename, line $line\n";
   }
}
//--------------------------------------
class MyCalendar {
   /*
      Requires a form named 'myform' with 2 fields CALYEAR, CALMON

      Two arrays must be passed and a function name. First array contains dates
      as 'YYYY-MM-DD', second record objects.
      function.
      Function is responsible for displaying cell data, using the two arrays and
      a 'this date' passed as string (YYYY-MM-DD).
   */
   var $Days;
   var $calyear;
   var $calmon;
   var $year; // today
   var $mon;  // today
   var $mday; // today
   //...............................................
   function MyCalendar($langid=0)
   {
      //setlocale(LC_TIME,'ell');

      $this->Days=array('Κυριακή', 'Δευτέρα', 'Τρίτη', 'Τετάρτη', 'Πέμπτη', 'Παρασκευή', 'Σάββατο');
      $x=strtotime('next Sunday') + 7*24*3600;

      if (!isset($_REQUEST['CALYEAR']) || !isset($_REQUEST['CALMON'])) {
   	   $d1=getdate();
	      $this->calyear=(int)$d1['year'];
	      $this->calmon=(int)$d1['mon'];
      }
      else {
         $this->calyear=(int)$_REQUEST['CALYEAR'];
	      $this->calmon=(int)$_REQUEST['CALMON'];
      }

      // Today
      $d1=getdate();
      $this->year=(int)$d1['year'];
      $this->mon=(int)$d1['mon'];
      $this->mday=(int)$d1['mday'];
   }
   //...............................................
	function draw($xcrd,$xdata,$func1)
	{
?>
<table border=1 cellspacing=0 cellpadding=1 bordercolordark="black" bordercolorlight="white">
<tr class="MYSIGN">
   <td colspan=7><?php
      echo strftime('%B %Y', mktime( 0,0,0, $this->calmon,1,$this->calyear ) ); // calmon: 1,2,,...
      ?></td>
</tr>
<tr class="HEADER" style="font-weight:bold;"><?php
      for ($i=0;$i<7;$i++) {
         echo "<td>".substr($this->Days[$i],0,2),"</td>";
      }
?></tr>
<?php
   // get weekday for 1st day of calendar month
   $caltime=mktime ( 0,0,0, $this->calmon, 1, $this->calyear);
   $d2=getdate($caltime);
   $weekday1=(int)$d2['wday'];
   $m1=$d2['mday'];

   // 1st row
   echo "<tr valign=top>\n";
   for ($i=0;$i<$weekday1;$i++) {
      echo "<td";
      if ($this->calyear==$this->year && $this->calmon==$this->mon && $m1==$this->mday)
         echo " class=\"MYSIGN\"";
      else if ($i==0)
         echo " class=\"ARGIA\"";
      echo ">&nbsp;</td>\n";
   }

   $m1=0;
   for ($i=$weekday1;$i<=6;$i++) {
      $m1++;
      if ($m1>1) {
         $caltime+=3600*24;
         $d2=getdate($caltime);
         if ((int)$d2['mon']!=$this->calmon)
            break;
      }
      echo "<td";
      $k2=sprintf("%d-%02d-%02d",$this->calyear,$this->calmon,$m1);
      if ($i==0 || $i==6)
         echo " class=\"ARGIA\"";
      if ($this->calyear==$this->year && $this->calmon==$this->mon && $m1==$this->mday)
         echo " style=\"border: solid red 2px;\"";
      echo ">";
      $func1($xcrd,$xdata,$k2);
      echo "</td>\n";
   }
   echo "</tr>\n";

   // 2nd row and over...
   do {

      echo "<tr valign=top>\n";
      for ($i=0;$i<=6;$i++) {
         $m1++;
         $caltime+=3600*24;
         $d2=getdate($caltime);
         if ((int)$d2['mon']!=$this->calmon)
            break;
         $k2=sprintf("%d-%02d-%02d",$this->calyear,$this->calmon,$m1);
         echo "<td";
         if ($i==0 || $i==6)
            echo " class=\"ARGIA\"";
         if ($this->calyear==$this->year && $this->calmon==$this->mon && $m1==$this->mday)
            echo " style=\"border: solid red 2px;\"";
         echo ">";
         $func1($xcrd,$xdata,$k2);
         echo "</td>\n";
      }
      echo "</tr>\n";

   } while ((int)$d2['mon']==$this->calmon)
?>
</table>
<?php
		$this->pr_month_navigator($xcrd);
   } // end of constructor...
	//...............................................
   function pr_month_navigator($xcrd)
   {
?>
<script>
function on_year(x)
{
   var f=document.myform;
   f.CALYEAR.value=x;
   f.CALMON.value="1";
   f.submit();
}
function on_month(x)
{
   var f=document.myform;
   f.CALMON.value=x;
   f.submit();
}
</script>
<table border=1 cellspacing=0 cellpadding=1 bordercolorlight="white" bordercolordark="black">
<tr class="GRAYED" style="font-weight:bold;">
<?php
   	echo "<td";
   	$k2=sprintf("%d",$this->calyear-1);
   	foreach ($xcrd as $val) {
      	if (substr($val,0,4)==$k2) {
         	echo " class=\"RFOUND\"";
         	break;
      	}
   	}
   	echo "><a href=\"javascript:on_year('".($this->calyear-1)."')\" class=\"B1\">&lt;&nbsp;</a></td>\n";

   	for ($i=1;$i<=12;$i++) {
			$mysign=false;

      	if ($this->calyear==$this->year && $i==$this->mon)
         	$fi=true;
      	else
         	$fi=false;

      	echo "<td";

      	$k2=sprintf("%d-%02d",$this->calyear,$i);
      	$fi2=false;
      	foreach ($xcrd as $val) {
         	if (substr($val,0,7)==$k2) {
            	$fi2=true;
            	break;
         	}
      	}

      	if ($i==$this->calmon) {
				$mysign=true;
         	echo " class=\"MYSIGN\"";
       	}
      	else if ($fi2)
         	echo " class=\"RFOUND\"";

      	if ($fi)
         	echo " style=\"border: solid red 2px;\"";

      	echo ">";

      	if ($fi || $mysign)
				echo "&nbsp;";

      	if ($i!=$this->calmon)
         	echo "<a href=\"javascript:on_month('".$i."')\">";

      	echo $i;
      	if ($i!=$this->calmon)
         	echo "</a>";

      	if ($fi || $mysign)
				echo "&nbsp;";

      	echo "</td>\n";
   	}

   	echo "<td";
   	$k2=sprintf("%d",$this->calyear+1);
   	foreach ($xcrd as $val) {
      	if (substr($val,0,4)==$k2) {
         	echo " class=\"RFOUND\"";
         	break;
      	}
   	}
   	echo "><b><a href=\"javascript:on_year('".($this->calyear+1)."')\">&nbsp;&gt;</a></b></td>\n".
			"</tr></table>\n";
	}
	//...............................................
}
//--------------------------------------
function xml2str($a)
{
   static $trans=array('&amp;'=>'&', '&lt;'=>'<', '&gt;'=>'>', '&quot;'=>'"', '&apos;'=>'\'' );
   
   return strtr($a, $trans );
}
//--------------------------------------
function myxml($a)
{
   static $trans=array('&'=>'&amp;', '<'=>'&lt;', '>'=>'&gt;', '"'=>'&quot;', '\''=>'&apos;' );   

   return strtr($a, $trans );
}
//--------------------------------------
function myjs($a)
{
   $esc="\10\13\14\0\"'\r\n\t\\"; // \b\v\f
   return addcslashes($a,$esc);
}
//--------------------------------------
function myhtml8($a)
{
   return myhtml(ToUTF8($a));
}
//--------------------------------------
function F437to928($a)
{
   $rets='';
   $l=strlen($a);
   for ($i=0;$i<$l;$i++) {
		$uc=ord($a{$i});

		if ($uc>=0x80 && $uc<=0x90) /*ÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑ*/
			$uc+=0x41;
		else if ($uc>=0x91 && $uc<=0x97) /*ÓÔÕÖ×ØÙ*/
			$uc+=0x42;
		else if ($uc>=0x98 && $uc<=0xA8) /*áâãäåæçèéêëìíîïðñ*/
			$uc+=0x49;
		else if ($uc==0xA9) /*ó*/
			$uc=0xF3;
		else if ($uc==0xAA) /*ò*/
			$uc=0xF2;
		else if ($uc>=0xAB && $uc<=0xAF) /*ôõö÷ø*/
			$uc+=0x49;
		/*
		  -------- graphics (start) --------
		*/
		else if ($uc>=0xB0 && $uc<=0xDF)
			$uc='*';
		/*
		  -------- graphics (end) --------
		*/
		else if ($uc==0xE0) /*ù*/
			$uc=0xF9;
		else if ($uc>=0xE1 && $uc<=0xE3) /*ÜÝÞ*/
			$uc-=5;
		else if ($uc==0xE4) /*ú*/
			$uc=0xFA;
		else if ($uc==0xE5) /*ß*/
			$uc=0xDF;
		else if ($uc==0xE6 || $uc==0xE7) /*üý*/
			$uc+=22;
		else if ($uc==0xE8) /*û*/
			$uc=0xFB;
		else if ($uc==0xE9) /*þ*/
			$uc=0xFE;
		else if ($uc==0xEA) /*¢*/
			$uc=0xA2;
		else if ($uc>=0xEB && $uc<=0xED) /*¸¹º*/
			$uc-=51;
		else if ($uc==0xEE) /*¼*/
			$uc=0xBC;
		else if ($uc>=0xEF && $uc<=0xF0) /*¾¿*/
			$uc-=49;
		else if ($uc>=0xF4 && $uc<=0xF5) /*ÉÕ ìå äéáëõôéêá*/
			$uc-=26;
		else if ($uc==0xFB) /* checker symbol */
			$uc='*';
		else if ($uc==0xFE) /* small block */
			$uc='*';

		$rets.=chr($uc);
	}
	
	return $rets;
}
//--------------------------------------
function F437toUTF8($a)
{
   return ToUTF8( F437to928($a) );
}
//--------------------------------------
function myhtml($a)
{
   if ($a===false)
      return '';

   $a1=(string)$a;
   $a2='';
   $l=strlen($a1);
   for ($i=0;$i<$l;$i++) {
      if (($c=$a1{$i})!='&') {
         $a2 .= $c;
      }
      else if ($i<($l-1) && $a1{$i+1}=='#') {
         $a2 .= $c;
      }
      else {
         $a2 .= '&amp;';
      }
   }

   $a3=str_replace( array('"', '<', '>'), array('&quot;', '&lt;', '&gt;'), $a2);

   return $a3;
}
//--------------------------------------
function commnt($obj,$title="")
{
   if (!empty($title))
      echo "<h5>".myhtml($title)."</h5>\n";

   echo "<!-- ";
   print_r($obj);
   echo " -->\n";
}                                                                                                                                
//--------------------------------------
function iscript($s1)
{
   echo "<script>window.alert('".addslashes($s1)."');</script>";
}
//--------------------------------------
function ptag($tagname, $content, $attrs=false) //  same as ptagText(), but safe print $content
{
   ptagText($tagname, myhtml($content), $attrs); 
}
//--------------------------------------
function ptagText($tagname, $content, $attrs=false)  //  same as ptag, print $content as-is
{
   if (empty($tagname)) {
      echo $content;
   }
   else {
      echo "<$tagname";
      if (is_array($attrs)) {
         foreach ($attrs as $k=>$v) {
            echo " $k=\"".myhtml($v)."\"";
         }
      }
      echo ">$content</$tagname>";
   }
}
//--------------------------------------
function pre($obj,$title="")
{
   if (!empty($title))
      echo "<div style=\"background-color:#c0c0c0;font-weight:bold;\">".myhtml($title)."</div>\n";

   echo "<pre>";
   echo myhtml( print_r($obj,true) );
   echo "</pre>";
}
//--------------------------------------
function prex($obj,$title="")
{
   if (!empty($title))
      echo "<div style=\"background-color:#c0c0c0;font-weight:bold;\">".myhtml($title)."</div>\n";

   echo "<PRE>";
   var_dump($obj);
   echo "</PRE>";
}
//--------------------------------------
function iGetSessionId(&$db,&$sessionid,&$delta,&$ErrMsg)
{
 	mt_srand(time());
   $i=0;
	$ok=false;
   while ($i++ < 100) {
		$sessionid=mt_rand();
		$delta=mt_rand().mt_rand();
   	$query="INSERT INTO session (SESSIONID, CREDAYTIME, DELTA, LASTUSAGE) VALUES( ?, NOW(), ?, NOW() )";
	   $data=array( $sessionid, $delta );
	   if ($db->Execute($query,$data)) {
      	$ok=true;
      	break;
      }
      else {
         echo "<!-- $query:".$db->ErrorMsg()." -->";
         //repeat query with other value
      }
   }
   if (!$ok) {
      $ErrMsg="Failed to create Session Id!";
		return false;
	}
	else
		return true;
}
//--------------------------------------
function get_tzs()
{
   $tz=(int)date('Z');

   $h=(int)($tz/3600);
   $m=(int)($tz-$h*3600);
   if ($h>=0)
      $s=sprintf("+%02d:%02d",$h,$m);
   else
      $s=sprintf("%03d:%02d",$h,$m);

   return $s;
}
//--------------------------------------
function iSetSessionData(&$db,$sessid,$data,$show_err=false)
{
 	if (empty($data))
		return true;

   $data1=array_keys($data);
	$n=count($data1);
   $query1="DELETE FROM session_data
      WHERE SESSIONID=? AND PNAME IN(".implode(',',array_fill(0,$n,'?') ).")";
   array_unshift($data1,$sessid);
	if (!$db->Execute($query1,$data1)) {
		if ($show_err)
			echo "<h6>$query1: ".$db->ErrorMsg()."</h6>";
		return false;
	}

	// Add new
	$query2="INSERT INTO session_data (SESSIONID,PNAME,PVALUE) VALUES (?,?,?)";
   $data2=array();

   foreach ($data as $key=>$val) {
      $data2=array($sessid, $key, $val);
      if (!$db->Execute($query2,$data2)) {
      	if ($show_err)
	    		echo "<h6>$query2: ".$db->ErrorMsg()."</h6>";
	  	   return false;
	   }
	}

	return true;
}
//--------------------------------------
function  prSelect($from,$to,$sel)
{
	for ($i=$from;$i<=$to;$i++) {
   	echo "<option";

      if ($i==$sel)
      	echo " SELECTED";

      echo ">$i</option>\n";
   }
}
//--------------------------------------
function prSelectErr($data,$v1)
{
 	$fi=false;
 	$n=count($data);
 	for ($i=0;$i<$n;$i++) {
		echo "<option";
		if (strcmp($data[$i],$v1)==0) {
			echo " SELECTED";
			$fi=true;
		}
		echo ">".myhtml($data[$i])."</option>\n";
 	}
 	if (!$fi && $v1!==false)
 		echo "<option SELECTED style=\"color:red;\">".myhtml($v1)."</option>\n";
}
//--------------------------------------
function  prAssocSelect($assoc_array, $sel='', $typ=0)
{
	foreach($assoc_array as $key=>$val) {
      echo "<option";
      
      if ($typ==1) { // new behaviour
         if ($val==$sel) {
      	   echo " SELECTED";
         }
         echo ">".myhtml($val); 
      }
      else if ($typ==2) { // very new behaviour
         echo " value=\"".myhtml($key)."\"";
         if ($val==$sel) {
      	   echo " SELECTED";
         }
         echo ">".myhtml($key.'# '.$val);
      }
      else { // classic behaviour
         echo " value=\"".myhtml($key)."\"";
         if ($key==$sel) {
      	   echo " SELECTED";
         }
         echo ">".myhtml($val);  
      }
      
      echo "</option>\n";
   }
}
//--------------------------------------
function  prAssocRadio($fldName, $assoc_array, $sel)
{
   if (!is_array($assoc_array))
      return;
      
	foreach($assoc_array as $key=>$value) {
   	echo "<input type=RADIO name=\"$fldName\" value=\"".myhtml($key)."\"";

      if ($key==$sel)
      	echo " CHECKED";

      echo "/ ><span onclick=\"CBclick(this)\">".myhtml($value)."</span><br />\n";
   }
}
//--------------------------------------
function prAssocSelErr($data, $v1)
{
   if (!is_array($data))
      return;
      
 	$fi=false;
 	foreach ($data as $key=>$val) {
		echo "<option ";
		if (strcmp($key, $v1)==0) {
			echo "SELECTED";
			$fi=true;
		}
		echo " value=\"".myhtml($key)."\">".myhtml($val)."</option>\n";
 	}
 	if (!$fi && $v1!==false)
 		echo "<option SELECTED style=\"color:red;\">".myhtml($v1)."</option>\n";
}
//--------------------------------------
function toFloat($a, $dd=false)
{
	$a2=strtr((string)$a,',','.');
	$ar2=explode('/',$a2);
	if (!empty($ar2) && count($ar2)==2 && (int)$ar2[1]!=0) {
      $x=(float)((int)$ar2[0]) / (float)((int)$ar2[1]);
   }
   else {
      $x=(float)$a2;
   }
   
   if ($dd!==false) {
      $format="%0.${dd}f";
	   $x=sprintf($format,$x);
   }

   return $x;
}
//--------------------------------------
function GrDate($a, $sep='/') // $sep=wanted separator
{
   $d1=explode(' ',$a); // may be it contains Date+Time
   if (empty($d1))
      return $a;

   $s1=strtr($d1[0], '/', '-');
   $data=explode('-', $s1);
   if (count($data)>=3)
      $ret=$data[2].$sep.$data[1].$sep.$data[0];
   else if (strlen($a)>=8) // YYYYMMDD
      $ret=substr($a,6,2).$sep.substr($a,4,2).$sep.substr($a,0,4);
   else
      $ret=$a;

   return $ret;
}
//--------------------------------------
function GrDate2($a, $sep='/') // $sep=wanted separator
{
   $d1=explode(' ',$a); // may be it contains Date+Time
   if (empty($d1))
      return $a;

   $s1=strtr($d1[0], '/', '-');
   $data=explode('-', $s1);
   if (count($data)>=3 && strlen($data[0])==4)
      $ret=$data[2].$sep.$data[1].$sep.substr($data[0],2);
   else if (strlen($a)>=8) // YYYYMMDD
      $ret=substr($a,6,2).$sep.substr($a,4,2).$sep.substr($a,2,2);
   else
      $ret=$a;

   return $ret;
}
//--------------------------------------
function GrDateTime($a,$sep='/')
{
   $d1=explode(' ',$a); // may be it contains Date+Time
   if (empty($d1) || empty($d1[0]))
      return $a;
   else if (count($d1)==1 && strlen($a)==14) {
      $ret=substr($a,6,2).$sep.substr($a,4,2).$sep.substr($a,0,4).' '.substr($a,8,2).':'.substr($a,10,2).':'.substr($a,12,2);
      return $ret;
   }
   else if (count($d1)==1) {
      $d1[1]='00:00:00';
   }
      
   $data=explode('-',$d1[0]);
   if (count($data)>=3 && strlen($data[0])==4)
      $ret=$data[2].$sep.$data[1].$sep.$data[0]." ".$d1[1];
   else
      $ret=$a.' '.$d1[1];

   return $ret;
}
//--------------------------------------
function GrDateHour($a,$sep='/')
{
   $d1=explode(' ',$a); // may be it contains Date+Time
   if (empty($d1) || empty($d1[0]))
      return $a;
   else if (count($d1)==1 && strlen($a)==14) {
      $ret=substr($a,6,2).$sep.substr($a,4,2).$sep.substr($a,0,4).' '.substr($a,8,2).':'.substr($a,10,2).':'.substr($a,12,2);
      return $ret;
   }
   else if (count($d1)==1) {
      $d1[1]='00:00:00';
   }
   
   $d2=explode(':',$d1[1]);
   while (count($d2)<2) {
      $d2[]='00';
   }
   $d1[1]=$d2[0].':'.$d2[1]; // remake   
   
   $data=explode('-',$d1[0]);
   if (count($data)>=3 && strlen($data[0])==4)
      $ret=$data[2].$sep.$data[1].$sep.$data[0]." ".$d1[1];
   else
      $ret=$a.' '.$d1[1];

   return $ret;
}
//--------------------------------------
function DateTimeFromString($src)
{
   // yyyy-mm-dd hh:mm:ss to integer
   $ar1 = array_pad(explode(':', strtr($src, ' -', '::')), 6, '0');
   if ($ar1[0]==0) {
      return false;
   }
   if (strlen($ar1[0])<=2) { $ar1[0] = (string)(2000 + $ar1[0]); }
   return mktime($ar1[3], $ar1[4], $ar1[5], $ar1[1], $ar1[2], $ar1[0]);
}
//--------------------------------------
function GNFormat($x,$d)
{
   // Greek number format
   return number_format($x, $d, ',', '.');
}
//--------------------------------------
function TrimZero($a)
// Removes any trailing zeros after comma or dot (decimal number)
{
   if (($x1=strrpos($a, '.'))===false)
      $x1=-1;
   if (($x2=strrpos($a, ','))===false)
      $x2=-2;

   if ($x1<0 && $x2<0)
      return $a;

   if ($x2>$x1)
      $x1=$x2;

   $l=strlen($a);
   while ($a[$l-1]=='0')
      $l--;

   if ($a[$l-1]=='.' || $a[$l-1]==',')
      $l--;

   $ret=substr($a,0,$l);
   if (empty($ret))
      $ret='0';

   return $ret;
}
//--------------------------------------
function StrHush($str,$maxshow)
{
   // Προβλημα σε utf-8
 	$l=mb_strlen($str);

 	if ($l<=($maxshow+3)) {
 		return $str;
 	}
 	else {
 		$outs=mb_substr($str,0,$maxshow).'...';
 		return $outs;
 	}
}
//--------------------------------------
function tr_echo($str)
{
   echo "<tr><td colspan=10>".$str."</td></tr>\n";
}
//--------------------------------------
function convertEngToGr($src,$f=0)
{
   static $EnStr="ABEZHIKMNOPTYXo";
   static $GrStr="ΑΒΕΖΗΙΚΜΝΟΡΤΥΧο"; // GR928

   $strout='';
   $l=mb_strlen($src);
   for ($i=0;$i<$l;$i++) {
      $c=mb_substr($src,$i,1);
      if ($f==0) { // English to Greek
         $j=mb_strpos($EnStr, $c);
         if ($j===false) {
            $c2 = $c;
         }
         else {
            $c2 = mb_substr($GrStr,$j,1);
         }
      }
      else { // Greek to English
         $j=mb_strpos($GrStr, $c);
         if ($j===false) {
            $c2 = $c;
         }
         else {
            $c2 = mb_substr($EnStr,$j,1);
         }
      }
      $strout .= $c2;
   }
   return $strout;
}
//--------------------------------------
function KbdToGr($strin)
{
   // Χρησιμοποιούμε όλα τα αντίστοιχα γράμματα πληκτρολογίου
   static $src="wertyuiopasdfghjklzxcvbnmERTYUIOPASDFGHJKLZXCVBNM";
 	static $out="ςερτυθιοπασδφγηξκλζχψωβνμΕΡΤΥΘΙΟΠΑΣΔΦΓΗΞΚΛΖΧΨΩΒΝΜ";

 	return strtr($strin,$src,$out);
}
//--------------------------------------
function ToEnglish($strin)
// Converts Greek 928 to lower English
{
   // Χρησιμοποιούμε όλα τα αντίστοιχα γράμματα πληκτρολογίου, εκτός από τα φωνήεντα
   // που είναι πάντα i και o. Τελευταία προσθέτουμε το κενό και τα κεφαλαία Αγγλικά H,Y.
   $src="hyvuHYVUαβγδεζηθικλμνξοπρστυφχψωςΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩάέίήύόώϊϋΆΈΊΉΎΌΏΪΫ.,-_%; |"."\\\"\'<>";
   $out="iioiiioiabgdeziiiklmnjoprstifxcowabgdeziiiklmnjoprstifxcoaeiiiooiiaeiiiooii......./"."/....";

   $strout='';
   $last_c2=false;
   $l=mb_strlen($strin);
   for ($i=0;$i<$l;$i++) {
      $c=mb_substr($strin,$i,1);
      $ii=mb_strpos($src,$c);
      if ($ii===false) {
         $c2 = $c;
      }
      else {
         $c2 = mb_substr($out,$ii,1);
      }
      
      if ($last_c2===$c2) {
         continue;
      }
      else {
         $strout .= $c2;
         $last_c2=$c2;
      }
   }
   
   return $strout;
}
//--------------------------------------
function UTF8strlen($s1)
{
   if ($s1===false)
      return 0;

   $l8=0;
   $l=strlen($s1);
   for ($i=0;$i<$l;$i++) {
      $x=ord($s1{$i});
      if ($x>=0 && $x<=0x7F) {
         $l8++;
      }
      else if ($x>=0xC2 && $x<=0xDF) { // start of a 2-byte sequence
         if ($i<$l-1) {
            $x1=ord($s1{$i+1});
            if ($x1>=0x80 && $x1=0xBF) {
               $l8++;
               $i++;
            }
         }
      }
      else if ($x>=0xE0 && $x<=0xEF) { // start of 3-byte sequence
         if ($i<$l-2) {
            for ($j=0;$j<2;$j++) {
               $x1=ord($s1{$i+1});
               if ($x1>=0x80 && $x1=0xBF) {
                  $l8++;
                  $i++;
               }
            }
         }
      }
      else if ($x>=0xF0 && $x<=0xF4) { // start of 4-byte sequence
         if ($i<$l-3) {
            for ($j=0;$j<3;$j++) {
               $x1=ord($s1{$i+1});
               if ($x1>=0x80 && $x1=0xBF) {
                  $l8++;
                  $i++;
               }
            }
         }
      }
      else {
         //echo "Incorrect byte $i value=$x\n";
         $l8++;
      }
   }

   return $l8;
}
//--------------------------------------
class cRECODE {
   var $ASCII;
   var $UTF8;

   function cRECODE()
   {
      $this->ASCII=array(
         chr(128),chr(129),chr(130),chr(131),chr(132),chr(133),chr(134),chr(135),chr(136),chr(137),
         chr(138),chr(139),chr(140),chr(141),chr(142),chr(143),chr(144),chr(145),chr(146),chr(147),
         chr(148),chr(149),chr(150),chr(151),chr(152),chr(153),chr(154),chr(155),chr(156),chr(157),
         chr(158),chr(159),chr(160),chr(161),chr(162),chr(163),chr(164),chr(165),chr(166),chr(167),
         chr(168),chr(169),chr(170),chr(171),chr(172),chr(173),chr(174),chr(175),chr(176),chr(177),
         chr(178),chr(179),chr(180),chr(181),chr(182),chr(183),chr(184),chr(185),chr(186),chr(187),
         chr(188),chr(189),chr(190),chr(191),chr(192),chr(193),chr(194),chr(195),chr(196),chr(197),
         chr(198),chr(199),chr(200),chr(201),chr(202),chr(203),chr(204),chr(205),chr(206),chr(207),
		   chr(208),chr(209),chr(210),chr(211),chr(212),chr(213),chr(214),chr(215),chr(216),chr(217),
         chr(218),chr(219),chr(220),chr(221),chr(222),chr(223),chr(224),chr(225),chr(226),chr(227),
         chr(228),chr(229),chr(230),chr(231),chr(232),chr(233),chr(234),chr(235),chr(236),chr(237),
         chr(238),chr(239),chr(240),chr(241),chr(242),chr(243),chr(244),chr(245),chr(246),chr(247),
         chr(248),chr(249),chr(250),chr(251),chr(252),chr(253),chr(254),chr(255) );

	   $this->UTF8=array(
         chr(226).chr(130).chr(172), chr(194).chr(129),          chr(226).chr(128).chr(154),
		   chr(198).chr(146),          chr(226).chr(128).chr(158), chr(226).chr(128).chr(166),
		   chr(226).chr(128).chr(160), chr(226).chr(128).chr(161), chr(194).chr(136),
		   chr(226).chr(128).chr(176), chr(194).chr(138),          chr(226).chr(128).chr(185),
		   chr(194).chr(140),          chr(194).chr(141),          chr(194).chr(142),          chr(194).chr(143),
		   chr(194).chr(144),          chr(226).chr(128).chr(152), chr(226).chr(128).chr(153),
		   chr(226).chr(128).chr(156), chr(226).chr(128).chr(157), chr(226).chr(128).chr(162),
		   chr(226).chr(128).chr(147), chr(226).chr(128).chr(148), chr(194).chr(152),
		   chr(226).chr(132).chr(162), chr(194).chr(154),          chr(226).chr(128).chr(186),
		   chr(194).chr(156),          chr(194).chr(157),          chr(194).chr(158),          chr(194).chr(159),
		   chr(194).chr(160),          chr(206).chr(133),          chr(206).chr(134),          chr(194).chr(163),
		   chr(194).chr(164),          chr(194).chr(165),          chr(194).chr(166),          chr(194).chr(167),
		   chr(194).chr(168),          chr(194).chr(169),          chr(239).chr(163).chr(185), chr(194).chr(171),
		   chr(194).chr(172),          chr(194).chr(173),          chr(194).chr(174),          chr(226).chr(128).chr(149),
		   chr(194).chr(176),          chr(194).chr(177),          chr(194).chr(178),          chr(194).chr(179),
		   chr(206).chr(132),          chr(194).chr(181),          chr(194).chr(182),          chr(194).chr(183),
		   chr(206).chr(136),          chr(206).chr(137),          chr(206).chr(138),          chr(194).chr(187),
		   chr(206).chr(140),          chr(194).chr(189),          chr(206).chr(142),          chr(206).chr(143),
		   chr(206).chr(144),          chr(206).chr(145),          chr(206).chr(146),          chr(206).chr(147),
		   chr(206).chr(148),          chr(206).chr(149),          chr(206).chr(150),          chr(206).chr(151),
		   chr(206).chr(152),          chr(206).chr(153),          chr(206).chr(154),          chr(206).chr(155),
		   chr(206).chr(156),          chr(206).chr(157),          chr(206).chr(158),          chr(206).chr(159),
		   chr(206).chr(160),          chr(206).chr(161),          chr(239).chr(163).chr(186), chr(206).chr(163),
		   chr(206).chr(164),          chr(206).chr(165),          chr(206).chr(166),          chr(206).chr(167),
		   chr(206).chr(168),          chr(206).chr(169),          chr(206).chr(170),          chr(206).chr(171),
		   chr(206).chr(172),          chr(206).chr(173),          chr(206).chr(174),          chr(206).chr(175),
		   chr(206).chr(176),          chr(206).chr(177),          chr(206).chr(178),          chr(206).chr(179),
		   chr(206).chr(180),          chr(206).chr(181),          chr(206).chr(182),          chr(206).chr(183),
		   chr(206).chr(184),          chr(206).chr(185),          chr(206).chr(186),          chr(206).chr(187),
		   chr(206).chr(188),          chr(206).chr(189),          chr(206).chr(190),          chr(206).chr(191),
		   chr(207).chr(128),          chr(207).chr(129),          chr(207).chr(130),          chr(207).chr(131),
		   chr(207).chr(132),          chr(207).chr(133),          chr(207).chr(134),          chr(207).chr(135),
		   chr(207).chr(136),          chr(207).chr(137),          chr(207).chr(138),          chr(207).chr(139),
		   chr(207).chr(140),          chr(207).chr(141),          chr(207).chr(142),          chr(239).chr(163).chr(187) );
   }
}
//--------------------------------------
function UTF8decode($a)
{
   if (is_string($a)) {  
      $ret=mb_convert_encoding($a, 'iso-8859-7', 'utf-8'); // convert (src, to, from encoding)
   }
   else if (is_array($a)) {         
      $ret=array();
      foreach ($a as $k1=>$a1) {
         if (is_string($a1)) {
            $ret[$k1]=mb_convert_encoding($a1, 'iso-8859-7', 'utf-8'); // convert (src, to, from encoding)
         }
         else {
            $ret[$k1]=$a1;
         }
      }
   }
   else {
      $ret=$a; // false -> false
   }

   // returns new string or new array
   return $ret;
}
//--------------------------------------
function SingleUTF8decode($a)
{
   /*
   static $z=false;

   if ($z===false)
      $z=new cRECODE();

   $b="";
   $l=strlen($a);
   for ($i=0;$i<$l;$i++) {
      $c=$a{$i};
      if (($x=ord($c))<=127) {
         $b .= $c;
      }
      else { // starting a Unicode sequence
         if (($x & 32)==32) {
            $buf=substr($a,$i,3);
            $i += 2;
         }
         else {
            $buf=substr($a,$i,2);
            $i++;
         }
         if (($x=array_search($buf,$z->UTF8))===false) {
            $b .= $buf;
         }
         else {
            $b .= $z->ASCII[$x];
         }
      }
   }
   return $b;
   */
   return mb_convert_encoding($a, 'iso-8859-7', 'utf-8'); // convert (src, to, from encoding)
}
//--------------------------------------
function ToUTF8($a)
{
   /*
   static $z=false;

   if ($z===false)
      $z=new cRECODE();

   $b="";
   $l=strlen($a);
 	for ($i=0;$i<$l;$i++) {
	   $c=$a[$i];
	   $x=ord($c);
	   if ($x<=127) {
		   $b .= $c;
	   }
	   else {
	      $j=array_search($c,$z->ASCII);
		   $b .= $z->UTF8[$j];
	   }
	}
	return $b;
   */
   return mb_convert_encoding((string)$a, 'utf-8', 'iso-8859-7'); // convert (src, to, from encoding)
}
//--------------------------------------
function array_to_utf8(&$val, $key)
{
   $val=ToUTF8($val);
}
//--------------------------------------
function floatFormatZ($num)
{
   //
   // Cut trailing decimal 0s. If no trailing decimals exist, cut  decimal separator too.
   //
   $d1=(string)toFloat($num);
   if (($i=strpos($d1,'.'))===false)
      return $d1;

   $l=strlen($d1);
   while ($l>0 && $d1{$l-1}=='0') {
      $l--;
   }
   if ($d1{$l-1}=='.') {
      $l--;
   }
   $d1=substr($d1,0,$l);
   
   return $d1;
}
//--------------------------------------
function floatFormatC($num)
{
   // Like floatFormatZ(), but if number is 0, return nothing (empty).
   $rets=floatFormatZ($num);
   if ($rets==0)
      return '';
   else
      return $rets;
}
//--------------------------------------
function floatFormat($num,$dd)
// DEPRECATED: you can call toFloat($num,$dd) 
{
	$format='%0.'.$dd.'f';
	$ret=sprintf($format,toFloat($num));
	return $ret;
}
//--------------------------------------
function floatFormatEx($num,$dd)
{
	$s1=(string)$num;

   // New code
	if (($s2=strstr($s1,'.'))!==false) {
	   $l=strlen($s2);
	   while ($l>0 && $s2{$l-1}=='0') {
	      $l--;
	   }
	   if (($l-1)>$dd) {
	      $dd=$l-1;
      }
   }
   return floatFormat($num,$dd);
}
//--------------------------------------
class cPROFILER1
{
   private $sec;

   function __construct()
   {
      $this->reset();
   }

   public function reset()
   {
      $this->sec=0;

   	$a=microtime(); 
   	$a2=explode(' ',$a);
      if (count($a2)!=2)
         return;

      $this->sec=(float)$a2[1] + (float)$a2[0];
   }

   public function elapsed()
   {
      $a=microtime(); 
   	$a2=explode(' ',$a);
      if (count($a2)!=2)
         return 0.0;

      $sec2=(float)$a2[1] + (float)$a2[0];
      return $sec2-$this->sec;
   }

   public function out($str=false)
   {
      echo "<!-- ";
      if ($str!==false) echo $str.": ";
      echo "Elapsed ".$this->elapsed()." -->";
   }

   public function outT($str=false)
   {
      echo "<br>";
      if ($str!==false) echo $str.": ";
      echo "Elapsed ".$this->elapsed()."\n";
   }
}
//--------------------------------------
function xlabel(&$db,$ids,$lang)
{
	$ret=false;

   if ((int)$lang==0) {
      $query="SELECT WLABEL, LANGID FROM ishop_langdic WHERE SHORTHAND=? AND LANGID=?";
   }
   else {
      $query="SELECT WLABEL, LANGID FROM ishop_langdic WHERE SHORTHAND=? ".
         " AND (LANGID=? OR LANGID=0) ORDER BY LANGID DESC";
   }
   $data=array($ids, (int)$lang);
   if (($rs=$db->Execute($query,$data))===false)
      return $db->ErrorMsg();
   while ($o1=$rs->FetchNextObject()) {
      $ret = $db->verify_8($o1->WLABEL);
      if (!empty($ret))
      	break;
   }
   $rs->Close();

   if (empty($ret))
      $ret=$ids;

   if ($o1===false || $o1->LANGID!=$lang) {
      // Could not find appropriate language entry: record the event
      $progname=(string)@$_SERVER['PHP_SELF'];
		$data=array('SHORTHAND'=>$ids, 'PROGNAME'=>$progname, 'LASTQUERY'=>date('Ymd') );
		$prim=array('SHORTHAND');
		$db->Replace('ishop_lang', $data, $prim, $autoQuote=true);
   }

   return $ret;
}
//--------------------------------------
function is_alphanumeric($ch1)
{
   $x=ord($ch1);

   return ( ($x>=ord('A') && ord($ch1)<=ord('Z')) ||
      ($x>=ord('a') && $x<=ord('z')) ||
      ($x>=ord('0') && $x<=ord('9')) ||
      $x==ord('_') || $x==ord('.') );
}
//--------------------------------------
function query_replace(&$query, $src, $outs)
{
   $k=strlen($src);
   $x=0;
   while (($i=strpos(($s2=substr($query, $x)), $src))!==false) {
      $x0=$x; // save old position
      $x += $i+$k;

      if ( $i>0 && is_alphanumeric( $s2{$i-1} ) ) {
         continue;
      }
      if (substr($s2,$i+$k,1)!='(' && substr($s2,$i+$k,2)!=' (') {
         continue;
      }

      $query = substr($query,0,$x0+$i).$outs.substr($query,$x0+$i+$k);
   }
}
//--------------------------------------
class cPREPROCESS
{
   var $x=0;
   var $x0;
   var $i;
   var $j1;
   var $j2;
   var $s2;
   // for internal use:
   var $key;
   var $k;
   var $sep;
   //......................................
   function cPREPROCESS($s1, $s2=',')
   {
      $this->key=$s1;
      $this->k=strlen($this->key);

      $this->sep=array();
      $l=strlen($s2);
      for ($i=0;$i<$l;$i++)
         $this->sep[]=$s2{$i};
   }
   //......................................
   function parse(&$query)
   {
      while (($this->i = strpos(($this->s2 = substr($query, $this->x)), $this->key))!==false) {
         $this->x0 = $this->x; // save old position
         $this->x += $this->i + $this->k;

         if ( $this->i > 0 && is_alphanumeric($this->s2{$this->i-1}) ) {
            //var_dump( "cont_a", $this->s2, $this->x, $this->i);
            continue;
         }
         $s3=trim(substr($this->s2, $this->i+$this->k, 10));
         if ($s3{0}!='(') {
            //echo "cont_b\n";
            continue;
         }

         $ar1=array();
         if (($i1=strpos(substr($this->s2, $this->i),'('))===false) {
            //echo "cont_c\n";
            continue;
         }

         $l=strlen($this->s2);
         $opn=0;
         $this->j1 = $this->i+$i1+1;
         $this->j2 = -1;
         $instr=false;
         for ($j=$this->j1;$j<$l;$j++) {
            if ($this->s2{$j}=='\'') {
               $instr = !$instr;
               continue;
            }

            if ($instr)
               continue;

            if ($this->s2{$j}=='(') {
               $opn++;
            }
            else if ($this->s2{$j}==')') {
               if ($opn>0)
                  $opn--;
               else {
                  $this->j2=$j;
                  break;
               }
            }
         }
         if ($this->j2<0)
            continue;

         $cs=substr($this->s2, $this->j1, $this->j2-$this->j1);
         // Process $c$
         $ar1 = array();
         $l = strlen($cs);
         $opn = 0;
         $k1 = 0;
         $instr=false;
         for ($j=0;$j<$l;$j++) {
            if ($cs{$j}=='\'') {
               $instr = !$instr;
               continue;
            }

            if ($instr)
               continue;

            if ($cs{$j}=='(') {
               $opn++;
               continue;
            }
            else if ($cs{$j}==')') {
               if ($opn>0)
                  $opn--;

               continue;
            }

            if ($opn>0)
               continue;

            if (in_array($cs{$j}, $this->sep)) {
               if ($j>$k1) {
                  $ar1[]=trim(substr($cs,$k1,$j-$k1));
               }
               $k1=$j+1;
            }
         }
         if ($k1<$l)
            $ar1[]=trim(substr($cs,$k1));

         return $ar1;
      }

      return false;
   }
   //......................................
}
//--------------------------------------
function preprocess_mysql(&$query)
{
   $query = strtr($query, "\r\n\t", str_repeat(' ',3) );

   // XDATE(datetime)
   $c1=new cPREPROCESS('XDATE');
   while (($ar1=$c1->parse($query))!==false) {
      if (count($ar1)!=1) {
         //echo "cont_e\n";
         continue;
      }
      $newstr = "DATE_FORMAT( $ar1[0], '%Y-%m-%d' )";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // XTIME(datetime)
   $c1=new cPREPROCESS('XTIME');
   while (($ar1=$c1->parse($query))!==false) {
      if (count($ar1)!=1) {
         //echo "cont_e\n";
         continue;
      }
      $newstr = "DATE_FORMAT( $ar1[0], '%H:%i:%s' )";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }
}
//--------------------------------------
function preprocess_sql2000(&$query)
{
   query_replace($query, 'NOW', 'GETDATE');
   query_replace($query, 'LENGTH', 'DATALENGTH');
   query_replace($query, 'UNIX_TIMESTAMP', 'dbo.UNXTIMESTAMP');
   query_replace($query, 'XTIME', 'dbo.TIMEX');

   // LIMIT x
   $ar1=explode(' ',$query);
   if (($k=array_search('LIMIT',$ar1))!==false) {
      $x=$ar1[$k+1];
      array_splice ($ar1, $k, 2);
      if ($ar1[0]=='SELECT')
         array_splice($ar1, 1, 0, array('TOP', (string)$x));

      $query=implode(' ',$ar1);
   }

   // CONCAT(str1,str2,...)
   $c1=new cPREPROCESS('CONCAT');
   while (($ar1=$c1->parse($query))!==false) {
      $newstr="(".implode('+',$ar1).")";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // LPAD(str,len,padstr)
   $c1=new cPREPROCESS('LPAD');
   while (($ar1=$c1->parse($query))!==false) {
     if (count($ar1)!=3) {
         //echo "cont_e\n";
         continue;
      }
      $newstr="RIGHT( REPLICATE($ar1[2], $ar1[1] ) + STR( $ar1[0] ), $ar1[1] )";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // XDATE(datetime)
   $c1=new cPREPROCESS('XDATE');
   while (($ar1=$c1->parse($query))!==false) {
      if (count($ar1)!=1) {
         //echo "cont_e\n";
         continue;
      }
      $newstr="SUBSTRING(CONVERT(CHAR, $ar1[0], 120), 1, 10)";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // CAST
   $c1=new cPREPROCESS('CAST', ' ');
   while (($ar1=$c1->parse($query))!==false) {
      if (count($ar1)!=3)
         continue;

      if ($ar1[1]!='AS')
         continue;

      switch (strtoupper($ar1[2]))
      {
      case 'SIGNED':
         $datatype='INT';
         break;
      case 'CHAR':
         $datatype='VARCHAR';
         break;
      default:
         $datatype=$ar1[2];
         break;
      }

      $newstr="CAST(".$ar1[0]." AS $datatype)";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // EXTRACT(type FROM date)
   $c1=new cPREPROCESS('EXTRACT', ' ');
   while (($ar1=$c1->parse($query))!==false) {
      if (count($ar1)!=3)
         continue;

      if ($ar1[1]!='FROM')
         continue;

      $newstr="DATEPART(";
      switch ($ar1[0])
      {
      case 'HOUR':
         $newstr .= 'hour, ';
         break;
      }
      $newstr .= $ar1[2].' )';

      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }

   // IF(boolean_expression, ret1, ret2)
   $c1=new cPREPROCESS('IF');
   while (($ar1=$c1->parse($query))!==false) {
     if (count($ar1)!=3) {
         //echo "cont_e\n";
         continue;
      }
      $newstr="( CASE WHEN ($ar1[0]) THEN ($ar1[1]) ELSE ($ar1[2]) END )";
      $query = substr_replace($query, $newstr, $c1->x0 + $c1->i, $c1->j2 - $c1->i + 1);
   }
}
//--------------------------------------
function PageExecuteEx(&$db,$query,$pgsz,$pg,$data=false)
{
   switch ($db->databaseType)
   {
   case 'mssql':
   case 'ado_mssql':
      preprocess_sql2000($query);
      break;
   case 'mysqlt':
      preprocess_mysql($query);
      break;
   }

   return $db->PageExecute($query,$pgsz,$pg,$data);
}
//--------------------------------------
function ExecuteEx(&$db, &$query, $data=false)
{
   switch ($db->databaseType)
   {
   case 'mssql':
   case 'ado_mssql':
      preprocess_sql2000($query);
      break;
   case 'mysqlt':
      preprocess_mysql($query);
      break;
   }

   return $db->Execute($query, $data);
}
//--------------------------------------
function InsertEx2(&$db, $t1, $data)
{
   static $colar=array();

   // 1st check (negative)
   if (!array_key_exists($t1,$colar)) {
      if (($coldatas=$db->MetaColumns($t1))!==false) {
         $co2=array();
         foreach ($coldatas as $k1=>$o1) {
            $co2[strtoupper($k1)]=$o1;
         }
         $colar[$t1]=$co2;
      }
   }

   // 2nd check (positive)
   if (array_key_exists($t1,$colar)) {
      $coldatas=$colar[$t1];
      foreach ($data as $key=>$val) {
         if (!isset($coldatas[$key]))
            continue;

         if ($coldatas[$key]->type=='varchar') {
            $max_length=(int)@$coldatas[$key]->max_length;
            if ($max_length>0 && mb_strlen($val)>$max_length)
               $data[$key]=mb_substr($val,0,$max_length);
         }
      }
   }

   return InsertEx($db, $t1, $data);
}
//--------------------------------------
function InsertEx(&$db, $t1, $data)
{
	$n=count($data);
   $query="INSERT INTO ".$t1." (".implode(',',array_keys($data)).")
		VALUES(".implode(',',array_fill(0,$n,'?')).")";
   $rdata=array_values($data);
   return $db->Execute($query,$rdata);
}
//--------------------------------------
function UpdateEx(&$db, $t1, $data, $where)
{
	$query="UPDATE $t1 SET ";
	$i=0;
   foreach($data as $k=>$v) {
      if ($i>0) {
         $query .= ",";
      }
      $query .= ($k.'=?');
      $i++;
   }

   $query .= " WHERE ";
   if (is_array($where)) {
      $i=0;
      foreach($where as $k=>$v) {
         if ($i>0) {
            $query.=" AND ";
         }
         $query .= ($k.'=?');
         $i++;
      }

      $rdata=array_merge( array_values($data), array_values($where) );
   }
   else {
      $query .= $where;
      $rdata = &$data;
   }

   return $db->Execute($query,$rdata);
}
//--------------------------------------
function ReplaceEx2(&$db, $t1, $data, $prim)
{
   static $colar=array();

   // 1st check (negative)
   if (!array_key_exists($t1,$colar)) {
      if (($coldatas=$db->MetaColumns($t1))!==false) {
         $colar[$t1]=$coldatas;
      }
   }

   // 2nd check (positive)
   if (array_key_exists($t1,$colar)) {
      $coldatas=$colar[$t1];
      foreach ($data as $key=>$val) {
         if (!isset($coldatas[$key]))
            continue;

         $cdx=$coldatas[$key];
         if ($cdx->type=='varchar') {
            $max_length=(int)@$cdx->max_length;
            if ($max_length>0 && mb_strlen($val)>$max_length) {
               $data[$key]=mb_substr($val,0,$max_length);
            }
         }
      }
   }
   
   return ReplaceEx($db, $t1, $data, $prim);
}
//--------------------------------------
function ReplaceEx2_dbg(&$db, $t1, $data, $prim)
{
   static $colar=array();

   // 1st check (negative)
   if (!array_key_exists($t1,$colar)) {
      if (($coldatas=$db->MetaColumns($t1))!==false) {
         $colar[$t1]=$coldatas;
      }
   }

   // 2nd check (positive)
   if (array_key_exists($t1,$colar)) {
      $coldatas=$colar[$t1];
      foreach ($data as $key=>$val) {
         if (!isset($coldatas[$key]))
            continue;

         $cdx=$coldatas[$key];
         if ($cdx->type=='varchar') {
            $max_length=(int)@$cdx->max_length;
            if ($max_length>0 && mb_strlen($val)>$max_length) {
               $data[$key]=mb_substr($val,0,$max_length);
            }
         }
      }
   }
   
   $ret=ReplaceEx($db, $t1, $data, $prim);
   
   if (!$ret) {
      print_r($data);
      
      if (array_key_exists($t1,$colar)) {
         $coldatas=$colar[$t1];
         foreach ($data as $key=>$val) {
            if (!isset($coldatas[$key]))
               continue;

            $cdx=$coldatas[$key];
            if ($cdx->type=='varchar') {
               $max_length=(int)@$cdx->max_length;
               echo "mb_len=".mb_strlen($val)." maxl=$max_length\n";               
            }
         }
      }      
      
   }
   
   return $ret;
}
//--------------------------------------
function ReplaceEx(&$db, $t1, $data, $prim)
{
   $wheres='';
   $wdata=array();
   $rdata=array();

   if (!empty($prim)) {
      if (!is_array($prim)) {
         $prim=explode(',',$prim);
         foreach ($prim as $key=>$val) {
            $prim[$key]=trim($val);
         }
      }
      
      $n=count($prim);
      for ($i=0;$i<$n;$i++) {
         $key=$prim[$i];

         if ($i==0)
            $wheres .= " WHERE $key=?";
         else
            $wheres .= " AND $key=?";

         if (!array_key_exists($key,$data)) {
            $key = strtoupper($key);
         }
         $wdata[] = $data[$key];
      }
   }

   $query="SELECT COUNT(*) FROM $t1 ".$wheres;
   if (($rs=$db->Execute($query,$wdata))===false) {                       
      $db->lastQuery=$query;
      $db->lastData=$wdata;
      echo __LINE__;
      return false;
   }
   $row=$rs->FetchRow();
   $rs->Close();

   if ($row!==false && (int)$row[0]>0) {
      $query="UPDATE $t1 SET ";
      $i=0;
      foreach($data as $k=>$v) {
         if (in_array($k,$prim))
            continue;

         if ($i>0) {
            $query.=",";
         }
         $query .= ($k.'=?');
         $rdata[]=$v;
         $i++;
      }
      if ($i==0) { // nothing to update
         return true;
      }
      $query .= $wheres;
      $rdata=array_merge($rdata,$wdata);
   }
   else {
      $n=count($data);
      $query="INSERT INTO ".$t1." (".implode(',',array_keys($data)).") VALUES(".implode(',',array_fill(0,$n,'?')).")";
      $rdata=array_values($data);
      
   }
   $ret = $db->Execute($query,$rdata)!==false;
   if (!$ret) {
      echo __LINE__;
      pre($query);
      pre($data);
      $db->lastQuery=$query;
      $db->lastData=$rdata;
   }
   return $ret;
}
//--------------------------------------
function UnlockTables(&$db)
{
   if ($db->databaseType==='mysqlt') {
      $query="UNLOCK TABLES";
      $db->Execute($query);
   }
   // else: on ado_mssql, mssql table locks are released at end of transaction
}
//--------------------------------------
function trim_dbl_comments($src)
{
   if (($i=strpos($src,'/*'))===false)
      return $src;

   if (($j=strpos($src,'*/',$i+2))===false)
      return $src;

   $outs=substr($src,0,$i).substr($src,$j+2);
   return trim_dbl_comments($outs);
}
//--------------------------------------
function remove_dash(&$val,$key)
{
	if (($i=strpos($val,' --'))!==false)
		$val=substr($val,0,$i);
}
//--------------------------------------
function trim_single_comm($query)
{
	$lines=explode("\n",$query);
	array_walk($lines,'remove_dash');
	return implode(' ',$lines);
}
//--------------------------------------
function mytrim(&$val,$key)
{
   $val=trim($val);
}
function squote(&$val, $key) 
{
   $val= "'".$val."'";
}
//------------------------------------------------------------------------------
function table_terminate($db,$t1,$a=false)
{
   echo "<h6>Could not create/alter table ${t1}: ".
		$db->ErrorMsg();
   if ($a!==false) {
     echo "\nfor [$a]";
   }
   echo "</h6>";
}
//--------------------------------------
function add_index(&$db,$t1,$idx,$checkonly=false)
{
   $keys=array();
   
   if ($db->databaseType==='mssql' || $db->databaseType==='ado_mssql') {
      $query="sp_helpindex $t1";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
         return false;
      }
      if (get_class($rs)!="adorecordset_empty") {
         while ($o1=$rs->FetchNextObject()) {
            $ar1=explode(',',$o1->INDEX_KEYS);
            array_walk($ar1,'mytrim');
            $keys[$o1->INDEX_NAME]=$ar1;
         }
         $rs->Close();
      }
   }
   else { // mysql
      $query="SHOW INDEX FROM $t1";
      if (($rs=$db->Execute($query))===false) {
         table_terminate($db,$t1,$query);
         return false;
      }
      while ($o1=$rs->FetchNextObject()) {
         if (!array_key_exists($o1->KEY_NAME,$keys))
            $keys[$o1->KEY_NAME]=array();

         $keys[$o1->KEY_NAME][]=$o1->COLUMN_NAME;
      }
      $rs->Close();
   }

   $remove_keys=array();
   
   foreach ($idx as $k1=>$var1) { // for each key index passed in parameter
      if (is_array($var1))
         $s1=implode(',',$var1);
      else
         $s1=strtr($var1, array(' '=>'') );

      $fi=false;
      foreach ($keys as $k2=>$ar2) { // for each key index read from file
         $s2=implode(',',$ar2);
         if (strcasecmp($s1,$s2)==0) {
            // An existing  key was found with exact same fields
            if (strcasecmp($k2,$k1)==0) {
               $fi=true;
               break;
            }
            else {
               // Fields do match, but key names do not match: drop the key
               $remove_keys[]=$k2;
            }
         }
      }
      if ($fi) {
         // An exact match was found to exist for this request; ignore this request
         continue;
      }

      // Not found so far: try drop (just in case it was set with diff. fields) than create
      // Ignore errors on drop
      $query="ALTER TABLE $t1 DROP INDEX $k1";      
      if ($checkonly)
         echo "Need: $query<br>";
      else if ($db->Execute($query))
         echo "<h6>Removed index $k1 on $t1</h6>\n";
      else
         echo "<!-- Error on [$query]: ".$db->ErrorMsg()." -->";

      $query="CREATE INDEX $k1 ON $t1 ($s1)";
      if ($checkonly)
         echo "Need: $query<br>";
      else if ($db->Execute($query))
         echo "<h6>Added index $k1 on $t1</h6>\n";
      else
         echo "<h6>Error on [$query]: ".$db->ErrorMsg()."</h6>";
   }
   
   foreach ($remove_keys as $k2) {
      $query="ALTER TABLE $t1 DROP INDEX $k2";
      if ($checkonly)
         echo "Need: $query<br>";
      else if ($db->Execute($query))
         echo "<h6>Removed index $k2 on $t1</h6>\n";
      else
         echo "<h6>Error on [$query]: ".$db->ErrorMsg()."</h6>";
   }

   return true;
}
//--------------------------------------
function process_fields(&$val,$key)
{
   $val=strtoupper($val);
   
	if (($i=strpos($val,'NOT NULL'))===false)
		return;

	if ((strlen($val)-$i-8)>0)
		return;

	$ar1=array();
	$tok=strtok($val,' (');
	while ($tok!==false) {
		$ar1[]=$tok;
		$tok=strtok(' (');
	}
	if (count($ar1)<2)
		continue;
      
	switch ($ar1[1])
	{
	case 'INT':
	case 'SMALLINT':
	case 'TINYINT':
		$val .= ' DEFAULT 0';
		break;
	case 'NUMERIC':
		$val .= ' DEFAULT 0.0';
		break;
	case 'CHAR':
	case 'VARCHAR':
		$val .= ' DEFAULT \'\'';
		break;
	}
}
//--------------------------------------
function process_for_lastupd(&$db,$t1,$fields,$drop_existing)
// ado_mssql, mssql code
{
   $tr1=$t1.'_tr1';

   $fi=false;
   $query="sp_helptrigger @tabname='$t1' ";
   if (($rs=$db->Execute($query))===false) {
      table_terminate($db,$t1,$query);
      return false;
   }
   while ($o1=$rs->FetchNextObject()) {
      if ($o1->TRIGGER_NAME==$tr1) {
         $fi=true;
         break;
      }
   }
   $rs->Close();

   // Force remake: $drop_existing=true;

   if ($fi) {
      if ($drop_existing) {
         $query="DROP TRIGGER $tr1";
         if (!$db->Execute($query)) {
            table_terminate($db,$t1,$query);
            return false;
         }
      }
      else {
         // OK, nothing else to do
         return true;
      }
   }

   // Search for LASTUPDATE; if not found abort.
   $fi=false;
   foreach ($fields as $f1) {
      $ar1=explode(' ',$f1);
      if (!empty($ar1) && $ar1[0]=='LASTUPDATE') {
         $fi=true;
         break;
      }
   }
   if (!$fi)
      return true;

   foreach ($fields as $f1) {
      $sep=' (,)';
      $s1=strtok($f1,$sep);
      if ($s1!='PRIMARY')
         continue;

      $ar1=array();
      while (($s1=strtok($sep))!==false) {
         $ar1[]=$s1;
      }
      if (($n=count($ar1))<2 || $ar1[0]!='KEY')
         continue;

      $query="CREATE TRIGGER $tr1
         ON $t1 FOR UPDATE
         AS
         UPDATE $t1 SET LASTUPDATE=GETDATE()
      	WHERE ";
      $qsel="(SELECT ";
      for ($i=1;$i<$n;$i++) {
         if ($i>1) {
            $query .= " + '#' + ";
         }
         $pk=$ar1[$i];
         $query .= " CAST($pk AS VARCHAR) ";

         if ($i>1) {
            $qsel .= " + '#' + ";
         }
         $qsel .= " CAST($pk AS VARCHAR) ";
      }
      $qsel .= " FROM inserted)";
      $query .= " IN ".$qsel;

      if ($db->Execute($query))
         echo "<h6>Added trigger $tr1</h6>";
      else {
         table_terminate($db,$t1,$query);
         return false;
      }
   }

   return true;
}
//--------------------------------------
function	my_check_unique(&$db,$t1,$indexes)
{
   $fileidx=array();
   $query="SHOW INDEX FROM $t1";
   if (($rs=$db->Execute($query))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   while ($o1=$rs->FetchNextObject()) {
      if (strcmp($o1->KEY_NAME,"PRIMARY")==0 || $o1->NON_UNIQUE==1)
         continue;
         
      if (!array_key_exists($o1->KEY_NAME, $fileidx)) {
         $fileidx[$o1->KEY_NAME]=array();
      }
      $fileidx[$o1->KEY_NAME][]=$o1->COLUMN_NAME;
   }
   $rs->Close();
   
   $ar1=str_replace(" ", "", $indexes);
   
   // Compare data
   $err=false;
   do {
      if (count($fileidx)!=count($ar1)) {
         $err=true;
         break;
      }
   
      ksort($fileidx);
      $i=0;
      foreach ($fileidx as $ar2) {
         $s2=implode(',', $ar2);
         if (strcasecmp($s2,$ar1[$i])!=0) {
            $err=true;
            break;
         }
         $i++;
      }
      
   } while (false);
   
   if ($err) {
      foreach ($fileidx as $k2=>$ar2) {
         $query="ALTER TABLE $t1 DROP INDEX $k2";
         if (!$db->Execute($query))
            echo "<h6>$query: ".$db->Errormsg()."</h6>";
         else
            echo "<h6>Done: $query</h6>";
      }
      
      foreach ($ar1 as $k1) {
         $query="ALTER TABLE $t1 ADD UNIQUE ($k1)";
         if (!$db->Execute($query))
            echo "<h6>$query: ".$db->Errormsg()."</h6>";
         else
            echo "<h6>Done: $query</h6>";
      }
   }   
   
   return true;
}
//--------------------------------------
function	ms_check_unique(&$db,$t1,$indexes)
{
   echo "<h6>Can check $t1 indexes: ms_check_unique() partially implemented!<h6>";
   return;
   
   $ar1=str_replace(" ", "", $indexes);
   
   foreach ($ar1 as $k1) {
      $query="ALTER TABLE $t1 ADD UNIQUE ($k1)";
      if (!$db->Execute($query))
         echo "<h6>$query: ".$db->Errormsg()."</h6>";
      else
         echo "<h6>Done: $query</h6>";
   }
}
//--------------------------------------
function	process_meta(&$db,&$tables,$t1,$query)
{
   $prof=new cPROFILER1();
   
   if ($db->databaseType==='mssql' || $db->databaseType==='ado_mssql') {
      $pat=array();
      $rpl=array();
      
   	$pat[0]='/\bENGINE=InnoDb/i';
   	$pat[1]='/\bTIMESTAMP\(*[0-9]*\)*/i';
   	$pat[2]='/\bAUTO_INCREMENT/i';
   	$pat[3]='/\bMEDIUMTEXT/i';
   	$pat[4]='/\bMEDIUMBLOB/i';
      /*
      $pat[5]='/\bCHAR\b/i';
      $pat[6]='/\bVARCHAR\b/i';
      */

   	$rpl[0]='';
   	$rpl[1]='DATETIME NOT NULL DEFAULT GETDATE()';
   	$rpl[2]='IDENTITY';
   	$rpl[3]='TEXT';
   	$rpl[4]='IMAGE';
      /*
      $rpl[5]='NCHAR';
      $rpl[6]='NVARCHAR';
      */

   	$query=preg_replace($pat, $rpl, $query);
   }

   $query=trim_dbl_comments($query);
   $query=trim_single_comm($query);

	$cr=strpos($query,'CREATE ');
	if ($cr===0) {
		$i=strpos($query,'(');
		if ($i!==false) {
			$query=substr($query,$i+1);
      }
	}

	// Remove special chars.
	$query=strtr($query,"\r\n\t",'   ');

   for ($i=0;$i<2;$i++) {
      if (do_proc_meta($db,$tables,$t1,$query)) {
         break;
      }
   }
}
function fld_post_process($s1)
{
   $s2 = trim($s1);
   $s2U = strtoupper($s2);
   if (startsWith('PRIMARY', $s2U) || startsWith('UNIQUE', $s2U))
      return $s2;

   if (strpos($s2U,'NULL')===false) {
      $s2 .= ' NULL';
   }
   return $s2;
}      
//--------------------------------------
function getFieldsArray($query)
{
   // Parse query: search for a ',', but whenever inside parenthesis, ignore.
   $l=strlen($query);
   $fields=array();
   $inParenthesis=false;
   $inQuotes=false;
   $s1='';
   for ($i=0;$i<$l;$i++) {
      $c=$query{$i};
      if ($c=='(') {
         $inParenthesis=true;
         $s1 .= $c;
      }
      else if ($c==')') {
         $inParenthesis=false;
         $s1 .= $c;
      }
      else if ($c=='\'') {
         $inQuotes = !$inQuotes;
         $s1 .= $c;
      }
      else if ($inParenthesis || $inQuotes) {
         $s1 .= $c;
      }
      else if ($c==',') {
         $fields[] = fld_post_process($s1);
         $s1='';
      }
      else {
         $s1.=$c;
      }
   }
   if (strlen($s1)>0) {
      $fields[] = fld_post_process($s1);
   }
   
   return $fields;
}
//--------------------------------------
function	do_proc_meta(&$db,&$tables,$t1,$query)
{
   global $verbose;
   $verbose = ($t1==='ishop_mbr_prop22');
   
   $fields = getFieldsArray($query);
   /*
   // Parse query: search for a ',', but whenever inside parenthesis, ignore.
   $l=strlen($query);
   $fields=array();
   $inParenthesis=false;
   $inQuotes=false;
   $s1='';
   for ($i=0;$i<$l;$i++) {
      $c=$query{$i};
      if ($c=='(') {
         $inParenthesis=true;
         $s1 .= $c;
      }
      else if ($c==')') {
         $inParenthesis=false;
         $s1 .= $c;
      }
      else if ($c=='\'') {
         $inQuotes = !$inQuotes;
         $s1 .= $c;
      }
      else if ($inParenthesis || $inQuotes) {
         $s1 .= $c;
      }
      else if ($c==',') {
         $fields[]=trim($s1);
         $s1='';
      }
      else {
         $s1.=$c;
      }
   }
   if (strlen($s1)>0) {
      $fields[]=trim($s1);
   }
   */
   
   $t_options='';
   if (($n=count($fields))>0) {
      $ar1=explode(')',$fields[$n-1]);
      if (count($ar1)>=3 && strlen(trim($ar1[1]))==0) {
         $fields[$n-1] = $ar1[0].')';
         array_shift($ar1);
         array_shift($ar1);
         $t_options=implode(')',$ar1);
      }
   }

   array_walk($fields,'process_fields');

	//
	// If table does not exist
	//
	if (!in_array($t1,$tables)) {
      if ($db->databaseType==='mysqlt') {
	     if (!empty($t_options)) {
	        $t_options .= ', ';
         }
         $t_options .= " COLLATE utf8_general_ci";
      }
       
	   $q2="CREATE TABLE $t1 (".implode(', ',$fields)." ) ".$t_options; 
      echo($q2);
      if ($db->Execute($q2)) {
         echo "<h6>Created $t1</h6>\n";
         if ($db->databaseType==='mssql' || $db->databaseType==='ado_mssql')
            process_for_lastupd($db,$t1,$fields,$drop=true);
      }
      else {
      	table_terminate($db,$t1,$q2);
      	return false;
      }

      return true;
   }

	//
	// Table already exists
	//
	$ar1=$db->MetaColumns($t1); // v5.11: always return associative array   
	// Convert into associative array, even if not, keys and field names in uppercase
	$fileCols=array();
	foreach ($ar1 as $o1) {
	   $o1->name = strtoupper(trim($o1->name));
	   $fileCols[$o1->name] = $o1;
   }

	if ($verbose) {
	   echo "fileCols:"; 
      pre($fileCols);
      echo "Fields:"; 
      pre($fields);
   }
   
   $queryCols=array();
   $indexes=array();
   $fobj=array();
   $make_primary=false;
   $newPrims=false;
   
   $nF=count($fields);
   
   for ($i=0;$i<$nF;$i++) {
      $fo=new cFIELDOBJEC($fields[$i]);
      $fobj[]=$fo;
      
      if (!empty($fo->primkey)) {
         $newPrims=$fo->primkey;
         
         $prims=$db->MetaPrimaryKeys($t1);
         if (empty($prims)) {
            $pks='';
         }
         else {
            $pks=clear_spaces(implode(',',$prims)); // old definition of primary key
         }
         //if ($verbose) { echo "pks=$pks\n"; pre($fo); }
         if (strcasecmp($pks, $fo->primkey)!=0) {
            // NEED REMAKE PRIMARY
            $make_primary=true;
            $query2="ALTER TABLE $t1 DROP PRIMARY KEY";
            if (!$db->Execute($query2)) {
               table_terminate($db,$t1,$query2);
               // do not return
            }
            else {
               echo "<h6>Processed $t1 ($query2)</h6>\n";
            }
         }
      }
   }
   
   for ($i=0;$i<$nF;$i++) {
      $fo=$fobj[$i];
      if ($verbose) {
         pre($fo);
      }

      if (strcmp($fo->name,"PRIMARY")==0) { // reach (almost) end of lines
         continue;
      }
      else if (strcmp($fo->name,"UNIQUE")==0) {
         if (($j=strpos($fields[$i],"("))!==false) {
            $s2=substr($fields[$i],$j+1);
            if (($j=strpos($s2,")"))!==false) {
               $indexes[]=substr($s2,0,$j);
            }
         } 
         continue;
      }

      // Keep track of columns found, so that we can later delete any exceeding one
      $queryCols[] = strtoupper($fo->name);

      if (!array_key_exists($fo->name, $fileCols)) {
         if ($db->databaseType==='mysqlt' && stripos($fields[$i], 'AUTO_INCREMENT')!==false) {
            $query2="ALTER TABLE $t1 DROP PRIMARY KEY";
            if (!$db->Execute($query2)) {
               table_terminate($db,$t1,$query2);
				   // do not return: PRIMARY may already have disappeared
            }
            else {
               echo "<h6>Processed $t1 ($query2)</h6>\n";
            }
            $make_primary=true;
         }
         
         $query2="ALTER TABLE $t1 ADD ".$fields[$i];
         if ($db->databaseType=='mysqlt') {
            if ($make_primary) {
               $query2 .= " key";
            }
         
            if ($i==0) {
               $query2 .= " FIRST ";
            }
            else { // $i>0
               $query2 .= " AFTER ".$lastkey;
            }
         }
         if ($db->Execute($query2))
            echo "<h6>Processed $t1 ($query2)</h6>\n";
         else {
				table_terminate($db,$t1,$query2);
				return false;
			}
      }
      else if ($fo->differs( $fileCols[$fo->name] )) { // $fo: cFIELDOBJEC
         switch ($db->databaseType)
         {
         case 'mssql':
         case 'ado_mssql':
            $query2="ALTER TABLE $t1 ALTER COLUMN ".$fields[$i];
            // ms-sql CAN NOT contain a DEFAULT definition in ALTER
            if (($j=strpos(strtoupper($query2), 'DEFAULT'))!==false) {
               $query2=substr($query2,0,$j);
            }
            break;
         default: // mysql
            $query2="ALTER TABLE $t1 CHANGE ".$fo->name." ".$fields[$i];
            break;
         }
         if ($db->Execute($query2))
            echo "<h6>Processed $t1 ($query2)</h6>\n";
         else {
				table_terminate($db,$t1,$query2);
				return false;
			}
      }

      $lastkey=$fo->name;
   }

   foreach ($fileCols as $fc1) {
      if (!in_array(strtoupper($fc1->name), $queryCols)) {
         $query2="ALTER TABLE $t1 DROP COLUMN ".$fc1->name;
         if ($db->Execute($query2))
            echo "<h6>Processed $t1 ($query2)</h6>\n";
         else { // error
            pre($fileCols);
				table_terminate($db,$t1,$query2);
				return false;
			}
      }
   }
   
   if ($make_primary) {
      $query2="ALTER TABLE $t1 ADD PRIMARY KEY ($newPrims) ";
      if (!$db->Execute($query2)) {
         table_terminate($db,$t1,$query2);
			// do not return 
      }
      else {
         echo "<h6>Processed $t1 ($query2)</h6>\n";
      }
   }
   
/*
$ar1=$db->MetaColumnNames($t1);
pre($ar1);

$ar1=$db->MetaPrimaryKeys($t1);
pre($ar1);
*/   
   
   if (!empty($indexes)) {
      switch ($db->databaseType)
      {
      case 'mysqlt':
         my_check_unique($db,$t1,$indexes);
         break;
      case 'mssql':
      case 'ado_mssql':
         ms_check_unique($db,$t1,$indexes);
         break;
      }         
   }

   if ($db->databaseType==='mssql' || $db->databaseType==='ado_mssql')
      process_for_lastupd($db,$t1,$fields,$drop=false);

   //echo "<!-- process_meta Elapsed Time=".$prof->elapsed()." -->\n";
   return true;
}
//--------------------------------------
function &fread_new_hasp($fp)
{
	$ret=array();

	while (!feof($fp)) {
		$re1=fgets($fp,64);
		$re=trim($re1);
		if (empty($re))
         continue;

      $ret[]=$re;
	}

	return $ret;
}
//--------------------------------------
function fread_old_hasp($fp)
{
	$ret=array();

   while (!feof($fp)) {
		$re1=fgets($fp,64);
		$re=trim($re1);
      if (empty($re))
         continue;

      $rex=explode('x',$re);
      foreach ($rex as $re1) {
         // A => Pocket.ERP (Common), B => Restaurant, C => ΑΠΟΓΡΑΦΗ
         if (strlen($re1)<2)
            continue;

         $k1=$re1{0};
         if (array_key_exists( $k1, $ret ))
				$ret[ $k1 ]=$ret[ $k1 ] + (int)substr($re1,1);
			else
            $ret[ $k1 ]=(int)substr($re1,1);
      }
   }

   return $ret;
}
//--------------------------------------
function r_serials(&$db,$rn1)
{
   $ret=array();
   
   do {
      if ($db===false)
         break;
         
      $query="SELECT * FROM hasp_lic WHERE HASPID=?";
      $data=array($rn1);
      if (($rs=$db->Execute($query,$data))===false) {
         echo $db->ErrorMsg();
         break;
      }
      $o1=$rs->FetchNextObject();
      $rs->Close();
      
      if ($o1===false) {
         // Nothing found, but normal
         break;
      }
      
      if (($ar2=unserialize(encode_decode_data(2, $o1->CLICENSE)))===false) {
         echo "<!-- Data error (unserialize failed)) -->";
         break;
      }
      
      if (strcmp($ar2['HASPID'],$rn1)==0) {
         $ret=$ar2;
      }
      // else do nothing (improper data) 
      
   } while (false);
   
   return $ret;
}
//--------------------------------------
function apply_hasp(&$db, &$ret, $rn1)
{
   // New code (start)
   if ($ret===false)
		$ret=array('zSerial'=>'');

   $ret['zSerial'] = $ret['zSerial'].'#'.$rn1;
   // New code (end)

   $ked='zEndDate';
   $r2=r_serials($db,$rn1);
   if (!empty($r2)) {
      if (!array_key_exists($ked,$ret)) {
         $ret[$ked]='';
      }
      $ret[$ked] = $ret[$ked].'#'.$r2[$ked];
            
		if (!isset($r2[$ked]) || $r2[$ked] < date('Ymd')) // license not good
			return;

		foreach ($r2 as $k=>$v) {
         switch ($k)
         {
         case $ked: // nothing to do, already processed
            break;
         default:
            if (!array_key_exists($k,$ret)) {
               $ret[$k]=0;
            }
            $ret[$k]=$ret[$k]+$v;
            break;
         }
      } // foreach ($r2...)
	}
}
//--------------------------------------
function getHaspInfoB(&$db)
{
   if (strcmp(PHP_OS,'WINNT')!=0) {
      // Αν ΔΕΝ είναι Windows, άρα είναι Linux:
 		return array('A'=>99, 'B'=>99, 'B2'=>99, 'C'=>99, 'D'=>99, 'E'=>99, 'F'=>99, 'X1'=>1, 'X2'=>1 );
 	}

 	$is_apache = (isset($_SERVER['SERVER_SOFTWARE']) && strncmp($_SERVER['SERVER_SOFTWARE'],"Apache",6)==0);

   $ris=array();
 	if (!$is_apache && $db!==false) {
      $query="SELECT RESELID FROM reseller ORDER BY RESELID";
      if (($rs=$db->Execute($query))!==false) {
         while ($o1=$rs->FetchNextObject()) {
            $ris[]=$o1->RESELID;
         }
         $rs->Close();
      }
   }

 	do {
      if ($db===false)  
         break;

      $p1=$p2=false;

      $query="SELECT PNAME, PVALUE FROM agent_main WHERE AGENTID=0 AND (PNAME='XTD_P1' OR PNAME='XTD_P2')";
    	if (($rs=$db->Execute($query))===false) {
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
            break;
      }
      while ($o1=$rs->FetchNextObject()) {
         $db->verify_8($o1->PVALUE);
         
         if (strcmp($o1->PNAME,'XTD_P1')==0)
            $p1=$o1->PVALUE; // date (YYYYMMDDhhmmss)
         else if (strcmp($o1->PNAME,'XTD_P2')==0)
            $p2=$o1->PVALUE; // license value
      }
      $rs->Close();

      if ($p1===false || $p2===false)
         break;

      $dt=3600;
      if (isset($_REQUEST['RESELID']) && ($j=array_search($_REQUEST['RESELID'], $ris))!==false) {
         $dt += $j*5;
      }
      $d1s=date('YmdHis', time()-$dt ); // now - (1 hour + ...) back
      if ($d1s<=$p1) { // ok
         $ret=array();
         $rex=explode(';',$p2);
         if (empty($rex))
            break;

         foreach ($rex as $re1) {
            // A => Pocket.ERP (Common), B => Restaurant, C => ΑΠΟΓΡΑΦΗ, ...
            $re2=explode('=',$re1);
            if (count($re2)<2)
               continue;

            $ret[ $re2[0] ]=(int)$re2[1];
      	}
      	if (!empty($ret)) {
      	   return $ret;
      	}
      }

 	} while (false);

	$tempfile = tempnam ("C:\\tmp", "hasp_");
	$ret=false;

   do {
      if (!$is_apache) {
         if (($obj=new COM('WScript.Shell'))==null) {
            echo "<h6>COM failed!</h6>\n";
            break;
         }
      }
      
      // Run NEW hasp and wait to finish
      $execs=array('hasprd.exe', 'rockey2.exe');
      foreach ($execs as $exec1) {
         @unlink($tempfile);
         if (!empty($_SERVER['WINDIR'])) {
            $cmd=$_SERVER['WINDIR']."\\system32\\$exec1";
         }
         else {
            $cmd=$exec1;
         }
         if (!file_exists($cmd)) {
            continue;
         }
         
         $cmd .= " 523 101 2 ".$tempfile;
         
         if ($is_apache) {
            @exec($cmd);
         }
         else {
            @$obj->Run($cmd,1,true);
         }

         if (($fp=@fopen($tempfile,"r"))!==false) {
	  		   $rnew=&fread_new_hasp($fp);
			   fclose($fp);

			   foreach ($rnew as $rn1) {
			      apply_hasp($db,$ret,$rn1);
			   } 
		   }

		} // foreach ($execs...)

   } while(false);

   $obj=null;
   @unlink($tempfile);

 	if ($ret===false && $db!==false) {
      $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='RANDHASP' ";
      if (($rs=$db->Execute($query))===false) {
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
         return false;
      }
      $row=$rs->FetchRow();
      $rs->Close();
      if ($row===false)
         return false;
         
      apply_hasp($db,$ret,$db->verify_8($row[0]));
   }

   // Save answer
 	$rs='';
 	if (!empty($ret)) {
    	foreach ($ret as $k=>$v) {
         $rs .= $k.'='.$v.';';
      }
   }

   if ($db!==false) {
      $prim=array('AGENTID', 'PNAME');
      $data=array('AGENTID'=>0, 'PNAME'=>'XTD_P1', 'PVALUE'=>date('YmdHis') );
      if (!ReplaceEx($db,'agent_main',$data,$prim)) {
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
      }
      else {
         $data=array('AGENTID'=>0, 'PNAME'=>'XTD_P2', 'PVALUE'=>$rs );
         ReplaceEx($db,'agent_main',$data,$prim);
      }
   }

   return $ret;
}
//--------------------------------------
function parse_cmd_line()
{
	$ar1=array();
   $n=(int)@$GLOBALS['argc'];
   for ($i=1;$i<$n;$i++) {
      $ar1[]=@$GLOBALS['argv'][$i];
   }
   if (!empty($ar1)) {
      /*
      Parses str as if it were the query string passed via a URL and sets
      variables in the current scope. If the second parameter arr is present,
      variables are stored in this variable as array elements instead, completely
      resetting this var. contents.
      */
      parse_str( implode('&',$ar1), $_REQUEST );
   }
}
//--------------------------------------
class cJSON
{
   var $error;
   var $fields;
   var $rows;
   var $errorEx;
   var $fieldsEx;
   var $rowsEx;

   function cJSON()
   {
      $this->error=false;
      $this->fields=array();
      $this->rows=array();

      $this->errorEx=array();
      $this->fieldsEx=array(); // array of arrays
      $this->rowsEx=array(); // array of arrays
   }

   function print_object($k,$j)
   {
      $outs='{"Dummy":"nodata"';

      if ($k<0) {
         $n=count($this->fields);

         if ($n==0) {
            foreach ($this->rows[$j] as $k1=>$s1) {
               $outs .= ',';
               $s1=str_replace ( "\r", '\r', $s1);
               $s1=str_replace ( "\n", '\n', $s1);
               $s1=str_replace ( "\t", '\t', $s1);
               $outs .= "\"$k1\":\"".addslashes($s1)."\"";
            }
         }
         else {
            for ($i=0;$i<$n;$i++) {
               $outs .= ', ';
               $s1=$this->rows[$j][$i];
               // mixed str_replace ( mixed $search , mixed $replace , mixed $subject [, int &$count ] )
               $s1=str_replace ( "\r", '\r', $s1);
               $s1=str_replace ( "\n", '\n', $s1);
               $s1=str_replace ( "\t", '\t', $s1);
               $outs .= "\"".$this->fields[$i]."\":\"".addslashes($s1)."\"";
            }
         }
      }
      else { // $k>=0
         $n=count($this->fieldsEx[$k]);

         for ($i=0;$i<$n;$i++) {
            $outs .= ', ';
            $s1=$this->rowsEx[$k][$j][$i];
            $s1=str_replace ( "\r", '\r', $s1);
            $s1=str_replace ( "\n", '\n', $s1);
            $s1=str_replace ( "\t", '\t', $s1);
            $outs .= "\"".$this->fieldsEx[$k][$i]."\":\"".addslashes($s1)."\"";
         }
      }

      $outs.='}';

      return $outs;
   }

   function print_self()
   {
      $rets="[{\"error\":\"".addslashes(myhtml($this->error))."\",\"data\":[";

      $n=count($this->rows);
      for ($i=0;$i<$n;$i++) {
         if ($i>0) {
            $rets .= ", ";
         }
         // print rows[i] as an object
         $rets .= $this->print_object(-1,$i);
      }
      $rets .= "]}";

      $n2=count($this->errorEx);
      for ($k=0;$k<$n2;$k++) {
         $rets .= ",{\"error\":\"".addslashes(myhtml($this->errorEx[$k]))."\",\"data\":[";

         if (array_key_exists($k, $this->rowsEx)) {         
            $n=count($this->rowsEx[$k]);
         }
         else {
            $n=0;
         }
         for ($i=0;$i<$n;$i++) {
            if ($i>0)
               $rets .= ", ";

            // print rows[i] as an object
            $rets .= $this->print_object($k,$i);
         }
         $rets .= "]}";
      }

      $rets .= "]";

      return $rets;
   }
}
//--------------------------------------
class cTABLE
{
   function __construct()
   {
      echo "<table>";
   }
   
   function __destruct()
   {
      echo "</table>";
   }
   
   function row($ar1)
   {
      echo "<tr>";
      
      $n=count($ar1);
      for ($i=0;$i<$n;$i++) {
         echo "<td>".myhtml($ar1[$i])."</td>";
      }
      
      echo "</tr>";
   } 
}
//--------------------------------------
class cPHP
{
   var $error;
   var $fields;
   var $rows;
   var $errorEx;
   var $fieldsEx;
   var $rowsEx;

   function cPHP()
   {
      $this->error=false;
      $this->fields=array();
      $this->rows=array();

      $this->errorEx=array();
      $this->fieldsEx=array(); // array of arrays
      $this->rowsEx=array(); // array of arrays
   }

   function print_object($k,$j)
   {
      $outs='array(';

      if ($k<0) {
         $n=count($this->fields);

         for ($i=0;$i<$n;$i++) {
            if ($i>0) $outs.=', ';
            $s1=$this->rows[$j][$i];
            $s1=str_replace ( "\r", "\\r", $s1);
            $s1=str_replace ( "\n", "\\n", $s1);
            $s1=str_replace ( "\t", "\\t", $s1);
            $outs .= "'".$this->fields[$i]."'=>'".addslashes($s1)."'";
         }
      }
      else { // $k>=0
         $n=count($this->fieldsEx[$k]);

         for ($i=0;$i<$n;$i++) {
            if ($i>0) $outs.=', ';
            $s1=$this->rowsEx[$k][$j][$i];
            $s1=str_replace ( "\r", "\\r", $s1);
            $s1=str_replace ( "\n", "\\n", $s1);
            $s1=str_replace ( "\t", "\\t", $s1);
            $outs .= "'".$this->fieldsEx[$k][$i]."'=>'".addslashes($s1)."'";
         }
      }

      $outs.=")\n";

      return $outs;
   }

   function print_self()
   {
      $rets="<?php \$xret=array( 'error'=>'".addslashes(myhtml($this->error))."', 'data'=>array(\n";

      $n=count($this->rows);
      for ($i=0;$i<$n;$i++) {
         if ($i>0)
            $rets .= ", ";

         // print rows[i] as an object
         $rets .= $this->print_object(-1,$i);
      }
      $rets .= ")";

      // Not tested (16-1-2007)
      $n2=count($this->errorEx);
      for ($k=0;$k<$n2;$k++) {
         $rets .= ", 'error'=>'".addslashes(myhtml($this->errorEx[$k]))."', 'data'=>(";

         $n=count($this->rowsEx[$k]);
         for ($i=0;$i<$n;$i++) {
            if ($i>0)
               $rets .= ", ";

            // print rows[i] as an object
            $rets .= $this->print_object($k,$i);
         }
         $rets .= ")}";
      }

      $rets .= ") ?".">";

      echo $rets;
   }
}
//--------------------------------------
function load_session_data(&$db)
{
   //if (strcasecmp(PHP_OS,'WINNT')==0)
   return;

   return;
   // OLD CODE:
   // Though primary key is APPLI+SESSID, SESSID should be enough to provide appropriate data (17-5-2007)
   $query="SELECT SEDATA FROM ishop_session_ctl WHERE SESSID=?";
   $data=array( session_id() );
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return;
   }
   if ($row=$rs->FetchRow())  {
      $ss2=unserialize($db->verify_8($row[0]));
      if (is_array($ss2)) {
         $_SESSION=array_merge($_SESSION, $ss2 );
      }
   }
   $rs->Close();
}
//--------------------------------------
function save_session_data(&$db)
{
   //if (strcasecmp(PHP_OS,'WINNT')==0)
   return;

   // Though primary key is APPLI+SESSID, SESSID should be enough to provide appropriate data (17-5-2007)
   $query="UPDATE ishop_session_ctl SET SEDATA=? WHERE SESSID=?";
   $s2=serialize($_SESSION);
   $data=array($s2, session_id() );
   if (!$db->Execute($query,$data)) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return;
   }
}
//--------------------------------------
function detailLogFlash()
{
   if (!isset($GLOBALS['logentries']))
      return;

   $s1=session_save_path();
   $l=strlen($s1);
   if ($l>0 && $s1{$l-1}!="\\") {
      $s1 .= "\\";
   }
   $s1 .= "inca.log";

   if (($fp=@fopen($s1,"a+t"))===false)
      return;

   if (flock($fp, LOCK_SH)) {
      foreach ($GLOBALS['logentries'] as $e1) {
         fwrite($fp, $e1[0].' '.$_SERVER['PHP_SELF'].' '.$e1[1]."\n" );
      }
   }

   fclose($fp);
}
//--------------------------------------
function detailLog($a)
{
   static $registered=false;

   if (!$registered) {
      register_shutdown_function('detailLogFlash');
      $registered=true;
   }

   $d1=date('Y-m-d H:i:s');
   $ar1=explode(' ',microtime()); // ms as sec, sec
   if (!isset($GLOBALS['logentries']))
      $GLOBALS['logentries']=array();

   if (is_array($a)) {
      $s2='';
      foreach ($a as $k=>$v) {
         $s2 .= ' '.$k.'='.$v;
      }
   }
   else {
      $s2=$a;
   }
   $GLOBALS['logentries'][]=array( $d1.' '.$ar1[0], strtr($s2,"\n"," ") );
}
//--------------------------------------
function log_save_input(&$db, $key)
{
   // Read parameters
   $ar1=array();
   $query="SELECT PNAME, PVALUE FROM agent_main WHERE AGENTID=0 AND (PNAME='KEEP_LOG' OR PNAME=?)";
   $data=array($key);
   if (($rs=$db->Execute($query,$data))!==false) {
      while ($o1=$rs->FetchNextObject()) {
         $ar1[$o1->PNAME] = $db->verify_8($o1->PVALUE);
      }
      $rs->Close();
   }

   // Clear old records
   if (($n=@$ar1['KEEP_LOG'])>0) {
      $today=getdate();
      $ds1=date('Ymd', mktime ( 0,0,0, $today['mon'], $today['mday'] - $n, $today['year']));
      $query="DELETE FROM ishop_cedata WHERE LOGTIME < ?";
      $data=array($ds1);
      $db->Execute($query,$data);
   }

   // New entry
   if ((int)@$ar1[$key]>0) {
      // Make input data
      $datain=serialize($_REQUEST);
      $query="INSERT INTO ishop_cedata (LOGTIME, LOGPROG, REMOTEADDR, DATAIN) VALUES(NOW(),?,?,?)";
      $data=array( $_SERVER['PHP_SELF'], @$_SERVER['REMOTE_ADDR'], $datain );
      if (!$db->Execute($query,$data))
         return false;
      else
         return $db->Insert_ID();
   }
   else
      return false;
}
//--------------------------------------
function log_save_output(&$db, $iid, $buf, $szout=false)           
{
   if ($db!==false && $iid!==false) {
      if ($szout===false) {
         $szout=strlen($buf);
      }
      $query="UPDATE ishop_cedata SET RETTIME=NOW(), DATAOUT=?, OUTSIZE=? WHERE LOGID=?";
      $data=array($buf, $szout, $iid);
      $db->Execute($query,$data);
	}

	return $buf;
}
//--------------------------------------
function encode_email_body($src)
{
   $rets='';
   
   $lilen=0;
   $l=strlen($src);
   for ($i=0;$i<$l;$i++) {
      $x=ord($src{$i});
      if (($x>=33 && $x<=60) || ($x>=62 && $x<=126)) {
         $rets .= $src{$i};
         ++$lilen;
      }
      else {
         $rets .= sprintf("=%02X",$x);
         $lilen += 3;
      }
      
      if ($lilen>=71) { 
         $rets .= "=\r\n";
         $lilen=0;
      }
   }
   
   return $rets;
}
//--------------------------------------
function encode_email_subject($in_str, $charset)
{
   $out_str = $in_str;

   if ($out_str && $charset) {

      // define start delimimter, end delimiter and spacer
      $end = "?=";
      $start = "=?" . $charset . "?B?";
      $spacer = $end . "\r\n " . $start;

      // determine length of encoded text within chunks
      // and ensure length is even
      $length = 74 - strlen($start) - strlen($end);
      $length = floor($length/2) * 2;
      
      if (function_exists('mb_strlen') && strcasecmp($charset,'utf-8')==0) {
         //mb_internal_encoding("UTF-8");
         $out_str = '';
         $l=mb_strlen($in_str);
         for ($i=0;$i<$l;$i+=$length/2) {
            if ($i>0) {
               $out_str .= $spacer; 
            }
            $out_str .= base64_encode(mb_substr($in_str,$i,$length/2));
         }
      }
      else {
         // encode the string and split it into chunks
         // with spacers after each chunk
         $out_str = base64_encode($out_str);
         $out_str = chunk_split($out_str, $length, $spacer);
      }

      // remove trailing spacer and
      // add start and end delimiters
      $spacer = preg_quote($spacer);
      $out_str = preg_replace("/" . $spacer . "$/", "", $out_str);
      $out_str = $start . $out_str . $end;
   }
   
   return $out_str;
}
//--------------------------------------
function is_all_digits($ulogin)
{
   $l=strlen($ulogin);
   
   $a=ord('0');
   $b=ord('9');
   for ($i=0;$i<$l;$i++) {
      if (ord($ulogin{$i})<$a || ord($ulogin{$i})>$b)
         return false;
   }
   return true;
}
//--------------------------------------
function ExcludeTrailingPathUrl( $str1 )
{
   $s1=strtr($str1, '\\', '/');
   $l=strlen($s1);
   if ($l>0 && $s1{$l-1}=='/')
      $s2=substr($s1,0,$l-1);
   else
      $s2=$s1;

   return $s2;
}
//--------------------------------------
function IncludeTrailingPathDlm( $str1 )
{
   $s1=strtr($str1, '/', FSEP);
   $l=strlen($s1);
   if ($l>0 && $s1{$l-1}!=FSEP)
      $s1 .= FSEP;
      
   return $s1;
}
//--------------------------------------
function ExcludeTrailingPathDlm( $str1 )
{
   $s1=strtr($str1, '/', FSEP);
   $l=strlen($s1);
   if ($l>0 && $s1{$l-1}==FSEP)
      $s2=substr($s1,0,$l-1);
   else
      $s2=$s1;

   return $s2;
}
//--------------------------------------
function array_toLower(&$val,$key)
{
   $val=strtolower($val);
}
//--------------------------------------
function extern_pconnect(&$db, $agentid, $ext_id)
{
   return extern_connect($db, $agentid, $ext_id, true);
}
//--------------------------------------
function extern_connect(&$db, $agentid, $ext_id=false, $p=false)
{
   if ($ext_id===false) {
      $query="SELECT PVALUE FROM agent_main WHERE AGENTID=? AND PNAME='EXT_ID' ";
      $data=array($agentid);
      if (($rs=$db->Execute($query,$data))===false) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         return false;
      }
      $row=$rs->FetchRow();
      $rs->Close();
      if ($row===false) {
         return false;
      }    
      $ext_id=(int)$row[0];
   }
   
   $conn=array( 'DATASOURCE'=>false, 'CATALOG'=>false, 'USERID'=>false, 'PWD'=>false );
      
   $query="SELECT PNAME,PVALUE FROM agent_main WHERE AGENTID=?
      AND PNAME IN ('EXT${ext_id}_DATASOURCE', 'EXT${ext_id}_CATALOG', 'EXT${ext_id}_USERID', 'EXT${ext_id}_PWD')";
   $data=array($agentid);
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   $k1="EXT${ext_id}_";
   $l=strlen($k1);
   while ($o1=$rs->FetchNextObject()) {
      $conn[substr($o1->PNAME,$l)] = $db->verify_8($o1->PVALUE);
   }
   $rs->Close();

   $db_ext = &ADONewConnection('ado_mssql');
   if ($p)
      $bok=$db_ext->PConnect( $conn['DATASOURCE'], $conn['USERID'], $conn['PWD'], $conn['CATALOG']);
   else
      $bok=$db_ext->Connect( $conn['DATASOURCE'], $conn['USERID'], $conn['PWD'], $conn['CATALOG']);
      
   if (!$bok) {
      $msg='External database connection failed: '.$db_ext->ErrorMsg();
      echo "<h6>$msg</h6>";
	   return false;
   }
   $ADODB_FETCH_MODE = ADODB_FETCH_NUM;
   
   return $db_ext;
}
//--------------------------------------
function encode_decode_data($todo, $datain)
{
   static $rand=false;
   //$key=LICKEY;

   switch ($todo) 
   {
   case 1:
      //
      // Encode
      //
      $key=array();
      $dataout='';
      for ($i=0;$i<32;$i++) {
         $x=mt_rand(1,255);
         $key[] = $x;
         $dataout .= sprintf("%02x",$x);
      }
      
      $n=strlen(rtrim($datain)); 
      for ($i=0, $j=0; $i<$n; $i++) {
         $x = ord($datain{$i}) ^ $key[$j];
         $dataout .= sprintf("%02x",$x);
         
         if (++$j >= 32)
            $j=0;
      }
      break;
   case 2:
      //
      // Decode
      //
      $key=array();
      for ($i=0; $i<64; $i+=2) {
         sscanf(substr($datain,$i,2), "%x", $x);
         $key[] = $x;
      }
      
      $dataout='';
      $n=rtrim(strlen($datain));
      for ($i=64, $j=0; $i<$n; $i+=2) {
         sscanf(substr($datain,$i,2), "%x", $x);
         $y= $x ^ $key[$j];
         $dataout .= chr($y);
            
         if (++$j >= 32)
            $j=0;
      }
      break;
   }
      
   return $dataout;
}
//--------------------------------------
function showMemUsage()
{
   if (function_exists('memory_get_usage')) {
      $mu=memory_get_usage(true);
      echo number_format($mu);
   }
   else {
      echo '0';
   }
}
//--------------------------------------
function startsWith($needle, $str)
{
   $l=mb_strlen($needle);
   return (mb_substr($str,0,$l)===$needle);
}
//--------------------------------------
/*
 * @package Habari
 *
 */

/*
 * Habari MultiByte Class
 *
 * Provides multibyte character set services,
 * a necessity since all of Habari's internal string
 * manipulations are done in UTF-8. Currently
 * this class is a wrapper around mbstring functions.
 *
 */
class MultiByte
{

  const USE_MBSTRING = 1;

  /*
  * @var $hab_enc String holding the current encoding the class is using
  */
  static $hab_enc = 'UTF-8';
  /*
  * @var $use_library Integer denoting the current multibyte
  * library the class is using
  */
  private static $use_library = self::USE_MBSTRING;

  private function __construct()
  {
  }

  /*
  * function hab_encoding
  *
  * Sets and returns the internal encoding.
  *
  * @param $use_enc string. The encoding to be used
  *
  * @return string. If $enc is null, returns the current
  * encoding. If $enc is not null, returns the old encoding
  */
  public static function hab_encoding( $use_enc = null )
  {
    if ( $use_enc === null ) {
      return self::$hab_enc;
    }
    else {
      $old_enc = self::$hab_enc;
      self::$hab_enc = $use_enc;
      return $old_enc;
    }
  }

  /*
  * function library
  *
  * Sets and returns the multibyte library being used internally
  *
  * @param $int The new library to use. One of the self::USE_* constants, null to simply return, or false to disable and use native non-multibyte-safe PHP methods.
  *
  * @return mixed  If $new_library is null, returns the current library
  * being used. If $new_library has a valid value, returns the old library,
  * else returns false.
  */
  public static function library( $new_library = null )
  {
    if ( $new_library === null ) {
      return self::$use_library;
    }
    else if ( $new_library === self::USE_MBSTRING ) {
      $old_library = self::$use_library;
      self::$use_library = $new_library;
      return $old_library;

    }
    else if ( $new_library === false ) {
      $old_library = self::$use_library;
      self::$use_library = $new_library;
      return $old_library;
    }
    else {
      return false;
    }
  }

  /*
  * function convert_encoding
  *
  * Converts a string's encoding to a new encoding
  *
  * @param $str string. The string who's encoding is being changed.
  * @param $use_enc string. The encoding to convert to. If not set,
  * the internal encoding will be used.
  * @param $from_enc string. encoding before conversion. If not set,
  * encoding is detected automatically.
  *
  * @return mixed  The  source string in the new encoding or boolean false.
  */
  public static function convert_encoding( $str, $use_enc = null, $from_enc = null )
  {
    $ret = false;

    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      if ( $from_enc == null ) {
        $from_enc = MultiByte::detect_encoding( $str );
      }
      $ret = mb_convert_encoding( $str, $enc, $from_enc );
    }

    return $ret;
  }

  /*
  * function detect_encoding
  *
  * Detects the encoding being used for a string
  *
  * @param $str string. The string who's encoding is being detected
  *
  * @return mixed The  source string's detected encoding, or boolean false.
  */
  public static function detect_encoding( $str )
  {
    $enc = false;

    if ( self::$use_library == self::USE_MBSTRING ) {
      // get original detection order
      $old_order = mb_detect_order();
      // make sure  ISO-8859-1 is included
      mb_detect_order( array( 'ASCII', 'JIS', 'UTF-8', 'ISO-8859-1', 'EUC-JP', 'SJIS' ) );
      //detect the encoding . the detected encoding may be wrong, but it's better than guessing
      $enc = mb_detect_encoding( $str );
      // reset detection order
      mb_detect_order( $old_order );
    }

    return $enc;
  }

  /*
  * function substr
  *
  * Get a section of a string
  *
  * @param $str string. The original string
  * @param $begin. integer. The beginning character of the string to return.
  * @param $len integer. How long the returned string should be. If $len is
  * not set, the section of the string from $begin to the end of the string is
  * returned.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return mixed The  section of the source string requested in the encoding requested or false.
  * If $len is not set, returns substring from $begin to end of string.
  *
  */
  public static function substr( $str, $begin, $len = null, $use_enc = null )
  {
    $ret = false;

    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      if ( ! isset( $len ) ) {
        $len = MultiByte::strlen( $str ) - $begin;
      }
      $ret = mb_substr( $str, $begin, $len, $enc );
    }
    else {
      $ret = substr( $str, $begin, $len );
    }
    return $ret;
  }

  /*
  * function strlen
  *
  * Gets the length of a string in characters
  *
  * @param $str string. The string who's length is being returned.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return integer. The length in characters of the string, or the length in bytes if a valid
  * multibyte library isn't loaded.
  */
  public static function strlen( $str, $use_enc = null )
  {
    $len = 0;

    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $len = mb_strlen( $str, $enc );
    }
    else {
      $len = strlen( $str );
    }

    return $len;
  }

  /*
  * function strpos
  *
  * Find position of first occurrence of string in a string
  *
  * @param $haysack string. The string being checked.
  * @param $needle. string. The position counted from the beginning of haystack .
  * @param $offset integer. The search offset. If it is not specified, 0 is used.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return mixed The  section of the source string requested in the encoding requested or false.
  * If $len is not set, returns substring from $begin to end of string.
  *
  */
  public static function strpos( $haysack, $needle, $offset = 0, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_strpos( $haysack, $needle, $offset, $enc );
    }
    else {
      $ret = strpos( $haysack, $needle, $offset );
    }
    return $ret;
  }

  /*
  * function stripos
  *
  * Find position of first occurrence of string in a string. Case insensitive.
  *
  * @param $haysack string. The string being checked.
  * @param $needle. string. The position counted from the beginning of haystack .
  * @param $offset integer. The search offset. If it is not specified, 0 is used.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return mixed The  section of the source string requested in the encoding requested or false.
  * If $len is not set, returns substring from $begin to end of string.
  *
  */
  public static function stripos( $haysack, $needle, $offset = 0, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_stripos( $haysack, $needle, $offset, $enc );
    }
    else {
      $ret = stripos( $haysack, $needle, $offset );
    }
    return $ret;
  }

  /*
  * function strrpos
  *
  * Find position of last occurrence of string in a string.
  *
  * @param $haysack string. The string being checked.
  * @param $needle. string. The position counted from the beginning of haystack .
  * @param $offset integer. The search offset. If it is not specified, 0 is used.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return mixed The  section of the source string requested in the encoding requested or false.
  * If $len is not set, returns substring from $begin to end of string.
  *
  */
  public static function strrpos( $haysack, $needle, $offset = 0, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_strrpos( $haysack, $needle, $offset, $enc );
    }
    else {
      $ret = strrpos( $haysack, $needle, $offset );
    }
    return $ret;
  }

  /*
  * function strripos
  *
  * Find position of last occurrence of string in a string. Case insensitive.
  *
  * @param $haysack string. The string being checked.
  * @param $needle. string. The position counted from the beginning of haystack .
  * @param $offset integer. The search offset. If it is not specified, 0 is used.
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return mixed The  section of the source string requested in the encoding requested or false.
  * If $len is not set, returns substring from $begin to end of string.
  *
  */
  public static function strripos( $haysack, $needle, $offset = 0, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_strripos( $haysack, $needle, $offset, $enc );
    }
    else {
      $ret = strripos( $haysack, $needle, $offset );
    }
    return $ret;
  }

  /*
   * function strtolower
   *
   * Converts a multibyte string to lowercase. If a valid multibyte library
  * isn't loaded, strtolower() will be used, which can lead to unexpected results.
   *
   * @param $str string. The string to lowercase
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
   *
   * @return string. The lowercased string.
  */
  public static function strtolower( $str, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_strtolower( $str, $enc );
    }
    else {
      $ret = strtolower( $str );
    }

    return $ret;
  }

  /*
  * function strtoupper
  *
  * Converts a multibyte string to uppercase. If a valid multibyte library
  * isn't loaded, strtoupper() will be used, which can lead to unexpected results.
  *
  * @param $str string. The string to uppercase
  * @param $use_enc string. The encoding to be used. If not set,
  * the internal encoding will be used.
  *
  * @return string. The uppercased string.
  */
  public static function strtoupper( $str, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }

    if ( self::$use_library == self::USE_MBSTRING ) {
      $ret = mb_strtoupper( $str, $enc );
    }
    else {
      $ret = strtoupper( $str );
    }

    return $ret;
  }

  public static function valid_data( $str, $use_enc = null )
  {
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
      return mb_check_encoding( $str, $enc );
    }
    
    return true;
  }
  
  public static function ucfirst ( $str, $use_enc = null )
  {
    
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
      
      // get the first character
      $first = self::substr( $str, 0, 1, $enc );
      
      // uppercase it
      $first = self::strtoupper( $first, $enc );
      
      // get the rest of the characters
      $last = self::substr( $str, 1, null, $enc );
      
      // put them back together
      $ret = $first . $last;
      
    }
    else {
      $ret = ucfirst( $str );
    }
    
    return $ret;
    
  }
  
  public static function lcfirst ( $str, $use_enc = null )
  {
    
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
      
      // get the first character
      $first = self::substr( $str, 0, 1, $enc );
      
      // lowercase it
      $first = self::strtolower( $first, $enc );
      
      // get the rest of the characters
      $last = self::substr( $str, 1, null, $enc );
      
      // put them back together
      $ret = $first . $last;
      
    }
    else {
      
      // lcfirst() is php 5.3+ so we'll emulate it
      $first = substr( $str, 0, 1 );
      $first = strtolower( $first );
      
      $last = substr( $str, 1 );
      
      $ret = $first . $last;
      
    }
    
    return $ret;
    
  }
  

  public static function str_replace ( $search, $replace, $subject, &$count = 0, $use_enc = null )
  {
    
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
    
      // if search is an array and replace is not, we need to make replace an array and pad it to the same number of values as search
      if ( is_array( $search ) && !is_array( $replace ) ) {
        $replace = array_fill( 0, count( $search ), $replace );
      }
      
      // if search is an array and replace is as well, we need to make sure replace has the same number of values - pad it with empty strings
      if ( is_array( $search ) && is_array( $replace ) ) {
        $replace = array_pad( $replace, count( $search ), '' );
      }
      
      // if search is not an array, make it one
      if ( !is_array( $search ) ) {
        $search = array( $search );
      }
      
      // if replace is not an array, make it one
      if ( !is_array( $replace ) ) {
        $replace = array( $replace );
      }
      
      // if subject is an array, recursively call ourselves on each element of it
      if ( is_array( $subject ) ) {
        foreach ( $subject as $k => $v ) {
          $subject[ $k ] = self::str_replace( $search, $replace, $v, $count, $use_enc );
        }
        
        return $subject;
      }
            
      
      
      // now we've got an array of characters and arrays of search / replace characters with the same values - loop and replace them!
      $search_count = count( $search ); // we modify $search, so we can't include it in the condition next
      for ( $i = 0; $i < $search_count; $i++ ) {
        
        // the values we'll match
        $s = array_shift( $search );
        $r = array_shift( $replace );
        
        // to avoid an infinite loop if you're replacing with a value that contains the subject we get the position of each instance first
        $positions = array();
        
        $offset = 0;
        while ( self::strpos( $subject, $s, $offset, $enc ) !== false ) {
          
          // get the position
          $pos = self::strpos( $subject, $s, $offset, $enc );
          
          // add it to the list
          $positions[] = $pos;
          
          // and set the offset to skip over this value
          $offset = $pos + self::strlen( $s, $enc );
          
        }
        
        // if we pick through from the beginning, our positions will change if the replacement string is longer
        // instead, we pick through from the last place
        $positions = array_reverse( $positions );
        
        // now that we've got the position of each one, just loop through that and replace them
        foreach ( $positions as $pos ) {
          
          // pull out the part before the string
          $before = self::substr( $subject, 0, $pos, $enc );
          
          // pull out the part after
          $after = self::substr( $subject, $pos + self::strlen( $s, $enc ), null, $enc );
          
          // now we have the string in two parts without the string we're searching for
          // put it back together with the replacement
          $subject = $before . $r . $after;
          
          // increment our count, a replacement was made
          $count++;
          
        }
        
      }
      
    }
    else {
      
      $subject = str_replace( $search, $replace, $subject, $count );
      
    }
    
    return $subject;
    
  }
  
  public static function str_ireplace( $search, $replace, $subject, &$count = 0, $use_enc = null )
  {
    
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
    
      // if search is an array and replace is not, we need to make replace an array and pad it to the same number of values as search
      if ( is_array( $search ) && !is_array( $replace ) ) {
        $replace = array_fill( 0, count( $search ), $replace );
      }
      
      // if search is an array and replace is as well, we need to make sure replace has the same number of values - pad it with empty strings
      if ( is_array( $search ) && is_array( $replace ) ) {
        $replace = array_pad( $replace, count( $search ), '' );
      }
      
      // if search is not an array, make it one
      if ( !is_array( $search ) ) {
        $search = array( $search );
      }
      
      // if replace is not an array, make it one
      if ( !is_array( $replace ) ) {
        $replace = array( $replace );
      }
      
      // if subject is an array, recursively call ourselves on each element of it
      if ( is_array( $subject ) ) {
        foreach ( $subject as $k => $v ) {
          $subject[ $k ] = self::str_ireplace( $search, $replace, $v, $count, $use_enc );
        }
        
        return $subject;
      }
            
      
      
      $search_count = count( $search ); // we modify $search, so we can't include it in the condition next
      for ( $i = 0; $i < $search_count; $i++ ) {
        
        // the values we'll match
        $s = array_shift( $search );
        $r = array_shift( $replace );
        
        
        // to avoid an infinite loop if you're replacing with a value that contains the subject we get the position of each instance first
        $positions = array();
        
        $offset = 0;
        while ( self::stripos( $subject, $s, $offset, $enc ) !== false ) {
          
          // get the position
          $pos = self::stripos( $subject, $s, $offset, $enc );
          
          // add it to the list
          $positions[] = $pos;
          
          // and set the offset to skip over this value
          $offset = $pos + self::strlen( $s, $enc );
          
        }
        
        // if we pick through from the beginning, our positions will change if the replacement string is longer
        // instead, we pick through from the last place
        $positions = array_reverse( $positions );
        
        // now that we've got the position of each one, just loop through that and replace them
        foreach ( $positions as $pos ) {
          
          // pull out the part before the string
          $before = self::substr( $subject, 0, $pos, $enc );
          
          // pull out the part after
          $after = self::substr( $subject, $pos + self::strlen( $s, $enc ), null, $enc );
          
          // now we have the string in two parts without the string we're searching for
          // put it back together with the replacement
          $subject = $before . $r . $after;
          
          // increment our count, a replacement was made
          $count++;
          
        }
        
      }
      
    }
    else {
      
      $subject = str_ireplace( $search, $replace, $subject, $count );
      
    }
    
    return $subject;
    
  }
  
  public static function ucwords ( $str, $use_enc = null )
  {
    
    $enc = self::$hab_enc;
    if ( $use_enc !== null ) {
      $enc = $use_enc;
    }
    
    if ( self::$use_library == self::USE_MBSTRING ) {
    
      $delimiters = array(
        chr( 32 ),  // space
        chr( 12 ),  // form-feed
        chr( 10 ),  // newline
        chr( 13 ),  // carriage return
        chr( 9 ), // horizontal tab
        chr( 11 ),  // vertical tab
      );
      
      // loop through the delimiters and explode the string by each one
      foreach ( $delimiters as $d ) {
        
        $pieces = explode( $d, $str );
        
        for ( $i = 0; $i < count( $pieces ); $i++ ) {
          
          // capitalize each word
          $pieces[ $i ] = self::ucfirst( $pieces[ $i ], $enc );
          
        }
        
        // put the string back together
        $str = implode( $d, $pieces );
        
      }
    
    }
    else {
      $str = ucwords( $str );
    }
    
    
    return $str;
  }

}
//--------------------------------------
function RemoveHtml($src)
{
   $search = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
                 "'<[\/\!]*?[^<>]*?>'si",           // Strip out html tags
                 "'([\r\n])[\s]+'",                 // Strip out white space
                 "'&(quot|#34);'i",                 // Replace html entities
                 "'&(amp|#38);'i",
                 "'&(lt|#60);'i",
                 "'&(gt|#62);'i",
                 "'&(nbsp|#160);'i",
                 "'&(iexcl|#161);'i",
                 "'&(cent|#162);'i",
                 "'&(pound|#163);'i",
                 "'&(copy|#169);'i",
                 "'&#(\d+);'e");                    // evaluate as php

   $replace = array ("",
                  "",
                  "\\1",
                  "\"",
                  "&",
                  "<",
                  ">",
                  " ",
                  chr(161),
                  chr(162),
                  chr(163),
                  chr(169),
                  "chr(\\1)");

   return preg_replace ($search, $replace, $src);
}
//--------------------------------------
?>
