<?php
include("../lib/ado/adodb.inc.php");
include("../lib/generic.inc.php");
include("../ishop/ishop_all.inc.php");
include("../ishop/ishop.inc.php");

class cS11 
{
   public $s11;
   public $mtype;
   public $location;
   
   function __construct($xs11, $xmtype, $xlocation=false)
   {
      $this->s11 = $xs11;
      $this->mtype = $xmtype;
      $this->location = $xlocation;
   }
}

header("Content-type: text/html; charset=utf-8");
ob_start();

$ret=false; // default
date_default_timezone_set('Europe/Athens');
$dm100=array('EPZ', 'EKX', 'EPT');

$db = &db_open();

$fu=(int)@$_REQUEST['FUNCTION'];

$savelog=false;
$query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='TXC_TEXT_LOG' ";
if (($rs=$db->Execute($query))===false) {
   $fu=9999; // reset to NOOP
}
if ($row=$rs->FetchRow()) {
   $savelog = (bool)$row[0];
}
$rs->Close();

if ($savelog || $fu==9999) {
   print_r($_REQUEST);
   $s1=ob_get_contents(); 
   ob_clean();
   
   save_log("\r\n".date('Y-m-d H:i:s')."\r\n$s1");
}
else {
   ob_end_clean();
}

// RUN program
switch ($fu)
{
case -1:
   check_tables_taxinfo();
   break;
case 0:
   $ret=process_input();
   break;
default:
   echo "Undefined function $fu";
   break;
}

// LOG again
if ($savelog || $fu==9999) {
   $s1=ob_get_clean();
   save_log($s1);
}
else {
   ob_end_clean();
}

if ($ret) {
   echo "OK";
}

$db->Close();
//--------------------------------------
function save_log($s1)
{
   if (($fp=fopen('c:\\tmp\\textinfo.out','ab'))===false) {
      echo "Failed to open output";
      return;
   }
   fwrite($fp, $s1."\r\n");
   fclose($fp);
}
//--------------------------------------
function authenticate_user()
{
   global $db;
   
   if (!isset($_REQUEST['USER']) || !isset($_REQUEST['PWD'])) {
      echo "Authentication failed!";
      return false;
   } 
   
	$query="SELECT AGENTID FROM reseller WHERE RESELID=? AND PASSWD=?";
   $data=array( $_REQUEST['USER'], $_REQUEST['PWD'] );
   if (($rs=$db->Execute($query,$data))===false) {
      echo __LINE__.$db->ErrorMsg();
      return false;
   }
   $o1=$rs->FetchNextObject();
   $rs->Close();
   
   if ($o1===false) {
      // Authenticate user as agent
      $query="SELECT AGENTID FROM agents WHERE LPATH=? AND PASSWD=?";
      $data=array( $_REQUEST['USER'], $_REQUEST['PWD'] );
      if (($rs=$db->Execute($query,$data))===false) {
         echo __LINE__.$db->ErrorMsg();
         return false;
      }
      $o1=$rs->FetchNextObject();
      $rs->Close();
   }
   
   if ($o1===false) {
      // Still not found
      echo "Authentication failed!";
      return false;
   }
   
   return $o1->AGENTID;
}
//--------------------------------------
function process_input()
{
   global $db;
   
   if (($agentid=authenticate_user())===false) {
      return false;
   }
   
   $ret1=true;
   $ret2=true;
   $ret3=true;
   
   $s11=array();
   
   if (!empty($_REQUEST['PCK1'])) {
      $ret1 = process_input1($agentid, $s11);
   }
   
   if (!empty($_REQUEST['PCK2'])) {
      $ret2 = process_input2($agentid, $s11);
   }
      
   if (!empty($_REQUEST['PCK3'])) {
      $ret3 = process_input3($agentid, $s11);
   }
      
   update_eafdss($agentid, $s11);
   
   return ($ret1 && $ret2 && $ret3);
}
//--------------------------------------
function update_eafdss($agentid, $ar_s11)
{
   global $db, $dm100;

   $t1='taxi_eafdss';
   $prim='MS11';
   
   $query="SELECT COUNT(*) FROM $t1 WHERE MS11=?";
   foreach ($ar_s11 as $o11) {
      $nma=0;
      $data=array($o11->s11);
      if (($rs=$db->Execute($query,$data))===false) {
         echo __LINE__.$db->ErrorMsg();
         break;
      }
      if ($row=$rs->FetchRow()) {
         $nma=$row[0];
      }
      $rs->Close();
      
      $data=array(
         'MS11' => $o11->s11,
         'AGENTID' => $agentid,
         'L_PROCID' => $_REQUEST['PROCID'],
         'L_NPROC' => (int)$_REQUEST['NPROC'],
         'L_OS' => $_REQUEST['OS'],
         'L_ARCH' => $_REQUEST['ARCH']
      );
      if (!empty($o11->location)) {
         $data['TXLOCATION'] = $o11->location; 
      }
      
      if ($nma==0) {
         if ($o11->mtype==0) { // unknown
            $s3=substr($o11->s11,0,3);
            $mtype = in_array($s3,$dm100)?1:0;
         }
         else {
            $mtype = $o11->mtype;
         }
         $data['MACHINETYPE'] = $mtype;
         if (!InsertEx($db,$t1,$data)) {
            echo __LINE__.$db->ErrorMsg();
         }
      }
      else {
         if (!ReplaceEx($db, $t1, $data, $prim)) {
            echo __LINE__.$db->ErrorMsg();
         }
      }
   }
}
//--------------------------------------
function process_input1($agentid, &$s11)
{
   global $db;
   
   $ret=true;
   $t1='taxi_log';
   $records=array();
   
   $ar1=explode("\n", $_REQUEST['PCK1']);
   $n=count($ar1);
   for ($i=0;$i<$n;$i++) {
      $ar2=explode("\t", trim($ar1[$i]));
      if (count($ar2)<4)
         continue;
         
      $key=$ar2[3].':'.$ar2[1]; // S11 + rec.type
      if (array_key_exists($key,$records)) {
         $records[$key][0] = $records[$key][0].", ".$ar2[0]." (".$ar2[1].")";
      }
      else {
         $ar2[0] = $ar2[0]." (".$ar2[1].")";
         $records[$key]=$ar2;
      }
   }
   ksort($records);
   
   $lastS11='';
   foreach ($records as $ar2) {
      if ($ar2[3]==$lastS11)
         continue;
         
      $lastS11=$ar2[3];

      $data=array(
         'AGENTID' => $agentid,
         'RECTYPE' => 1, 
         'TXVERSION' => $_REQUEST['X1'], 
         'MEM_USG' => (int)$_REQUEST['MEM'],             
         'CPU_USG' => (int)$_REQUEST['CPU'],
         'CLOGIC' => $_REQUEST['LOGIC'],
         'SENDERIP' => $_SERVER['REMOTE_ADDR'], 
         'EAFDSSPORT' => $ar2[2], 
         'MS11' => $ar2[3], 
         'MVENDOR' => $ar2[4], 
         'MMODEL' => $ar2[5], 
         'MVERSION' => $ar2[6], 
         'LASTZNR' => $ar2[10],  
         'MPROGRESSIVE' => $ar2[11], 
         'MDAILY' => $ar2[12],
         'MTIMEPASSED' => $ar2[13],
         'TXSPEC' => $ar2[0]
      );
      
      $s11[] = new cS11($data['MS11'], 1, $_REQUEST['X2']);  
      
      if (!empty($ar2[7]) && !startsWith('0000', $ar2[7])) 
        $data['OPENTIME'] = $ar2[7]; // DATETIME
        
      if (!empty($ar2[8]) && !startsWith('0000', $ar2[8])) 
        $data['FIRSTSIGNINZ'] = $ar2[8]; // DATETIME
        
      if (!empty($ar2[9]) && !startsWith('0000', $ar2[9])) 
        $data['LASTZTAKEN'] = $ar2[9]; // DATETIME
      
      if (!empty($ar2[14]) && !startsWith('0000', $ar2[14])) 
         $data['MLASTOK'] = $ar2[14]; // DATETIME
         
      if (!empty($ar2[15]) && !startsWith('0000', $ar2[15]))
         $data['MLASTFAIL'] = $ar2[15]; // DATETIME
       
      if (!empty($ar2[16]))   
         $data['MLASTERROR'] = $ar2[16];
         
      if (!empty($ar2[17])) 
         $data['MLASTHARDST'] = $ar2[17];
         
      if (!empty($ar2[18])) 
         $data['MLASTAPPST'] = $ar2[18];

      if (!InsertEx($db,$t1,$data)) {
         echo __LINE__.$db->ErrorMsg();
         print_r($data);
         $ret=false;
      }
   }
   
   return $ret;
}
//--------------------------------------
function process_input2($agentid, &$s11)
{
   global $db;
   
   $ret=true;
   $t1='taxi_log';
   $records=array();
   
   $ar1=explode("\n", $_REQUEST['PCK2']);
   $n=count($ar1);
   for ($i=0;$i<$n;$i++) {
      $ar2=explode("\t", trim($ar1[$i]));
      if (count($ar2)<6)
         continue;
         
      $records[]=$ar2;
   }
   
   // $ar2:
   //   0          1           2         3         4         5      6        7 
   // MS11  FirstSignInZ  lastZdate  lastZno  Progressive  Daily  Port  MachineType
   
   foreach ($records as $ar2) {
      $data=array(
         'AGENTID' => $agentid,
         'RECTYPE' => 2, 
         'TXVERSION' => (string)@$_REQUEST['X1'], // if defined 
         'MEM_USG' => (int)$_REQUEST['MEM'],             
         'CPU_USG' => (int)$_REQUEST['CPU'],
         'CLOGIC' => $_REQUEST['LOGIC'],
         'SENDERIP' => $_SERVER['REMOTE_ADDR'],
         'MS11' => $ar2[0],
         'LASTZNR' => $ar2[3],  
         'MPROGRESSIVE' => $ar2[4], 
         'MDAILY' => $ar2[5]
      );
      
      // version 2 of client service 
      if (count($ar2)>=7) {
         $data['EAFDSSPORT'] = $ar2[6]; 
      }
      
      $s11[] = new cS11($data['MS11'], 0, $_REQUEST['X2']);
      
      if (!startsWith('0000', $ar2[1]) && !startsWith('9999', $ar2[1])) {
         $data['FIRSTSIGNINZ'] = $ar2[1]; // DATETIME or '9999-99-99' (error=no info)
      }
      
      if (!startsWith('0000', $ar2[2]) && !startsWith('9999', $ar2[2])) {
         $data['LASTZTAKEN'] = $ar2[2]; // DATETIME or '9999-99-99' (error=no info)
      }
      
      if (!InsertEx($db,$t1,$data)) {
         echo __LINE__.$db->ErrorMsg();
         print_r($data);
         $ret=false;
      }
   }
   
   return $ret;
}
//--------------------------------------
function process_input3($agentid, &$s11)
{
   global $db;
   
   $ret=true;
   $t1='taxi_log';
   $records=array();
   $ar1=explode("\n", $_REQUEST['PCK3']);
   $n=count($ar1);
   for ($i=0;$i<$n;$i++) {
      $ar2=explode("\t", trim($ar1[$i]));
      if (count($ar2)<7)
         continue;
         
      $records[]=$ar2;
   }
   //save_log( print_r($records,true) );
   
   /* $ar2:
      AREAID         INT, -- ΥΠΟΚΑΤ                   0
      MS11           VARCHAR,                         1
      LASTZTAKEN     DATETIME,                        2
      LASTZNR        INT,                             3
      POSRECEIPTS    INT, -- ΑΠΟΔΕΙΞΕΙΣ ΕΣΟΔΩΝ        4         
      POSFPACHANGE   INT, -- ΑΛΛΑΓΕΣ ΤΙΜΩΝ ΦΠΑ        5             
      POSHDRCHANGE   INT, -- ΑΛΛΑΓΕΣ ΛΕΚΤΙΚΟΥ         6              
      POSCMOSERR     INT, -- ΒΛΑΒΕΣ CMOS              7              
      POSCFERR       INT, -- ΒΛΑΒΗ ΕΠΙΚΟΙΝΩΝΙΑΣ CF    8              
      POSPRNDETACH   INT, -- ΑΠΟΣΥΝΔΕΣΕΙΣ ΕΚΤΥΠΩΤΗ    9              
      POSTECHOPEN    INT, -- ΕΠΕΜΒΑΣΕΙΣ ΤΕΧΝΙΚΟΥ      10
      POSDIMEDETACH  INT, -- ΑΠΟΣΥΝΔΕΣΕΙΣ ΔΗΜΕ        11
   */
   
   foreach ($records as $ar2) {
      $data=array(
         'AGENTID' => $agentid,
         'RECTYPE' => 3, // POS type 
         'MEM_USG' => (int)$_REQUEST['MEM'],             
         'CPU_USG' => (int)$_REQUEST['CPU'],
         'CLOGIC' => $_REQUEST['LOGIC'],
         'SENDERIP' => $_SERVER['REMOTE_ADDR'],
         'POSAREAID' => (int)$ar2[0],
         'MS11' => $ar2[1],
         'LASTZNR' => $ar2[3],
         'POSRECEIPTS' => $ar2[4],  // ΑΠΟΔΕΙΞΕΙΣ ΕΣΟΔΩΝ                 
         'POSFPACHANGE' => $ar2[5], // ΑΛΛΑΓΕΣ ΤΙΜΩΝ ΦΠΑ                     
         'POSHDRCHANGE' => $ar2[6], // ΑΛΛΑΓΕΣ ΛΕΚΤΙΚΟΥ
         'POSCMOSERR' => (int)@$ar2[7],   // ΒΛΑΒΕΣ CMOS                            
         'POSCFERR' => (int)@$ar2[8],     // ΒΛΑΒΗ ΕΠΙΚΟΙΝΩΝΙΑΣ CF                  
         'POSPRNDETACH' => (int)@$ar2[9], // ΑΠΟΣΥΝΔΕΣΕΙΣ ΕΚΤΥΠΩΤΗ                  
         'POSTECHOPEN' => (int)@$ar2[10],  // ΕΠΕΜΒΑΣΕΙΣ ΤΕΧΝΙΚΟΥ  
         'POSDIMEDETACH' => (int)@$ar2[11] // ΑΠΟΣΥΝΔΕΣΕΙΣ ΔΗΜΕ  
      );
      
      $s11[] = new cS11($data['MS11'], 3);
      
      if (!startsWith('0000', $ar2[2]) && !startsWith('9999', $ar2[2])) {
         $data['LASTZTAKEN'] = $ar2[2]; // DATETIME or '9999-99-99' (error=no info)
      }
      
      if (!InsertEx($db,$t1,$data)) {
         echo __LINE__.$db->ErrorMsg();
         print_r($data);
         $ret=false;
      }
   }
   
   return $ret;
}
//--------------------------------------
function check_tables_taxinfo()
{
   global $db;
   include('taxinfo.inc.php'); // include and execute
}
//--------------------------------------
?>